SFS2X = {
    SmartFox: function(e) {
        this._majVersion = 1, this._minVersion = 2, this._subVersion = 0, this._socketEngine = new SFS2X.SocketEngine, this._eventDispatcher = new SFS2X.EventDispatcher, this._lagMonitor = null, this._log = SFS2X.Logger, this._inited = this._isJoining = !1, this._currentZone = null, this._clientDetails = "JavaScript", this.version = this._majVersion + "." + this._minVersion + "." + this._subVersion, this.config = e, this.debug = !1, null != this.config && this.config.debug && (this.debug = !0), this.logger = this._log, this.lastJoinedRoom = this.mySelf = this.buddyManager = this.userManager = this.roomManager = this.sessionToken = null, this._controllers = {}, this._initialize()
    }
}, SmartFox = SFS2X.SmartFox, SFS2X.SmartFox.prototype.addEventListener = function(e, t, s) {
    this._eventDispatcher.addEventListener(e, t, s)
}, SFS2X.SmartFox.prototype.removeEventListener = function(e, t) {
    this._eventDispatcher.removeEventListener(e, t)
}, SFS2X.SmartFox.prototype.setClientDetails = function(e, t) {
    this.isConnected() ? this._log.warn("SetClientDetails must be called before the connection is started") : (this._clientDetails = null != e ? e.replace(":", " ") : "", this._clientDetails += ":", this._clientDetails += null != t ? t.replace(":", " ") : "")
}, SFS2X.SmartFox.prototype.connect = function(e, t, s) {
    if (this.isConnected()) this._log.warn("Already connected");
    else if (this._socketEngine.isConnecting) this._log.warn("A connection attempt is already in progress");
    else {
        var n = null != this.config && null != this.config.host ? this.config.host : null,
            r = null != this.config && null != this.config.port ? this.config.port : null,
            i = null != this.config && this.config.useSSL;
        null != e && (n = e), null != t && (r = t), null != s && (i = s), null == n || 0 == n.length ? this._log.error("Invalid connection host/address") : "number" != typeof r || 0 > r || 65535 < r ? this._log.error("Invalid TCP port") : ("boolean" != typeof i && (i = !1), this._socketEngine.connect(n, r, i))
    }
}, SFS2X.SmartFox.prototype.disconnect = function() {
    this.isConnected() ? (0 < this._socketEngine.reconnectionSeconds && this.send(new SFS2X.Requests.System.ManualDisconnectionRequest), setTimeout((function(e) {
        e._handleClientDisconnection(SFS2X.Utils.ClientDisconnectionReason.MANUAL)
    }), 100, this)) : this._log.info("You are not connected")
}, SFS2X.SmartFox.prototype.enableLagMonitor = function(e, t, s) {
    null == this.mySelf ? this._log.warn("Lag Monitoring requires that you are logged in a Zone; please retry after completing the login process") : (null != this._lagMonitor && this._lagMonitor.destroy(), e && (this._lagMonitor = new SFS2X.Utils.LagMonitor(this, t, s), this._lagMonitor.start()))
}, SFS2X.SmartFox.prototype.isConnected = function() {
    return null != this._socketEngine && this._socketEngine.isConnected
}, SFS2X.SmartFox.prototype.getMaxMessageSize = function() {
    return null != this._socketEngine ? this._socketEngine._maxMessageSize : 0
}, SFS2X.SmartFox.prototype.send = function(e) {
    if (this.isConnected()) {
        if (null != e.validate && null != e.execute) {
            try {
                e.validate(this), e.execute(this)
            } catch (s) {
                if (!(s instanceof SFS2X.Exceptions.SFSValidationError && null != s.getMessage)) throw s;
                if (e = s.getMessage(), null != s.getErrors()) {
                    e = e + ":";
                    for (var t = 0; t < s.getErrors()
                        .length; t++) 1 < s.getErrors()
                        .length && (e += " " + (t + 1) + ")"), e += " " + s.getErrors()[t]
                }
                return this._log.error("Request failed | " + e), !1
            }
            return this.debug && (this._log.info("OUTGOING DATA\n" + SFS2X.DebugHelper.getDump(e.getMessage())), this._log.info("OUT > " + SFS2X.Requests.getRequestNameFromId(e._id))), this._socketEngine.send(e.getMessage()), !0
        }
        this._log.error("An invalid request was passed: " + e), this._log.debug("Object dump:\n" + SFS2X.DebugHelper.getDump(e))
    } else this._log.error("You are not connected. Request cannot be sent: " + SFS2X.Requests.getRequestNameFromId(e._id))
}, SFS2X.SmartFox.prototype.getRoomById = function(e) {
    return this.roomManager.getRoomById(e)
}, SFS2X.SmartFox.prototype.getRoomByName = function(e) {
    return this.roomManager.getRoomByName(e)
}, SFS2X.SmartFox.prototype.getRoomList = function() {
    return this.roomManager.getRoomList()
}, SFS2X.SmartFox.prototype.getRoomListFromGroup = function(e) {
    return this.roomManager.getRoomListFromGroup(e)
}, SFS2X.SmartFox.prototype.getJoinedRooms = function() {
    return this.roomManager.getJoinedRooms()
}, SFS2X.SmartFox.prototype._initialize = function() {
    this._inited || (this._socketEngine = new SFS2X.SocketEngine(this), this._socketEngine.addEventListener(SFS2X.SocketEvent.CONNECT, this._onSocketConnect, this), this._socketEngine.addEventListener(SFS2X.SocketEvent.DISCONNECT, this._onSocketDisconnect, this), this._socketEngine.addEventListener(SFS2X.SocketEvent.DATA, this._onSocketData, this), this._socketEngine.addEventListener(SFS2X.SocketEvent.IOERROR, this._onSocketIOError, this), this._controllers[0] = new SFS2X.Controllers.SystemController(this), this._controllers[1] = new SFS2X.Controllers.ExtensionController(this), this._inited = !0, this._reset())
}, SFS2X.SmartFox.prototype._reset = function(e) {
    null != this.buddyManager && this.buddyManager._clearAll(), this.userManager = new SFS2X.Managers.GlobalUserManager(this), this.roomManager = new SFS2X.Managers.RoomManager(this), this.buddyManager = new SFS2X.Managers.BuddyManager(this), null != this._lagMonitor && this._lagMonitor.destroy(), this._isJoining = !1, this.mySelf = this.lastJoinedRoom = this._currentZone = null, e && (this.sessionToken = null)
}, SFS2X.SmartFox.prototype._dispatchEvent = function(e, t) {
    this._eventDispatcher.dispatchEvent(e, t)
}, SFS2X.SmartFox.prototype._onSocketConnect = function(e) {
    e.success ? (e = new SFS2X.Requests.System.HandshakeRequest(this.version, this._clientDetails, e.isReconnection ? this.sessionToken : null), this.send(e)) : this._dispatchEvent(SFS2X.SFSEvent.CONNECTION, {
        success: !1
    })
}, SFS2X.SmartFox.prototype._onSocketDisconnect = function(e) {
    this._dispatchEvent(SFS2X.SFSEvent.CONNECTION_LOST, {
        reason: e.reason
    }), this._reset(!0)
}, SFS2X.SmartFox.prototype._onSocketData = function(e) {
    this.debug && this._log.info("INCOMING DATA\n" + SFS2X.DebugHelper.getDump(e));
    var t = e[SFS2X.Controllers.CONTROLLER_ID],
        s = e[SFS2X.Controllers.ACTION_ID];
    e = e[SFS2X.Controllers.PARAM_ID];
    null == t ? this._log.error("Message rejected: Controller ID is missing") : null == t ? this._log.error("Message rejected: Action ID missing") : this._controllers[t].handleMessage(e, s)
}, SFS2X.SmartFox.prototype._onSocketIOError = function(e) {
    this._dispatchEvent(SFS2X.SFSEvent.SOCKET_ERROR, {
        message: e
    })
}, SFS2X.SmartFox.prototype._handleHandShake = function(e) {
    var t = e[SFS2X.Controllers.KEY_ERROR_CODE];
    null == t ? (this.sessionToken = e[SFS2X.Requests.System.HandshakeRequest.KEY_SESSION_TOKEN], this._socketEngine._maxMessageSize = e[SFS2X.Requests.System.HandshakeRequest.KEY_MAX_MESSAGE_SIZE], this._socketEngine._isReconnecting ? this._socketEngine._isReconnecting = !1 : this._dispatchEvent(SFS2X.SFSEvent.CONNECTION, {
        success: !0
    })) : (e = {
        success: !1,
        errorMessage: SFS2X.ErrorCodes.getErrorMessage(t, e[SFS2X.Controllers.KEY_ERROR_PARAMS]),
        errorCode: t
    }, this._dispatchEvent(SFS2X.SFSEvent.CONNECTION, e))
}, SFS2X.SmartFox.prototype._handleLogout = function() {
    this._reset(!1)
}, SFS2X.SmartFox.prototype._handleClientDisconnection = function(e) {
    this.isConnected() && this._socketEngine.disconnect(e)
},
function() {
    var e = !1,
        t = /xyz/.test((function() {
            xyz
        })) ? /\b_super\b/ : /.*/;
    this.Class = function() {}, Class.extend = function(s) {
        function n() {
            !e && this.init && this.init.apply(this, arguments)
        }
        var r = this.prototype;
        e = !0;
        var i = new this;
        for (var o in e = !1, s) i[o] = "function" == typeof s[o] && "function" == typeof r[o] && t.test(s[o]) ? function(e, t) {
            return function() {
                var s = this._super;
                this._super = r[e];
                var n = t.apply(this, arguments);
                return this._super = s, n
            }
        }(o, s[o]) : s[o];
        return n.prototype = i, n.prototype.constructor = n, n.extend = arguments.callee, n
    }
}();
var hexcase = 0,
b64pad = "";

function hex_md5(e) {
return rstr2hex(rstr_md5(str2rstr_utf8(e)))
}

function b64_md5(e) {
return rstr2b64(rstr_md5(str2rstr_utf8(e)))
}

function any_md5(e, t) {
return rstr2any(rstr_md5(str2rstr_utf8(e)), t)
}

function hex_hmac_md5(e, t) {
return rstr2hex(rstr_hmac_md5(str2rstr_utf8(e), str2rstr_utf8(t)))
}

function b64_hmac_md5(e, t) {
return rstr2b64(rstr_hmac_md5(str2rstr_utf8(e), str2rstr_utf8(t)))
}

function any_hmac_md5(e, t, s) {
return rstr2any(rstr_hmac_md5(str2rstr_utf8(e), str2rstr_utf8(t)), s)
}

function md5_vm_test() {
return "900150983cd24fb0d6963f7d28e17f72" == hex_md5("abc")
    .toLowerCase()
}

function rstr_md5(e) {
return binl2rstr(binl_md5(rstr2binl(e), 8 * e.length))
}

function rstr_hmac_md5(e, t) {
var s = rstr2binl(e);
16 < s.length && (s = binl_md5(s, 8 * e.length));
for (var n = Array(16), r = Array(16), i = 0; 16 > i; i++) n[i] = 909522486 ^ s[i], r[i] = 1549556828 ^ s[i];
return s = binl_md5(n.concat(rstr2binl(t)), 512 + 8 * t.length), binl2rstr(binl_md5(r.concat(s), 640))
}

function rstr2hex(e) {
for (var t, s = hexcase ? "0123456789ABCDEF" : "0123456789abcdef", n = "", r = 0; r < e.length; r++) t = e.charCodeAt(r), n += s.charAt(t >>> 4 & 15) + s.charAt(15 & t);
return n
}

function rstr2b64(e) {
for (var t = "", s = e.length, n = 0; n < s; n += 3)
    for (var r = e.charCodeAt(n) << 16 | (n + 1 < s ? e.charCodeAt(n + 1) << 8 : 0) | (n + 2 < s ? e.charCodeAt(n + 2) : 0), i = 0; 4 > i; i++) t = 8 * n + 6 * i > 8 * e.length ? t + b64pad : t + "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/".charAt(r >>> 6 * (3 - i) & 63);
return t
}

function rstr2any(e, t) {
var s, n, r, i, o, a = t.length,
    u = Array(Math.ceil(e.length / 2));
for (s = 0; s < u.length; s++) u[s] = e.charCodeAt(2 * s) << 8 | e.charCodeAt(2 * s + 1);
var S = Math.ceil(8 * e.length / (Math.log(t.length) / Math.log(2))),
    l = Array(S);
for (n = 0; n < S; n++) {
    for (o = [], s = i = 0; s < u.length; s++) i = (i << 16) + u[s], i -= (r = Math.floor(i / a)) * a, (0 < o.length || 0 < r) && (o[o.length] = r);
    l[n] = i, u = o
}
for (a = "", s = l.length - 1; 0 <= s; s--) a += t.charAt(l[s]);
return a
}

function str2rstr_utf8(e) {
for (var t, s, n = "", r = -1; ++r < e.length;) t = e.charCodeAt(r), s = r + 1 < e.length ? e.charCodeAt(r + 1) : 0, 55296 <= t && 56319 >= t && 56320 <= s && 57343 >= s && (t = 65536 + ((1023 & t) << 10) + (1023 & s), r++), 127 >= t ? n += String.fromCharCode(t) : 2047 >= t ? n += String.fromCharCode(192 | t >>> 6 & 31, 128 | 63 & t) : 65535 >= t ? n += String.fromCharCode(224 | t >>> 12 & 15, 128 | t >>> 6 & 63, 128 | 63 & t) : 2097151 >= t && (n += String.fromCharCode(240 | t >>> 18 & 7, 128 | t >>> 12 & 63, 128 | t >>> 6 & 63, 128 | 63 & t));
return n
}

function str2rstr_utf16le(e) {
for (var t = "", s = 0; s < e.length; s++) t += String.fromCharCode(255 & e.charCodeAt(s), e.charCodeAt(s) >>> 8 & 255);
return t
}

function str2rstr_utf16be(e) {
for (var t = "", s = 0; s < e.length; s++) t += String.fromCharCode(e.charCodeAt(s) >>> 8 & 255, 255 & e.charCodeAt(s));
return t
}

function rstr2binl(e) {
for (var t = Array(e.length >> 2), s = 0; s < t.length; s++) t[s] = 0;
for (s = 0; s < 8 * e.length; s += 8) t[s >> 5] |= (255 & e.charCodeAt(s / 8)) << s % 32;
return t
}

function binl2rstr(e) {
for (var t = "", s = 0; s < 32 * e.length; s += 8) t += String.fromCharCode(e[s >> 5] >>> s % 32 & 255);
return t
}

function binl_md5(e, t) {
e[t >> 5] |= 128 << t % 32, e[14 + (t + 64 >>> 9 << 4)] = t;
for (var s = 1732584193, n = -271733879, r = -1732584194, i = 271733878, o = 0; o < e.length; o += 16) {
    var a = s,
        u = n,
        S = r,
        l = i;
    s = md5_ff(s, n, r, i, e[o + 0], 7, -680876936), i = md5_ff(i, s, n, r, e[o + 1], 12, -389564586), r = md5_ff(r, i, s, n, e[o + 2], 17, 606105819), n = md5_ff(n, r, i, s, e[o + 3], 22, -1044525330), s = md5_ff(s, n, r, i, e[o + 4], 7, -176418897), i = md5_ff(i, s, n, r, e[o + 5], 12, 1200080426), r = md5_ff(r, i, s, n, e[o + 6], 17, -1473231341), n = md5_ff(n, r, i, s, e[o + 7], 22, -45705983), s = md5_ff(s, n, r, i, e[o + 8], 7, 1770035416), i = md5_ff(i, s, n, r, e[o + 9], 12, -1958414417), r = md5_ff(r, i, s, n, e[o + 10], 17, -42063), n = md5_ff(n, r, i, s, e[o + 11], 22, -1990404162), s = md5_ff(s, n, r, i, e[o + 12], 7, 1804603682), i = md5_ff(i, s, n, r, e[o + 13], 12, -40341101), r = md5_ff(r, i, s, n, e[o + 14], 17, -1502002290), s = md5_gg(s, n = md5_ff(n, r, i, s, e[o + 15], 22, 1236535329), r, i, e[o + 1], 5, -165796510), i = md5_gg(i, s, n, r, e[o + 6], 9, -1069501632), r = md5_gg(r, i, s, n, e[o + 11], 14, 643717713), n = md5_gg(n, r, i, s, e[o + 0], 20, -373897302), s = md5_gg(s, n, r, i, e[o + 5], 5, -701558691), i = md5_gg(i, s, n, r, e[o + 10], 9, 38016083), r = md5_gg(r, i, s, n, e[o + 15], 14, -660478335), n = md5_gg(n, r, i, s, e[o + 4], 20, -405537848), s = md5_gg(s, n, r, i, e[o + 9], 5, 568446438), i = md5_gg(i, s, n, r, e[o + 14], 9, -1019803690), r = md5_gg(r, i, s, n, e[o + 3], 14, -187363961), n = md5_gg(n, r, i, s, e[o + 8], 20, 1163531501), s = md5_gg(s, n, r, i, e[o + 13], 5, -1444681467), i = md5_gg(i, s, n, r, e[o + 2], 9, -51403784), r = md5_gg(r, i, s, n, e[o + 7], 14, 1735328473), s = md5_hh(s, n = md5_gg(n, r, i, s, e[o + 12], 20, -1926607734), r, i, e[o + 5], 4, -378558), i = md5_hh(i, s, n, r, e[o + 8], 11, -2022574463), r = md5_hh(r, i, s, n, e[o + 11], 16, 1839030562), n = md5_hh(n, r, i, s, e[o + 14], 23, -35309556), s = md5_hh(s, n, r, i, e[o + 1], 4, -1530992060), i = md5_hh(i, s, n, r, e[o + 4], 11, 1272893353), r = md5_hh(r, i, s, n, e[o + 7], 16, -155497632), n = md5_hh(n, r, i, s, e[o + 10], 23, -1094730640), s = md5_hh(s, n, r, i, e[o + 13], 4, 681279174), i = md5_hh(i, s, n, r, e[o + 0], 11, -358537222), r = md5_hh(r, i, s, n, e[o + 3], 16, -722521979), n = md5_hh(n, r, i, s, e[o + 6], 23, 76029189), s = md5_hh(s, n, r, i, e[o + 9], 4, -640364487), i = md5_hh(i, s, n, r, e[o + 12], 11, -421815835), r = md5_hh(r, i, s, n, e[o + 15], 16, 530742520), s = md5_ii(s, n = md5_hh(n, r, i, s, e[o + 2], 23, -995338651), r, i, e[o + 0], 6, -198630844), i = md5_ii(i, s, n, r, e[o + 7], 10, 1126891415), r = md5_ii(r, i, s, n, e[o + 14], 15, -1416354905), n = md5_ii(n, r, i, s, e[o + 5], 21, -57434055), s = md5_ii(s, n, r, i, e[o + 12], 6, 1700485571), i = md5_ii(i, s, n, r, e[o + 3], 10, -1894986606), r = md5_ii(r, i, s, n, e[o + 10], 15, -1051523), n = md5_ii(n, r, i, s, e[o + 1], 21, -2054922799), s = md5_ii(s, n, r, i, e[o + 8], 6, 1873313359), i = md5_ii(i, s, n, r, e[o + 15], 10, -30611744), r = md5_ii(r, i, s, n, e[o + 6], 15, -1560198380), n = md5_ii(n, r, i, s, e[o + 13], 21, 1309151649), s = md5_ii(s, n, r, i, e[o + 4], 6, -145523070), i = md5_ii(i, s, n, r, e[o + 11], 10, -1120210379), r = md5_ii(r, i, s, n, e[o + 2], 15, 718787259), n = md5_ii(n, r, i, s, e[o + 9], 21, -343485551), s = safe_add(s, a), n = safe_add(n, u), r = safe_add(r, S), i = safe_add(i, l)
}
return [s, n, r, i]
}

function md5_cmn(e, t, s, n, r, i) {
return safe_add(bit_rol(safe_add(safe_add(t, e), safe_add(n, i)), r), s)
}

function md5_ff(e, t, s, n, r, i, o) {
return md5_cmn(t & s | ~t & n, e, t, r, i, o)
}

function md5_gg(e, t, s, n, r, i, o) {
return md5_cmn(t & n | s & ~n, e, t, r, i, o)
}

function md5_hh(e, t, s, n, r, i, o) {
return md5_cmn(t ^ s ^ n, e, t, r, i, o)
}

function md5_ii(e, t, s, n, r, i, o) {
return md5_cmn(s ^ (t | ~n), e, t, r, i, o)
}

function safe_add(e, t) {
var s = (65535 & e) + (65535 & t);
return (e >> 16) + (t >> 16) + (s >> 16) << 16 | 65535 & s
}

function bit_rol(e, t) {
return e << t | e >>> 32 - t
}
SFS2X.Utils = {}, SFS2X.Utils.md5_crypt = function(e, t) {
    "undefined" != typeof VarType && (e = VarType.toStr(e), t = VarType.toStr(t));
    var s = b64pad;
    b64pad = "";
    var n = chrsz;
    chrsz = 8, "$1$" == t.substr(0, 3) && (t = t.substr(3)), (0 > (o = t.indexOf("$")) || 8 < o) && (o = 8);
    for (var r = e + "$1$" + (t = t.substr(0, o)), i = str_md5(e + t + e), o = e.length; 0 < o; o -= 16) r = 16 <= o ? r + i : r + i.substr(0, o);
    for (o = e.length; 0 != o; o >>= 1) r = 1 & o ? r + String.fromCharCode(0) : r + e.charAt(0);
    var a = "$1$" + t + "$";
    for (i = str_md5(r), o = 0; 1e3 > o; o++) r = "", r = 1 & o ? r + e : r + i, 0 != o % 3 && (r += t), 0 != o % 7 && (r += e), r = 1 & o ? r + i : r + e, i = str_md5(r);
    for (i += i.charAt(5), o = 0; 5 > o; o++) r = i.charCodeAt(o) << 16 | i.charCodeAt(o + 6) << 8 | i.charCodeAt(o + 12), a += md5_to64(r, 4);
    return r = i.charCodeAt(11), a += md5_to64(r, 2), b64pad = s, chrsz = n, a
}, SFS2X.Utils.ClientDisconnectionReason = {
    IDLE: "idle",
    KICK: "kick",
    BAN: "ban",
    MANUAL: "manual",
    UNKNOWN: "unknown"
}, SFS2X.Utils.ClientDisconnectionReason.getReason = function(e) {
    switch (e) {
        case 0:
            return this.IDLE;
        case 1:
            return this.KICK;
        case 2:
            return this.BAN;
        case 3:
            return this.MANUAL;
        case 4:
            return this.UNKNOWN
    }
}, SFS2X.Utils.ArrayUtil = {}, SFS2X.Utils.ArrayUtil.objToArray = function(e) {
    var t, s = [];
    for (t in e) e.hasOwnProperty(t) && s.push(e[t]);
    return s
}, SFS2X.Utils.ArrayUtil.removeItem = function(e, t) {
    var s = e.indexOf(t); - 1 < s && e.splice(s, 1)
}, SFS2X.Utils.HashTable = function(e) {
    for (var t in this.length = 0, this.items = {}, e) e.hasOwnProperty(t) && (this.items[t] = e[t], this.length++)
}, SFS2X.Utils.HashTable.prototype.setItem = function(e, t) {
    var s = void 0;
    return this.hasItem(e) ? s = this.items[e] : this.length++, this.items[e] = t, s
}, SFS2X.Utils.HashTable.prototype.getItem = function(e) {
    return this.hasItem(e) ? this.items[e] : void 0
}, SFS2X.Utils.HashTable.prototype.hasItem = function(e) {
    return this.items.hasOwnProperty(e)
}, SFS2X.Utils.HashTable.prototype.removeItem = function(e) {
    if (this.hasItem(e)) return previous = this.items[e], this.length--, delete this.items[e], previous
}, SFS2X.Utils.HashTable.prototype.keys = function() {
    var e, t = [];
    for (e in this.items) this.hasItem(e) && t.push(e);
    return t
}, SFS2X.Utils.HashTable.prototype.values = function() {
    var e, t = [];
    for (e in this.items) this.hasItem(e) && t.push(this.items[e]);
    return t
}, SFS2X.Utils.HashTable.prototype.each = function(e) {
    for (var t in this.items) this.hasItem(t) && e(t, this.items[t])
}, SFS2X.Utils.HashTable.prototype.clear = function() {
    this.items = {}, this.length = 0
}, SFS2X.Utils.LagMonitor = function(e, t, s) {
    (null == t || 1 > t) && (t = 4), (null == s || 1 > s) && (s = 10), this._sfs = e, this._valueQueue = [], this._interval = t, this._queueSize = s, this._thread = null, this._lastReqTime = -1
}, SFS2X.Utils.LagMonitor.prototype.start = function() {
    !this.isRunning() && null != this._sfs && (this._thread = setInterval(this._threadRunner, 1e3 * this._interval, this))
}, SFS2X.Utils.LagMonitor.prototype.stop = function() {
    this.isRunning() && (clearInterval(this._thread), this._thread = null, this._valueQueue = [])
}, SFS2X.Utils.LagMonitor.prototype.destroy = function() {
    this.stop(), this._sfs = null
}, SFS2X.Utils.LagMonitor.prototype.isRunning = function() {
    return null != this._thread
}, SFS2X.Utils.LagMonitor.prototype.getLastPingTime = function() {
    return 0 < this._valueQueue.length ? this._valueQueue[this._valueQueue.length - 1] : 0
}, SFS2X.Utils.LagMonitor.prototype._threadRunner = function(e) {
    e._lastReqTime = (new Date)
        .getTime(), e._sfs.send(new SFS2X.Requests.System.PingPongRequest)
}, SFS2X.Utils.LagMonitor.prototype._onPingPong = function() {
    var e = (new Date)
        .getTime() - this._lastReqTime;
    return this._valueQueue.length >= this._queueSize && this._valueQueue.shift(), this._valueQueue.push(e), this._getAveragePingTime()
}, SFS2X.Utils.LagMonitor.prototype._getAveragePingTime = function() {
    if (0 == this._valueQueue.length) return 0;
    for (var e = 0, t = 0; t < this._valueQueue.length; t++) e += this._valueQueue[t];
    return e / this._valueQueue.length
}, SFS2X.Utils.BuddyOnlineState = {
    ONLINE: 0,
    OFFLINE: 1,
    LEFT_THE_SERVER: 2
}, SFS2X.Controllers = {}, SFS2X.Controllers.CONTROLLER_ID = "c", SFS2X.Controllers.ACTION_ID = "a", SFS2X.Controllers.PARAM_ID = "p", SFS2X.Controllers.KEY_ERROR_CODE = "ec", SFS2X.Controllers.KEY_ERROR_PARAMS = "ep", SFS2X.Controllers.ROOM_PARAM = "r", SFS2X.Controllers.USER_PARAM = "u", SFS2X.Controllers.USER_COUNT_PARAM = "uc", SFS2X.Controllers.SPECT_COUNT_PARAM = "sc", SFS2X.Controllers.SystemController = function(e) {
    this._sfs = e, this._id = 0, this._requestHandlers = {}, this._initRequestHandlers(), this._log = SFS2X.Logger
}, SFS2X.Controllers.SystemController.prototype.getId = function() {
    return this._id
}, SFS2X.Controllers.SystemController.prototype.handleMessage = function(e, t) {
    this._sfs.debug && this._log.info("IN < " + this._getEvtName(t));
    var s = this._requestHandlers[t];
    null != s ? this[s](e) : this._log.warn("Unknown message id: " + e.id)
}, SFS2X.Controllers.SystemController.prototype._initRequestHandlers = function() {
    this._requestHandlers[SFS2X.Requests.Handshake] = "_fnHandshake", this._requestHandlers[SFS2X.Requests.Login] = "_fnLogin", this._requestHandlers[SFS2X.Requests.Logout] = "_fnLogout", this._requestHandlers[SFS2X.Requests.JoinRoom] = "_fnJoinRoom", this._requestHandlers[SFS2X.Requests.CreateRoom] = "_fnCreateRoom", this._requestHandlers[SFS2X.Requests.ChangeRoomName] = "_fnChangeRoomName", this._requestHandlers[SFS2X.Requests.ChangeRoomPassword] = "_fnChangeRoomPassword", this._requestHandlers[SFS2X.Requests.ChangeRoomCapacity] = "_fnChangeRoomCapacity", this._requestHandlers[SFS2X.Requests.GenericMessage] = "_fnGenericMessage", this._requestHandlers[SFS2X.Requests.SetRoomVariables] = "_fnSetRoomVariables", this._requestHandlers[SFS2X.Requests.SetUserVariables] = "_fnSetUserVariables", this._requestHandlers[SFS2X.Requests.SubscribeRoomGroup] = "_fnSubscribeRoomGroup", this._requestHandlers[SFS2X.Requests.UnsubscribeRoomGroup] = "_fnUnsubscribeRoomGroup", this._requestHandlers[SFS2X.Requests.SpectatorToPlayer] = "_fnSpectatorToPlayer", this._requestHandlers[SFS2X.Requests.PlayerToSpectator] = "_fnPlayerToSpectator", this._requestHandlers[SFS2X.Requests.InitBuddyList] = "_fnInitBuddyList", this._requestHandlers[SFS2X.Requests.AddBuddy] = "_fnAddBuddy", this._requestHandlers[SFS2X.Requests.RemoveBuddy] = "_fnRemoveBuddy", this._requestHandlers[SFS2X.Requests.BlockBuddy] = "_fnBlockBuddy", this._requestHandlers[SFS2X.Requests.GoOnline] = "_fnGoOnline", this._requestHandlers[SFS2X.Requests.SetBuddyVariables] = "_fnSetBuddyVariables", this._requestHandlers[SFS2X.Requests.FindRooms] = "_fnFindRooms", this._requestHandlers[SFS2X.Requests.FindUsers] = "_fnFindUsers", this._requestHandlers[SFS2X.Requests.InviteUsers] = "_fnInviteUsers", this._requestHandlers[SFS2X.Requests.InvitationReply] = "_fnInvitationReply", this._requestHandlers[SFS2X.Requests.QuickJoinGame] = "_fnQuickJoinGame", this._requestHandlers[SFS2X.Requests.PingPong] = "_fnPingPong", this._requestHandlers[SFS2X.Requests.SetUserPosition] = "_fnSetUserPosition", this._requestHandlers[1e3] = "_fnUserEnterRoom", this._requestHandlers[1001] = "_fnUserCountChange", this._requestHandlers[1002] = "_fnUserLost", this._requestHandlers[1003] = "_fnRoomLost", this._requestHandlers[1004] = "_fnUserExitRoom", this._requestHandlers[1005] = "_fnClientDisconnection", this._requestHandlers[1007] = "_fnSetMMOItemVariables"
}, SFS2X.Controllers.SystemController.prototype._getEvtName = function(e) {
    return this._requestHandlers[e].substr(3)
}, SFS2X.Controllers.SystemController.prototype._fnHandshake = function(e) {
    this._sfs._handleHandShake(e)
}, SFS2X.Controllers.SystemController.prototype._fnLogin = function(e) {
    if (null == e[SFS2X.Controllers.KEY_ERROR_CODE]) {
        this._populateRoomList(e[SFS2X.Requests.System.LoginRequest.KEY_ROOMLIST]), this._sfs.mySelf = new SFS2X.Entities.SFSUser(e[SFS2X.Requests.System.LoginRequest.KEY_ID], e[SFS2X.Requests.System.LoginRequest.KEY_USER_NAME], !0), this._sfs.mySelf._setUserManager(this._sfs.userManager), this._sfs.mySelf.privilegeId = e[SFS2X.Requests.System.LoginRequest.KEY_PRIVILEGE_ID], this._sfs.userManager._addUser(this._sfs.mySelf), this._sfs._socketEngine.reconnectionSeconds = e[SFS2X.Requests.System.LoginRequest.KEY_RECONNECTION_SECONDS];
        var t = {};
        t.zone = e[SFS2X.Requests.System.LoginRequest.KEY_ZONE_NAME], t.user = this._sfs.mySelf, t.data = e[SFS2X.Requests.System.LoginRequest.KEY_PARAMS], this._sfs._dispatchEvent(SFS2X.SFSEvent.LOGIN, t)
    } else t = e[SFS2X.Controllers.KEY_ERROR_CODE], e = SFS2X.ErrorCodes.getErrorMessage(t, e[SFS2X.Controllers.KEY_ERROR_PARAMS]), this._sfs._dispatchEvent(SFS2X.SFSEvent.LOGIN_ERROR, {
        errorMessage: e,
        errorCode: t
    })
}, SFS2X.Controllers.SystemController.prototype._fnLogout = function(e) {
    this._sfs._handleLogout();
    var t = {};
    t.zone = e[SFS2X.Requests.System.LogoutRequest.KEY_ZONE_NAME], this._sfs._dispatchEvent(SFS2X.SFSEvent.LOGOUT, t)
}, SFS2X.Controllers.SystemController.prototype._fnJoinRoom = function(e) {
    var t = this._sfs.roomManager,
        s = {};
    this._sfs._isJoining = !1;
    var n = e[SFS2X.Controllers.KEY_ERROR_CODE];
    if (null == n) {
        for (n = e[SFS2X.Requests.System.JoinRoomRequest.KEY_USER_LIST], (e = SFS2X.Entities.SFSRoom.fromArray(e[SFS2X.Requests.System.JoinRoomRequest.KEY_ROOM]))
            ._setRoomManager(t), e = t._replaceRoom(e, t.containsGroup(e.groupId)), t = 0; t < n.length; t++) {
            var r = n[t],
                i = this._getOrCreateUser(r, !0, e);
            i._setPlayerId(r[3], e), e._addUser(i)
        }
        e.isJoined = !0, this._sfs.lastJoinedRoom = e, s.room = e, this._sfs._dispatchEvent(SFS2X.SFSEvent.ROOM_JOIN, s)
    } else e = SFS2X.ErrorCodes.getErrorMessage(n, e[SFS2X.Controllers.KEY_ERROR_PARAMS]), s.content = e, s.errorCode = n, this._sfs._dispatchEvent(SFS2X.SFSEvent.ROOM_JOIN_ERROR, s)
}, SFS2X.Controllers.SystemController.prototype._fnCreateRoom = function(e) {
    var t = {};
    if (null == e[SFS2X.Controllers.KEY_ERROR_CODE]) {
        var s = this._sfs.roomManager;
        (e = SFS2X.Entities.SFSRoom.fromArray(e[SFS2X.Requests.System.CreateRoomRequest.KEY_ROOM]))
        ._setRoomManager = s, s._addRoom(e), t.room = e, this._sfs._dispatchEvent(SFS2X.SFSEvent.ROOM_ADD, t)
    } else s = e[SFS2X.Controllers.KEY_ERROR_CODE], e = SFS2X.ErrorCodes.getErrorMessage(s, e[SFS2X.Controllers.KEY_ERROR_PARAMS]), t.content = e, t.errorCode = s, this._sfs._dispatchEvent(SFS2X.SFSEvent.ROOM_CREATION_ERROR, t)
}, SFS2X.Controllers.SystemController.prototype._fnChangeRoomName = function(e) {
    var t = {};
    if (null == e[SFS2X.Controllers.KEY_ERROR_CODE]) {
        var s = this._sfs.roomManager.getRoomById(e[SFS2X.Requests.System.ChangeRoomNameRequest.KEY_ROOM]);
        null != s ? (t.oldName = s.name, this._sfs.roomManager._changeRoomName(s, e[SFS2X.Requests.System.ChangeRoomNameRequest.KEY_NAME]), t.room = s, this._sfs._dispatchEvent(SFS2X.SFSEvent.ROOM_NAME_CHANGE, t)) : this._log.warn("RoomNameChange event, unknown Room id: " + rId)
    } else s = e[SFS2X.Controllers.KEY_ERROR_CODE], e = SFS2X.ErrorCodes.getErrorMessage(s, e[SFS2X.Controllers.KEY_ERROR_PARAMS]), t.content = e, t.errorCode = s, this._sfs._dispatchEvent(SFS2X.SFSEvent.ROOM_NAME_CHANGE_ERROR, t)
}, SFS2X.Controllers.SystemController.prototype._fnChangeRoomPassword = function(e) {
    var t = {};
    if (null == e[SFS2X.Controllers.KEY_ERROR_CODE]) {
        var s = this._sfs.roomManager.getRoomById(e[SFS2X.Requests.System.ChangeRoomNameRequest.KEY_ROOM]);
        null != s ? (this._sfs.roomManager._changeRoomPasswordState(s, e[SFS2X.Requests.System.ChangeRoomPasswordStateRequest.KEY_PASS]), t.room = s, this._sfs._dispatchEvent(SFS2X.SFSEvent.ROOM_PASSWORD_STATE_CHANGE, t)) : this._log.warn("RoomPasswordChange event, unknown Room id: " + rId)
    } else s = e[SFS2X.Controllers.KEY_ERROR_CODE], e = SFS2X.ErrorCodes.getErrorMessage(s, e[SFS2X.Controllers.KEY_ERROR_PARAMS]), t.content = e, t.errorCode = s, this._sfs._dispatchEvent(SFS2X.SFSEvent.ROOM_PASSWORD_STATE_CHANGE_ERROR, t)
}, SFS2X.Controllers.SystemController.prototype._fnChangeRoomCapacity = function(e) {
    var t = {};
    if (null == e[SFS2X.Controllers.KEY_ERROR_CODE]) {
        var s = this._sfs.roomManager.getRoomById(e[SFS2X.Requests.System.ChangeRoomNameRequest.KEY_ROOM]);
        null != s ? (this._sfs.roomManager._changeRoomCapacity(s, e[SFS2X.Requests.System.ChangeRoomCapacityRequest.KEY_USER_SIZE], e[SFS2X.Requests.System.ChangeRoomCapacityRequest.KEY_SPEC_SIZE]), t.room = s, this._sfs._dispatchEvent(SFS2X.SFSEvent.ROOM_CAPACITY_CHANGE, t)) : this._log.warn("RoomPasswordChange event, unknown Room id: " + rId)
    } else s = e[SFS2X.Controllers.KEY_ERROR_CODE], e = SFS2X.ErrorCodes.getErrorMessage(s, e[SFS2X.Controllers.KEY_ERROR_PARAMS]), t.content = e, t.errorCode = s, this._sfs._dispatchEvent(SFS2X.SFSEvent.ROOM_CAPACITY_CHANGE_ERROR, t)
}, SFS2X.Controllers.SystemController.prototype._fnGenericMessage = function(e) {
    switch (e[SFS2X.Requests.System.GenericMessageRequest.KEY_MESSAGE_TYPE]) {
        case SFS2X.Requests.GenericMessageType.PUBLIC_MSG:
            this._handlePublicMessage(e);
            break;
        case SFS2X.Requests.GenericMessageType.PRIVATE_MSG:
            this._handlePrivateMessage(e);
            break;
        case SFS2X.Requests.GenericMessageType.BUDDY_MSG:
            this._handleBuddyMessage(e);
            break;
        case SFS2X.Requests.GenericMessageType.MODERATOR_MSG:
            this._handleModMessage(e);
            break;
        case SFS2X.Requests.GenericMessageType.ADMING_MSG:
            this._handleAdminMessage(e);
            break;
        case SFS2X.Requests.GenericMessageType.OBJECT_MSG:
            this._handleObjectMessage(e)
    }
}, SFS2X.Controllers.SystemController.prototype._handlePublicMessage = function(e) {
    var t = {},
        s = e[SFS2X.Requests.System.GenericMessageRequest.KEY_ROOM_ID],
        n = this._sfs.roomManager.getRoomById(s);
    null != n ? (t.room = n, t.sender = this._sfs.userManager.getUserById(e[SFS2X.Requests.System.GenericMessageRequest.KEY_USER_ID]), t.message = e[SFS2X.Requests.System.GenericMessageRequest.KEY_MESSAGE], t.data = e[SFS2X.Requests.System.GenericMessageRequest.KEY_XTRA_PARAMS], this._sfs._dispatchEvent(SFS2X.SFSEvent.PUBLIC_MESSAGE, t)) : this._log.warn("Unexpected, public message target Room doesn't exist; Room id: " + s)
}, SFS2X.Controllers.SystemController.prototype._handlePrivateMessage = function(e) {
    var t = {},
        s = this._sfs.userManager.getUserById(e[SFS2X.Requests.System.GenericMessageRequest.KEY_USER_ID]);
    if (null == s) {
        if (null == e[SFS2X.Requests.System.GenericMessageRequest.KEY_SENDER_DATA]) return void this._log.warn("Unexpected, private message has no sender details");
        s = SFS2X.Entities.SFSUser.fromArray(e[SFS2X.Requests.System.GenericMessageRequest.KEY_SENDER_DATA])
    }
    t.sender = s, t.message = e[SFS2X.Requests.System.GenericMessageRequest.KEY_MESSAGE], t.data = e[SFS2X.Requests.System.GenericMessageRequest.KEY_XTRA_PARAMS], this._sfs._dispatchEvent(SFS2X.SFSEvent.PRIVATE_MESSAGE, t)
}, SFS2X.Controllers.SystemController.prototype._handleBuddyMessage = function(e) {
    var t = {},
        s = e[SFS2X.Requests.System.GenericMessageRequest.KEY_USER_ID],
        n = this._sfs.buddyManager.getBuddyById(s);
    t.isItMe = this._sfs.mySelf.id == s, t.buddy = n, t.message = e[SFS2X.Requests.System.GenericMessageRequest.KEY_MESSAGE], t.data = e[SFS2X.Requests.System.GenericMessageRequest.KEY_XTRA_PARAMS], this._sfs._dispatchEvent(SFS2X.SFSBuddyEvent.BUDDY_MESSAGE, t)
}, SFS2X.Controllers.SystemController.prototype._handleModMessage = function(e) {
    var t = {};
    t.sender = SFS2X.Entities.SFSUser.fromArray(e[SFS2X.Requests.System.GenericMessageRequest.KEY_SENDER_DATA]), t.message = e[SFS2X.Requests.System.GenericMessageRequest.KEY_MESSAGE], t.data = e[SFS2X.Requests.System.GenericMessageRequest.KEY_XTRA_PARAMS], this._sfs._dispatchEvent(SFS2X.SFSEvent.MODERATOR_MESSAGE, t)
}, SFS2X.Controllers.SystemController.prototype._handleAdminMessage = function(e) {
    var t = {};
    t.sender = SFS2X.Entities.SFSUser.fromArray(e[SFS2X.Requests.System.GenericMessageRequest.KEY_SENDER_DATA]), t.message = e[SFS2X.Requests.System.GenericMessageRequest.KEY_MESSAGE], t.data = e[SFS2X.Requests.System.GenericMessageRequest.KEY_XTRA_PARAMS], this._sfs._dispatchEvent(SFS2X.SFSEvent.ADMIN_MESSAGE, t)
}, SFS2X.Controllers.SystemController.prototype._handleObjectMessage = function(e) {
    var t = {};
    t.sender = this._sfs.userManager.getUserById(e[SFS2X.Requests.System.GenericMessageRequest.KEY_USER_ID]), t.message = e[SFS2X.Requests.System.GenericMessageRequest.KEY_XTRA_PARAMS], this._sfs._dispatchEvent(SFS2X.SFSEvent.OBJECT_MESSAGE, t)
}, SFS2X.Controllers.SystemController.prototype._fnSetRoomVariables = function(e) {
    var t = e[SFS2X.Requests.System.SetRoomVariablesRequest.KEY_VAR_ROOM],
        s = e[SFS2X.Requests.System.SetRoomVariablesRequest.KEY_VAR_LIST],
        n = [];
    if (null != (e = this._sfs.roomManager.getRoomById(t))) {
        for (t = 0; t < s.length; t++) {
            var r = SFS2X.Entities.Variables.SFSRoomVariable.fromArray(s[t]);
            e._setVariable(r), n.push(r.name)
        }(s = {})
        .changedVars = n, s.room = e, this._sfs._dispatchEvent(SFS2X.SFSEvent.ROOM_VARIABLES_UPDATE, s)
    } else this._log.warn("RoomVariablesUpdate event, unknown Room id: " + t)
}, SFS2X.Controllers.SystemController.prototype._fnSetUserVariables = function(e) {
    var t = e[SFS2X.Requests.System.SetUserVariablesRequest.KEY_USER],
        s = e[SFS2X.Requests.System.SetUserVariablesRequest.KEY_VAR_LIST],
        n = [];
    if (null != (e = this._sfs.userManager.getUserById(t))) {
        for (t = 0; t < s.length; t++) {
            var r = SFS2X.Entities.Variables.SFSUserVariable.fromArray(s[t]);
            e._setVariable(r), n.push(r.name)
        }(s = {})
        .changedVars = n, s.user = e, this._sfs._dispatchEvent(SFS2X.SFSEvent.USER_VARIABLES_UPDATE, s)
    } else this._log.warn("UserVariablesUpdate event, unknown User id: " + t)
}, SFS2X.Controllers.SystemController.prototype._fnSubscribeRoomGroup = function(e) {
    var t = {};
    if (null == e[SFS2X.Controllers.KEY_ERROR_CODE]) {
        var s = e[SFS2X.Requests.System.SubscribeRoomGroupRequest.KEY_GROUP_ID];
        e = e[SFS2X.Requests.System.SubscribeRoomGroupRequest.KEY_ROOM_LIST];
        this._sfs.roomManager.containsGroup(s) && this._log.warn("Subscribe Group error: Group '" + s + "' already subscribed"), this._populateRoomList(e), t.groupId = s, t.newRooms = this._sfs.roomManager.getRoomListFromGroup(s), this._sfs._dispatchEvent(SFS2X.SFSEvent.ROOM_GROUP_SUBSCRIBE, t)
    } else s = e[SFS2X.Controllers.KEY_ERROR_CODE], e = SFS2X.ErrorCodes.getErrorMessage(s, e[SFS2X.Controllers.KEY_ERROR_PARAMS]), t.content = e, t.errorCode = s, this._sfs._dispatchEvent(SFS2X.SFSEvent.ROOM_GROUP_SUBSCRIBE_ERROR, t)
}, SFS2X.Controllers.SystemController.prototype._fnUnsubscribeRoomGroup = function(e) {
    var t = {};
    if (null == e[SFS2X.Controllers.KEY_ERROR_CODE]) {
        var s = e[SFS2X.Requests.System.UnsubscribeRoomGroupRequest.KEY_GROUP_ID];
        this._sfs.roomManager.containsGroup(s) || this._log.warn("Unsubscribe Group error: Group '" + s + "' not found (maybe never subscribed, or the Room Manager doesn't contain Rooms belonging to that Group)"), this._sfs.roomManager._removeGroup(s), t.groupId = s, this._sfs._dispatchEvent(SFS2X.SFSEvent.ROOM_GROUP_UNSUBSCRIBE, t)
    } else s = e[SFS2X.Controllers.KEY_ERROR_CODE], e = SFS2X.ErrorCodes.getErrorMessage(s, e[SFS2X.Controllers.KEY_ERROR_PARAMS]), t.content = e, t.errorCode = s, this._sfs._dispatchEvent(SFS2X.SFSEvent.ROOM_GROUP_UNSUBSCRIBE_ERROR, t)
}, SFS2X.Controllers.SystemController.prototype._fnSpectatorToPlayer = function(e) {
    var t = {};
    if (null == e[SFS2X.Controllers.KEY_ERROR_CODE]) {
        var s = e[SFS2X.Requests.System.SpectatorToPlayerRequest.KEY_ROOM_ID],
            n = e[SFS2X.Requests.System.SpectatorToPlayerRequest.KEY_USER_ID],
            r = (e = e[SFS2X.Requests.System.SpectatorToPlayerRequest.KEY_PLAYER_ID], this._sfs.userManager.getUserById(n)),
            i = this._sfs.roomManager.getRoomById(s);
        null != i ? null != r ? r.isJoinedInRoom(i) ? (r._setPlayerId(e, i), t.room = i, t.user = r, t.playerId = e, this._sfs._dispatchEvent(SFS2X.SFSEvent.SPECTATOR_TO_PLAYER, t)) : this._log.warn("SpectatorToPlayer event, user " + r + " not joined in Room ", i) : this._log.warn("SpectatorToPlayer event, unknown User id: " + n) : this._log.warn("SpectatorToPlayer event, unknown Room id: " + s)
    } else s = e[SFS2X.Controllers.KEY_ERROR_CODE], n = SFS2X.ErrorCodes.getErrorMessage(s, e[SFS2X.Controllers.KEY_ERROR_PARAMS]), t.content = n, t.errorCode = s, this._sfs._dispatchEvent(SFS2X.SFSEvent.SPECTATOR_TO_PLAYER_ERROR, t)
}, SFS2X.Controllers.SystemController.prototype._fnPlayerToSpectator = function(e) {
    var t = {};
    if (null == e[SFS2X.Controllers.KEY_ERROR_CODE]) {
        var s = e[SFS2X.Requests.System.PlayerToSpectatorRequest.KEY_ROOM_ID],
            n = (e = e[SFS2X.Requests.System.PlayerToSpectatorRequest.KEY_USER_ID], this._sfs.userManager.getUserById(e)),
            r = this._sfs.roomManager.getRoomById(s);
        null != r ? null != n ? n.isJoinedInRoom(r) ? (n._setPlayerId(-1, r), t.room = r, t.user = n, this._sfs._dispatchEvent(SFS2X.SFSEvent.PLAYER_TO_SPECTATOR, t)) : this._log.warn("PlayerToSpectator event, user " + n + " not joined in Room ", r) : this._log.warn("PlayerToSpectator event, unknown User id: " + e) : this._log.warn("PlayerToSpectator event, unknown Room id: " + s)
    } else s = e[SFS2X.Controllers.KEY_ERROR_CODE], e = SFS2X.ErrorCodes.getErrorMessage(s, e[SFS2X.Controllers.KEY_ERROR_PARAMS]), t.content = e, t.errorCode = s, this._sfs._dispatchEvent(SFS2X.SFSEvent.PLAYER_TO_SPECTATOR_ERROR, t)
}, SFS2X.Controllers.SystemController.prototype._fnFindRooms = function(e) {
    for (var t = {}, s = (e = e[SFS2X.Requests.System.FindRoomsRequest.KEY_FILTERED_ROOMS], []), n = 0; n < e.length; n++) {
        var r = SFS2X.Entities.SFSRoom.fromArray(e[n]),
            i = this._sfs.roomManager.getRoomById(r.id);
        null != i && (r.isJoined = i.isJoined), s.push(r)
    }
    t.rooms = s, this._sfs._dispatchEvent(SFS2X.SFSEvent.ROOM_FIND_RESULT, t)
}, SFS2X.Controllers.SystemController.prototype._fnFindUsers = function(e) {
    for (var t = {}, s = (e = e[SFS2X.Requests.System.FindUsersRequest.KEY_FILTERED_USERS], []), n = this._sfs.mySelf, r = 0; r < e.length; r++) {
        var i = SFS2X.Entities.SFSUser.fromArray(e[r]);
        i.id == n.id && (i = n), s.push(i)
    }
    t.users = s, this._sfs._dispatchEvent(SFS2X.SFSEvent.USER_FIND_RESULT, t)
}, SFS2X.Controllers.SystemController.prototype._fnInviteUsers = function(e) {
    var t = {},
        s = null != e[SFS2X.Requests.Game.InviteUsersRequest.KEY_USER_ID] ? this._sfs.userManager.getUserById(e[SFS2X.Requests.Game.InviteUsersRequest.KEY_USER_ID]) : SFS2X.Entities.SFSUser.fromArray(e[SFS2X.Requests.Game.InviteUsersRequest.KEY_USER]),
        n = e[SFS2X.Requests.Game.InviteUsersRequest.KEY_INVITATION_ID];
    (e = new SFS2X.Entities.Invitation.SFSInvitation(s, this._sfs.mySelf, e[SFS2X.Requests.Game.InviteUsersRequest.KEY_TIME], e[SFS2X.Requests.Game.InviteUsersRequest.KEY_PARAMS]))
    .id = n, t.invitation = e, this._sfs._dispatchEvent(SFS2X.SFSEvent.INVITATION, t)
}, SFS2X.Controllers.SystemController.prototype._fnInvitationReply = function(e) {
    var t = {};
    if (null == e[SFS2X.Controllers.KEY_ERROR_CODE]) {
        var s = null,
            n = (s = null != e[SFS2X.Requests.Game.InviteUsersRequest.KEY_USER_ID] ? this._sfs.userManager.getUserById(e[SFS2X.Requests.Game.InviteUsersRequest.KEY_USER_ID]) : SFS2X.Entities.SFSUser.fromArray(e[SFS2X.Requests.Game.InviteUsersRequest.KEY_USER]), e[SFS2X.Requests.Game.InviteUsersRequest.KEY_REPLY_ID]);
        e = e[SFS2X.Requests.Game.InviteUsersRequest.KEY_PARAMS];
        t.invitee = s, t.reply = n, t.data = e, this._sfs._dispatchEvent(SFS2X.SFSEvent.INVITATION_REPLY, t)
    } else s = e[SFS2X.Controllers.KEY_ERROR_CODE], e = SFS2X.ErrorCodes.getErrorMessage(s, e[SFS2X.Controllers.KEY_ERROR_PARAMS]), t.content = e, t.errorCode = s, this._sfs._dispatchEvent(SFS2X.SFSEvent.INVITATION_REPLY_ERROR, t)
}, SFS2X.Controllers.SystemController.prototype._fnQuickJoinGame = function(e) {
    if (null != e[SFS2X.Controllers.KEY_ERROR_CODE]) {
        var t = e[SFS2X.Controllers.KEY_ERROR_CODE],
            s = (e = SFS2X.ErrorCodes.getErrorMessage(t, e[SFS2X.Controllers.KEY_ERROR_PARAMS]), {});
        s.content = e, s.errorCode = t, this._sfs._dispatchEvent(SFS2X.SFSEvent.ROOM_JOIN_ERROR, s)
    }
}, SFS2X.Controllers.SystemController.prototype._fnPingPong = function() {
    var e = this._sfs._lagMonitor._onPingPong(),
        t = {};
    t.lagValue = e, this._sfs._dispatchEvent(SFS2X.SFSEvent.PING_PONG, t)
}, SFS2X.Controllers.SystemController.prototype._fnSetUserPosition = function(e) {
    var t = {},
        s = this._sfs.roomManager.getRoomById(e[SFS2X.Requests.MMO.SetUserPositionRequest.KEY_ROOM]),
        n = e[SFS2X.Requests.MMO.SetUserPositionRequest.KEY_MINUS_USER_LIST],
        r = e[SFS2X.Requests.MMO.SetUserPositionRequest.KEY_PLUS_USER_LIST],
        i = e[SFS2X.Requests.MMO.SetUserPositionRequest.KEY_MINUS_ITEM_LIST],
        o = (e = e[SFS2X.Requests.MMO.SetUserPositionRequest.KEY_PLUS_ITEM_LIST], []),
        a = [],
        u = [],
        S = [],
        l = 0;
    if (null != n)
        for (l = 0; l < n.length; l++) {
            var _ = s.getUserById(n[l]);
            null != _ && (s._removeUser(_), a.push(_))
        }
    if (null != r)
        for (l = 0; l < r.length; l++) _ = r[l], n = this._getOrCreateUser(_, !0, s), o.push(n), s._addUser(n), null != (_ = _[5]) && (n.aoiEntryPoint = SFS2X.Entities.Data.Vec3D.fromArray(_));
    if (null != i)
        for (l = 0; l < i.length; l++) null != (r = s.getMMOItem(i[l])) && (s._removeItem(r), S.push(r));
    if (null != e)
        for (l = 0; l < e.length; l++) r = e[l], i = SFS2X.Entities.MMOItem.fromArray(r), u.push(i), s._addMMOItem(i), null != (r = r[2]) && (i.aoiEntryPoint = SFS2X.Entities.Data.Vec3D.fromArray(r));
    t.addedItems = u, t.removedItems = S, t.removedUsers = a, t.addedUsers = o, t.room = s, this._sfs._dispatchEvent(SFS2X.SFSEvent.PROXIMITY_LIST_UPDATE, t)
}, SFS2X.Controllers.SystemController.prototype._fnSetMMOItemVariables = function(e) {
    var t = {},
        s = this._sfs.roomManager.getRoomById(e[SFS2X.Requests.MMO.SetMMOItemVariables.KEY_ROOM_ID]),
        n = e[SFS2X.Requests.MMO.SetMMOItemVariables.KEY_ITEM_ID],
        r = (e = e[SFS2X.Requests.MMO.SetMMOItemVariables.KEY_VAR_LIST], []);
    if (null != s && null != (n = s.getMMOItem(n))) {
        for (var i = 0; i < e.length; i++) {
            var o = SFS2X.Entities.Variables.MMOItemVariable.fromArray(e[i]);
            n._setVariable(o), r.push(o.name)
        }
        t.changedVars = r, t.mmoItem = n, t.room = s, this._sfs._dispatchEvent(SFS2X.SFSEvent.MMOITEM_VARIABLES_UPDATE, t)
    }
}, SFS2X.Controllers.SystemController.prototype._fnUserEnterRoom = function(e) {
    var t = this._sfs.roomManager.getRoomById(e[SFS2X.Controllers.ROOM_PARAM]);
    if (null != t) {
        e = this._getOrCreateUser(e[SFS2X.Controllers.USER_PARAM], !0, t), t._addUser(e);
        var s = {};
        s.user = e, s.room = t, this._sfs._dispatchEvent(SFS2X.SFSEvent.USER_ENTER_ROOM, s)
    }
}, SFS2X.Controllers.SystemController.prototype._fnUserCountChange = function(e) {
    var t = this._sfs.roomManager.getRoomById(e[SFS2X.Controllers.ROOM_PARAM]);
    if (null != t) {
        var s = e[SFS2X.Controllers.USER_COUNT_PARAM],
            n = 0;
        null != e.sc && (n = e[SFS2X.Controllers.SPECT_COUNT_PARAM]), t._userCount = s, t._specCount = n, (e = {})
            .room = t, e.uCount = s, e.sCount = n, this._sfs._dispatchEvent(SFS2X.SFSEvent.USER_COUNT_CHANGE, e)
    }
}, SFS2X.Controllers.SystemController.prototype._fnUserLost = function(e) {
    if (null != (e = this._sfs.userManager.getUserById(e[SFS2X.Controllers.USER_PARAM]))) {
        var t = this._sfs.roomManager.getUserRooms(e);
        this._sfs.roomManager._removeUser(e), this._sfs.userManager._removeUser(e);
        for (var s = 0; s < t.length; s++) {
            var n = {};
            n.user = e, n.room = t[s], this._sfs._dispatchEvent(SFS2X.SFSEvent.USER_EXIT_ROOM, n)
        }
    }
}, SFS2X.Controllers.SystemController.prototype._fnRoomLost = function(e) {
    e = this._sfs.roomManager.getRoomById(e[SFS2X.Controllers.ROOM_PARAM]);
    var t = this._sfs.userManager;
    if (null != e) {
        this._sfs.roomManager._removeRoom(e);
        for (var s = e.getUserList(), n = 0; n < s.length; n++) t._removeUser(s[n]);
        (t = {})
        .room = e, this._sfs._dispatchEvent(SFS2X.SFSEvent.ROOM_REMOVE, t)
    }
}, SFS2X.Controllers.SystemController.prototype._fnUserExitRoom = function(e) {
    var t = this._sfs.roomManager.getRoomById(e[SFS2X.Controllers.ROOM_PARAM]);
    e = this._sfs.userManager.getUserById(e[SFS2X.Controllers.USER_PARAM]);
    if (null != t && null != e) {
        t._removeUser(e), this._sfs.userManager._removeUser(e), e.isItMe && t.isJoined && (t.isJoined = !1, 0 == this._sfs.roomManager.getJoinedRooms()
            .length && (this._sfs.lastJoinedRoom = null), t._isManaged || this._sfs.roomManager._removeRoom(t));
        var s = {};
        s.user = e, s.room = t, this._sfs._dispatchEvent(SFS2X.SFSEvent.USER_EXIT_ROOM, s)
    } else this._log.debug("Failed to handle UserExit event. Room: " + t + ", User: " + e)
}, SFS2X.Controllers.SystemController.prototype._fnClientDisconnection = function(e) {
    this._sfs._handleClientDisconnection(SFS2X.Utils.ClientDisconnectionReason.getReason(e.dr))
}, SFS2X.Controllers.SystemController.prototype._fnInitBuddyList = function(e) {
    var t = {};
    if (null == e[SFS2X.Controllers.KEY_ERROR_CODE]) {
        var s = e[SFS2X.Requests.BuddyList.InitBuddyListRequest.KEY_BLIST],
            n = e[SFS2X.Requests.BuddyList.InitBuddyListRequest.KEY_MY_VARS],
            r = e[SFS2X.Requests.BuddyList.InitBuddyListRequest.KEY_BUDDY_STATES];
        for (this._sfs.buddyManager._clearAll(), e = 0; e < s.length; e++) {
            var i = SFS2X.Entities.SFSBuddy.fromArray(s[e]);
            this._sfs.buddyManager._addBuddy(i)
        }
        for (null != r && this._sfs.buddyManager._setBuddyStates(r), s = [], e = 0; e < n.length; e++) r = SFS2X.Entities.Variables.SFSBuddyVariable.fromArray(n[e]), s.push(r);
        this._sfs.buddyManager._setMyVariables(s), this._sfs.buddyManager._setInited(), t.buddyList = this._sfs.buddyManager.getBuddyList(), t.myVariables = this._sfs.buddyManager.getMyVariables(), this._sfs._dispatchEvent(SFS2X.SFSBuddyEvent.BUDDY_LIST_INIT, t)
    } else n = e[SFS2X.Controllers.KEY_ERROR_CODE], e = SFS2X.ErrorCodes.getErrorMessage(n, e[SFS2X.Controllers.KEY_ERROR_PARAMS]), t.content = e, t.errorCode = n, this._sfs._dispatchEvent(SFS2X.SFSBuddyEvent.BUDDY_ERROR, t)
}, SFS2X.Controllers.SystemController.prototype._fnAddBuddy = function(e) {
    var t = {};
    if (null == e[SFS2X.Controllers.KEY_ERROR_CODE]) {
        var s = SFS2X.Entities.SFSBuddy.fromArray(e[SFS2X.Requests.BuddyList.AddBuddyRequest.KEY_BUDDY_NAME]);
        this._sfs.buddyManager._addBuddy(s), t.buddy = s, this._sfs._dispatchEvent(SFS2X.SFSBuddyEvent.BUDDY_ADD, t)
    } else s = e[SFS2X.Controllers.KEY_ERROR_CODE], e = SFS2X.ErrorCodes.getErrorMessage(s, e[SFS2X.Controllers.KEY_ERROR_PARAMS]), t.content = e, t.errorCode = s, this._sfs._dispatchEvent(SFS2X.SFSBuddyEvent.BUDDY_ERROR, t)
}, SFS2X.Controllers.SystemController.prototype._fnRemoveBuddy = function(e) {
    var t = {};
    if (null == e[SFS2X.Controllers.KEY_ERROR_CODE]) {
        var s = e[SFS2X.Requests.BuddyList.RemoveBuddyRequest.KEY_BUDDY_NAME];
        null != (e = this._sfs.buddyManager._removeBuddyByName(s)) ? (t.buddy = e, this._sfs._dispatchEvent(SFS2X.SFSBuddyEvent.BUDDY_REMOVE, t)) : this._log.warn("Unexpected: buddy removal failed, can't find " + s + " in local buddy list")
    } else s = e[SFS2X.Controllers.KEY_ERROR_CODE], e = SFS2X.ErrorCodes.getErrorMessage(s, e[SFS2X.Controllers.KEY_ERROR_PARAMS]), t.content = e, t.errorCode = s, this._sfs._dispatchEvent(SFS2X.SFSBuddyEvent.BUDDY_ERROR, t)
}, SFS2X.Controllers.SystemController.prototype._fnBlockBuddy = function(e) {
    var t = {};
    if (null == e[SFS2X.Controllers.KEY_ERROR_CODE]) {
        var s = e[SFS2X.Requests.BuddyList.BlockBuddyRequest.KEY_BUDDY_NAME],
            n = this._sfs.buddyManager.getBuddyByName(s);
        null != n ? (n.blocked = e[SFS2X.Requests.BuddyList.BlockBuddyRequest.KEY_BUDDY_BLOCK_STATE], t.buddy = n, this._sfs._dispatchEvent(SFS2X.SFSBuddyEvent.BUDDY_BLOCK, t)) : this._log.warn("Unexpected: buddy blocking/unblocking failed, can't find " + s + " in local buddy list")
    } else s = e[SFS2X.Controllers.KEY_ERROR_CODE], e = SFS2X.ErrorCodes.getErrorMessage(s, e[SFS2X.Controllers.KEY_ERROR_PARAMS]), t.content = e, t.errorCode = s, this._sfs._dispatchEvent(SFS2X.SFSBuddyEvent.BUDDY_ERROR, t)
}, SFS2X.Controllers.SystemController.prototype._fnGoOnline = function(e) {
    var t = {};
    if (null == e[SFS2X.Controllers.KEY_ERROR_CODE]) {
        var s = e[SFS2X.Requests.BuddyList.GoOnlineRequest.KEY_BUDDY_NAME],
            n = this._sfs.buddyManager.getBuddyByName(s),
            r = s == this._sfs.mySelf.name,
            i = e[SFS2X.Requests.BuddyList.GoOnlineRequest.KEY_ONLINE],
            o = i == SFS2X.Utils.BuddyOnlineState.ONLINE,
            a = !0;
        if (r) this._sfs.buddyManager.getMyOnlineState() != o && (this._log.warn("Unexpected: myOnlineState is not in synch with the server; resynching to: " + o), this._sfs.buddyManager._setMyOnlineState(o));
        else {
            if (null == n) return void this._log.warn("Unexpected:  buddy '" + s + "' not found in local Buddy List when trying to set his online state");
            n.id = e[SFS2X.Requests.BuddyList.GoOnlineRequest.KEY_BUDDY_ID], n._setVariable(new SFS2X.Entities.Variables.SFSBuddyVariable(SFS2X.Entities.Variables.ReservedBuddyVariables.BV_ONLINE, o)), i == SFS2X.Utils.BuddyOnlineState.LEFT_THE_SERVER && n._clearVolatileVariables(), a = this._sfs.buddyManager.getMyOnlineState()
        }
        a && (t.buddy = n, t.isItMe = r, this._sfs._dispatchEvent(SFS2X.SFSBuddyEvent.BUDDY_ONLINE_STATE_CHANGE, t))
    } else s = e[SFS2X.Controllers.KEY_ERROR_CODE], e = SFS2X.ErrorCodes.getErrorMessage(s, e[SFS2X.Controllers.KEY_ERROR_PARAMS]), t.content = e, t.errorCode = s, this._sfs._dispatchEvent(SFS2X.SFSBuddyEvent.BUDDY_ERROR, t)
}, SFS2X.Controllers.SystemController.prototype._fnSetBuddyVariables = function(e) {
    var t = {};
    if (null == e[SFS2X.Controllers.KEY_ERROR_CODE]) {
        for (var s = e[SFS2X.Requests.BuddyList.SetBuddyVariablesRequest.KEY_BUDDY_NAME], n = (e = e[SFS2X.Requests.BuddyList.SetBuddyVariablesRequest.KEY_BUDDY_VARS], this._sfs.buddyManager.getBuddyByName(s)), r = s == this._sfs.mySelf.name, i = [], o = [], a = !0, u = 0; u < e.length; u++) {
            var S = SFS2X.Entities.Variables.SFSBuddyVariable.fromArray(e[u]);
            o.push(S), i.push(S.name)
        }
        if (r) this._sfs.buddyManager._setMyVariables(o);
        else {
            if (null == n) return void this._log.warn("Unexpected:  buddy '" + s + "' not found in local Buddy List when trying to set his Buddy Variables");
            n._setVariables(o), a = sfs.buddyManager.getMyOnlineState()
        }
        a && (t.buddy = n, t.isItMe = r, t.changedVars = i, this._sfs._dispatchEvent(SFS2X.SFSBuddyEvent.BUDDY_VARIABLES_UPDATE, t))
    } else s = e[SFS2X.Controllers.KEY_ERROR_CODE], e = SFS2X.ErrorCodes.getErrorMessage(s, e[SFS2X.Controllers.KEY_ERROR_PARAMS]), t.content = e, t.errorCode = s, this._sfs._dispatchEvent(SFS2X.SFSBuddyEvent.BUDDY_ERROR, t)
}, SFS2X.Controllers.SystemController.prototype._populateRoomList = function(e) {
    for (var t = this._sfs.roomManager, s = 0; s < e.length; s++) {
        var n = SFS2X.Entities.SFSRoom.fromArray(e[s]);
        t._replaceRoom(n)
    }
}, SFS2X.Controllers.SystemController.prototype._getOrCreateUser = function(e, t, s) {
    null == t && (t = !1);
    var n = this._sfs.userManager.getUserById(e[0]);
    if (null == n)(n = SFS2X.Entities.SFSUser.fromArray(e, s))
        ._setUserManager(this._sfs.userManager);
    else if (null != s)
        for (n._setPlayerId(e[3], s), e = e[4], s = 0; s < e.length; s++) n._setVariable(SFS2X.Entities.Variables.SFSUserVariable.fromArray(e[s]));
    return t && this._sfs.userManager._addUser(n), n
}, SFS2X.Controllers.ExtensionController = function(e) {
    this.KEY_CMD = "c", this.KEY_PARAMS = "p", this.KEY_ROOM = "r", this._sfs = e, this._id = 1, this._log = SFS2X.Logger
}, SFS2X.Controllers.ExtensionController.prototype.getId = function() {
    return this._id
}, SFS2X.Controllers.ExtensionController.prototype.handleMessage = function(e) {
    this._sfs.debug && this._log.info("IN < ExtensionResponse");
    var t = {};
    t.cmd = e[this.KEY_CMD], t.params = e[this.KEY_PARAMS], null != e[this.KEY_ROOM] && (t.sourceRoom = e[this.KEY_ROOM]), this._sfs._dispatchEvent(SFS2X.SFSEvent.EXTENSION_RESPONSE, t)
}, SFS2X.DebugHelper = {}, SFS2X.DebugHelper.getDump = function(e) {
    return null == e ? "<Null>" : e instanceof Object ? this._dumpObject(e) : "<Not An Object>"
}, SFS2X.DebugHelper._dumpObject = function(e) {
    var t = [];
    return function e(t, s, n) {
        var r = null;
        for (var i in SFS2X.DebugHelper._getTabs(n), t) {
            var o = t[i];
            if (null == o) r = "Null";
            else {
                var a = o.constructor,
                    u = void 0;
                a === Array || a === Object ? (r = null, u = a === Array ? "[Array]" : "[Object]", e(o, s, n + 1)) : r = o.constructor === Number ? "Num" : o.constructor === Boolean ? "Bool" : o.constructor === String ? "Str" : "Unsupported"
            }
            s.push(SFS2X.DebugHelper._getTabs(n) + i + ": " + (null == u ? o : u) + (null == r ? "" : " (" + r + ")"))
        }
    }(e, t, 0), SFS2X.DebugHelper._prettyPrint(t)
}, SFS2X.DebugHelper._getTabs = function(e) {
    if (0 >= e) return "";
    if (1 == e) return "\t";
    for (var t = "", s = 0; s < e; s++) t += "\t";
    return t
}, SFS2X.DebugHelper._prettyPrint = function(e) {
    for (var t = "", s = e.length - 1; - 1 < s; s--) t += e[s] + "\n";
    return t
}, SFS2X.Entities = {}, SFS2X.Entities.Data = {}, SFS2X.Entities.Variables = {}, SFS2X.Entities.Match = {}, SFS2X.Entities.Invitation = {}, SFS2X.Entities.SFSRoom = Class.extend({
    init: function(e, t, s) {
        this.id = e, this.name = t, this.groupId = null != s ? s : "default", this.isPasswordProtected = this.isJoined = this.isHidden = this.isGame = !1, this._specCount = this._userCount = this.maxSpectators = this.maxUsers = 0, this._isManaged = !0, this.variables = {}, this.properties = {}, this._userManager = new SFS2X.Managers.UserManager, this._roomManager = null
    },
    toString: function() {
        return "[Room: " + this.name + ", Id: " + this.id + ", Group id: " + this.groupId + "]"
    },
    getUserCount: function() {
        return this.isJoined ? this.isGame ? this.getPlayerList()
            .length : this._userManager.getUserCount() : this._userCount
    },
    getSpectatorCount: function() {
        return this.isGame ? this.isJoined ? this.getSpectatorList()
            .length : this._specCount : 0
    },
    getCapacity: function() {
        return this.maxUsers + this.maxSpectators
    },
    getUserByName: function(e) {
        return this._userManager.getUserByName(e)
    },
    getUserById: function(e) {
        return this._userManager.getUserById(e)
    },
    containsUser: function(e) {
        return this._userManager.containsUser(e)
    },
    getUserList: function() {
        return this._userManager.getUserList()
    },
    getPlayerList: function() {
        for (var e = [], t = this._userManager.getUserList(), s = 0; s < t.length; s++) {
            var n = t[s];
            n.isPlayerInRoom(this) && e.push(n)
        }
        return e
    },
    getSpectatorList: function() {
        for (var e = [], t = this._userManager.getUserList(), s = 0; s < t.length; s++) {
            var n = t[s];
            n.isSpectatorInRoom(this) && e.push(n)
        }
        return e
    },
    getVariable: function(e) {
        return this.variables[e]
    },
    containsVariable: function(e) {
        return null != this.variables[e]
    },
    getVariables: function() {
        return SFS2X.Utils.ArrayUtil.objToArray(this.variables)
    },
    getRoomManager: function() {
        return this._roomManager
    },
    _addUser: function(e) {
        this._userManager._addUser(e)
    },
    _removeUser: function(e) {
        this._userManager._removeUser(e)
    },
    _setVariables: function(e) {
        for (var t = 0; t < e.length; t++) this._setVariable(e[t])
    },
    _setVariable: function(e) {
        e.isNull() ? delete this.variables[e.name] : this.variables[e.name] = e
    },
    _setRoomManager: function(e) {
        if (null != this._roomManager) throw new SFS2X.Exceptions.SFSError("Room Manager already assigned to Room " + this.toString());
        this._roomManager = e
    },
    _merge: function(e) {
        for (var t in this.variables = [], e.variables) this.variables[t] = e.variables[t];
        for (this._userManager._clearAll(), e = e.getUserList(), t = 0; t < e.length; t++) this._userManager._addUser(e[t])
    }
}), SFS2X.Entities.SFSRoom.fromArray = function(e) {
    var t = 14 == e.length,
        s = null;
    (s = t ? new SFS2X.Entities.MMORoom(e[0], e[1], e[2]) : new SFS2X.Entities.SFSRoom(e[0], e[1], e[2]))
    .isGame = e[3], s.isHidden = e[4], s.isPasswordProtected = e[5], s._userCount = e[6], s.maxUsers = e[7];
    var n = e[8];
    if (null != n)
        for (var r = 0; r < n.length; r++) {
            var i = SFS2X.Entities.Variables.SFSRoomVariable.fromArray(n[r]);
            s._setVariable(i)
        }
    return s.isGame && (s._specCount = e[9], s.maxSpectators = e[10]), t && (s.defaultAOI = SFS2X.Entities.Data.Vec3D.fromArray(e[11]), null != e[13] && (s.lowerMapLimit = SFS2X.Entities.Data.Vec3D.fromArray(e[12]), s.higherMapLimit = SFS2X.Entities.Data.Vec3D.fromArray(e[13]))), s
}, SFS2X.Entities.MMORoom = SFS2X.Entities.SFSRoom.extend({
    init: function(e, t, s) {
        this._super(e, t, s), this.higherMapLimit = this.lowerMapLimit = this.defaultAOI = null, this._itemsById = {}
    },
    getMMOItem: function(e) {
        return this._itemsById[e]
    },
    getMMOItems: function() {
        return SFS2X.Utils.ArrayUtil.objToArray(this._itemsById)
    },
    _addMMOItem: function(e) {
        this._itemsById[e.id] = e
    },
    _removeItem: function(e) {
        delete this._itemsById[e]
    }
}), SFS2X.Entities.SFSUser = function(e, t, s) {
    this.id = e, this.name = t, this.isItMe = null != s && s, this.privilegeId = 0, this.properties = {}, this.aoiEntryPoint = null, this.variables = {}, this._playerIdByRoomId = {}, this._userManager = null
}, SFS2X.Entities.SFSUser.fromArray = function(e, t) {
    var s = new SFS2X.Entities.SFSUser(e[0], e[1]);
    s.privilegeId = e[2], null != t && s._setPlayerId(e[3], t);
    var n = e[4];
    if (null != n)
        for (var r = 0; r < n.length; r++) {
            var i = SFS2X.Entities.Variables.SFSUserVariable.fromArray(n[r]);
            s._setVariable(i)
        }
    return s
}, SFS2X.Entities.SFSUser.prototype.toString = function() {
    return "[User: " + this.name + ", Id: " + this.id + ", Is me: " + this.isItMe + "]"
}, SFS2X.Entities.SFSUser.prototype.isJoinedInRoom = function(e) {
    return e.containsUser(this)
}, SFS2X.Entities.SFSUser.prototype.isGuest = function() {
    return this.privilegeId == SFS2X.Entities.UserPrivileges.GUEST
}, SFS2X.Entities.SFSUser.prototype.isStandardUser = function() {
    return this.privilegeId == SFS2X.Entities.UserPrivileges.STANDARD
}, SFS2X.Entities.SFSUser.prototype.isModerator = function() {
    return this.privilegeId == SFS2X.Entities.UserPrivileges.MODERATOR
}, SFS2X.Entities.SFSUser.prototype.isAdmin = function() {
    return this.privilegeId == SFS2X.Entities.UserPrivileges.ADMINISTRATOR
}, SFS2X.Entities.SFSUser.prototype.isPlayer = function() {
    return this.isPlayerInRoom(this._userManager._sfs.lastJoinedRoom)
}, SFS2X.Entities.SFSUser.prototype.isSpectator = function() {
    return this.isSpectatorInRoom(this._userManager._sfs.lastJoinedRoom)
}, SFS2X.Entities.SFSUser.prototype.getPlayerId = function(e) {
    var t = 0;
    return null != this._playerIdByRoomId[e.id] && (t = this._playerIdByRoomId[e.id]), t
}, SFS2X.Entities.SFSUser.prototype.isPlayerInRoom = function(e) {
    return !(null == e || !e.isGame) && 0 < this._playerIdByRoomId[e.id]
}, SFS2X.Entities.SFSUser.prototype.isSpectatorInRoom = function(e) {
    return !(null == e || !e.isGame) && 0 > this._playerIdByRoomId[e.id]
}, SFS2X.Entities.SFSUser.prototype.getVariable = function(e) {
    return this.variables[e]
}, SFS2X.Entities.SFSUser.prototype.containsVariable = function(e) {
    return null != this.variables[e]
}, SFS2X.Entities.SFSUser.prototype.getVariables = function() {
    return SFS2X.Utils.ArrayUtil.objToArray(this.variables)
}, SFS2X.Entities.SFSUser.prototype.getUserManager = function() {
    return this._userManager
}, SFS2X.Entities.SFSUser.prototype._setPlayerId = function(e, t) {
    this._playerIdByRoomId[t.id] = e
}, SFS2X.Entities.SFSUser.prototype._removePlayerId = function(e) {
    delete this._playerIdByRoomId[e.id]
}, SFS2X.Entities.SFSUser.prototype._setVariables = function(e) {
    for (var t = 0; t < e.length; t++) this._setVariable(e[t])
}, SFS2X.Entities.SFSUser.prototype._setVariable = function(e) {
    e.isNull() ? delete this.variables[e.name] : this.variables[e.name] = e
}, SFS2X.Entities.SFSUser.prototype._setUserManager = function(e) {
    if (null != this._userManager) throw new SFS2X.Exceptions.SFSError("User Manager already assigned to user " + this.toString());
    this._userManager = e
}, SFS2X.Entities.SFSBuddy = function(e, t, s, n) {
    this.id = e, this.name = t, this.blocked = null != s && s, this.temp = null != n && n, this.variables = {}
}, SFS2X.Entities.SFSBuddy.fromArray = function(e) {
    for (var t = new SFS2X.Entities.SFSBuddy(e[0], e[1], e[2], 4 < e.length && e[4]), s = (e = e[3], 0); s < e.length; s++) {
        var n = SFS2X.Entities.Variables.SFSBuddyVariable.fromArray(e[s]);
        t._setVariable(n)
    }
    return t
}, SFS2X.Entities.SFSBuddy.prototype.toString = function() {
    return "[Buddy: " + this.name + ", Id: " + this.id + "]"
}, SFS2X.Entities.SFSBuddy.prototype.isBlocked = function() {
    return this.blocked
}, SFS2X.Entities.SFSBuddy.prototype.isTemp = function() {
    return this.temp
}, SFS2X.Entities.SFSBuddy.prototype.isOnline = function() {
    var e = !0,
        t = SFS2X.Entities.Variables.ReservedBuddyVariables.BV_ONLINE;
    return this.containsVariable(t) && (e = this.getVariable(t)
        .value), e && -1 < this.id
}, SFS2X.Entities.SFSBuddy.prototype.getState = function() {
    var e = SFS2X.Entities.Variables.ReservedBuddyVariables.BV_STATE;
    return this.containsVariable(e) ? this.getVariable(e)
        .value : null
}, SFS2X.Entities.SFSBuddy.prototype.getNickName = function() {
    var e = SFS2X.Entities.Variables.ReservedBuddyVariables.BV_NICKNAME;
    return this.containsVariable(e) ? this.getVariable(e)
        .value : null
}, SFS2X.Entities.SFSBuddy.prototype.getVariable = function(e) {
    return this.variables[e]
}, SFS2X.Entities.SFSBuddy.prototype.containsVariable = function(e) {
    return null != this.variables[e]
}, SFS2X.Entities.SFSBuddy.prototype.getVariables = function() {
    return SFS2X.Utils.ArrayUtil.objToArray(this.variables)
}, SFS2X.Entities.SFSBuddy.prototype.getOfflineVariables = function() {
    var e, t = [];
    for (e in this.variables) {
        var s = this.variables[e];
        s.name.charAt(0) == SFS2X.Entities.Variables.SFSBuddyVariable.OFFLINE_PREFIX && t.push(s)
    }
    return t
}, SFS2X.Entities.SFSBuddy.prototype.getOnlineVariables = function() {
    var e, t = [];
    for (e in this.variables) {
        var s = this.variables[e];
        s.name.charAt(0) != SFS2X.Entities.Variables.SFSBuddyVariable.OFFLINE_PREFIX && t.push(s)
    }
    return t
}, SFS2X.Entities.SFSBuddy.prototype._setVariables = function(e) {
    for (var t = 0; t < e.length; t++) this._setVariable(e[t])
}, SFS2X.Entities.SFSBuddy.prototype._setVariable = function(e) {
    e.isNull() ? this._removeVariable(e.name) : this.variables[e.name] = e
}, SFS2X.Entities.SFSBuddy.prototype._removeVariable = function(e) {
    delete this.variables[e]
}, SFS2X.Entities.SFSBuddy.prototype._clearVolatileVariables = function() {
    for (var e in this.variables) {
        var t = this.variables[e];
        t.name.charAt(0) != SFS2X.Entities.Variables.SFSBuddyVariable.OFFLINE_PREFIX && this._removeVariable(t.name)
    }
}, SFS2X.Entities.MMOItem = function(e) {
    this.id = e, this.aoiEntryPoint = null, this.variables = {}
}, SFS2X.Entities.MMOItem.fromArray = function(e) {
    var t = new SFS2X.Entities.MMOItem(e[0]);
    if (null != (e = e[1]))
        for (var s = 0; s < e.length; s++) {
            var n = SFS2X.Entities.Variables.MMOItemVariable.fromArray(e[s]);
            t._setVariable(n)
        }
    return t
}, SFS2X.Entities.MMOItem.prototype.toString = function() {
    return "[Item: " + this.id + "]"
}, SFS2X.Entities.MMOItem.prototype.getVariable = function(e) {
    return this.variables[e]
}, SFS2X.Entities.MMOItem.prototype.containsVariable = function(e) {
    return null != this.variables[e]
}, SFS2X.Entities.MMOItem.prototype.getVariables = function() {
    return SFS2X.Utils.ArrayUtil.objToArray(this.variables)
}, SFS2X.Entities.MMOItem.prototype._setVariables = function(e) {
    for (var t = 0; t < e.length; t++) this._setVariable(e[t])
}, SFS2X.Entities.MMOItem.prototype._setVariable = function(e) {
    null != e && (e.isNull() ? delete this.variables[e.name] : this.variables[e.name] = e)
}, SFS2X.Entities.Variables.SFSUserVariable = Class.extend({
    init: function(e, t, s) {
        this.name = e, this.value = t, this._setType(s)
    },
    toString: function() {
        return "[UserVar: " + this.name + ", Type: " + this.type + ", Value: " + this.value + "]"
    },
    toArray: function() {
        return [this.name, SFS2X.Entities.Variables.VariableType.getTypeIdFromName(this.type), this.value]
    },
    isNull: function() {
        return SFS2X.Entities.Variables.VariableType.getTypeIdFromName(this.type) == SFS2X.Entities.Variables.VariableType.NULL
    },
    _setType: function(e) {
        null == e && (e = -1), -1 < e ? this.type = this.getTypeName(e) : null == this.value ? this.type = this.getTypeName(SFS2X.Entities.Variables.VariableType.NULL) : "boolean" == (e = typeof this.value) ? this.type = this.getTypeName(SFS2X.Entities.Variables.VariableType.BOOL) : "number" == e ? this.type = this.value === +this.value && this.value === (0 | this.value) ? this.getTypeName(SFS2X.Entities.Variables.VariableType.INT) : this.getTypeName(SFS2X.Entities.Variables.VariableType.DOUBLE) : "string" == e ? this.type = this.getTypeName(SFS2X.Entities.Variables.VariableType.STRING) : "object" == e && (this.type = this.value instanceof Array ? this.getTypeName(SFS2X.Entities.Variables.VariableType.ARRAY) : this.getTypeName(SFS2X.Entities.Variables.VariableType.OBJECT))
    },
    getTypeName: function(e) {
        return SFS2X.Entities.Variables.VariableType.getTypeName(e)
    }
}), SFS2X.Entities.Variables.SFSUserVariable.fromArray = function(e) {
    return new SFS2X.Entities.Variables.SFSUserVariable(e[0], e[2], e[1])
}, SFS2X.Entities.Variables.SFSRoomVariable = SFS2X.Entities.Variables.SFSUserVariable.extend({
    init: function(e, t, s) {
        this._super(e, t, s), this.isPersistent = this.isPrivate = !1
    },
    toString: function() {
        return "[RoomVar: " + this.name + ", Type: " + this.type + ", Value: " + this.value + ", Is private: " + this.isPrivate + "]"
    },
    toArray: function() {
        var e = this._super();
        return e.push(this.isPrivate), e.push(this.isPersistent), e
    }
}), SFS2X.Entities.Variables.SFSRoomVariable.fromArray = function(e) {
    var t = new SFS2X.Entities.Variables.SFSRoomVariable(e[0], e[2], e[1]);
    return t.isPrivate = e[3], t.isPersistent = e[4], t
}, SFS2X.Entities.Variables.SFSBuddyVariable = SFS2X.Entities.Variables.SFSUserVariable.extend({
    init: function(e, t, s) {
        this._super(e, t, s)
    },
    toString: function() {
        return "[BuddyVar: " + this.name + ", Type: " + this.type + ", Value: " + this.value + "]"
    },
    isOffline: function() {
        return this.name.charAt(0) == SFS2X.Entities.Variables.SFSBuddyVariable.OFFLINE_PREFIX
    }
}), SFS2X.Entities.Variables.SFSBuddyVariable.OFFLINE_PREFIX = "$", SFS2X.Entities.Variables.SFSBuddyVariable.fromArray = function(e) {
    return new SFS2X.Entities.Variables.SFSBuddyVariable(e[0], e[2], e[1])
}, SFS2X.Entities.Variables.MMOItemVariable = SFS2X.Entities.Variables.SFSUserVariable.extend({
    init: function(e, t, s) {
        this._super(e, t, s)
    },
    toString: function() {
        return "[ItemVar: " + this.name + ", Type: " + this.type + ", Value: " + this.value + "]"
    }
}), SFS2X.Entities.Variables.MMOItemVariable.fromArray = function(e) {
    return new SFS2X.Entities.Variables.MMOItemVariable(e[0], e[2], e[1])
}, SFS2X.Entities.Variables.VariableType = {
    _typeStrings: "Null Bool Int Double String Object Array".split(" "),
    NULL: 0,
    BOOL: 1,
    INT: 2,
    DOUBLE: 3,
    STRING: 4,
    OBJECT: 5,
    ARRAY: 6
}, SFS2X.Entities.Variables.VariableType.getTypeName = function(e) {
    return this._typeStrings[e]
}, SFS2X.Entities.Variables.VariableType.getTypeIdFromName = function(e) {
    return this._typeStrings.indexOf(e)
}, SFS2X.Entities.Variables.ReservedBuddyVariables = {}, SFS2X.Entities.Variables.ReservedBuddyVariables.BV_ONLINE = "$__BV_ONLINE__", SFS2X.Entities.Variables.ReservedBuddyVariables.BV_STATE = "$__BV_STATE__", SFS2X.Entities.Variables.ReservedBuddyVariables.BV_NICKNAME = "$__BV_NICKNAME__", SFS2X.Entities.Variables.ReservedRoomVariables = {}, SFS2X.Entities.Variables.ReservedRoomVariables.RV_GAME_STARTED = "$GS", SFS2X.Entities.UserPrivileges = {}, SFS2X.Entities.UserPrivileges.GUEST = 0, SFS2X.Entities.UserPrivileges.STANDARD = 1, SFS2X.Entities.UserPrivileges.MODERATOR = 2, SFS2X.Entities.UserPrivileges.ADMINISTRATOR = 3, SFS2X.Entities.Match.MatchExpression = function(e, t, s) {
    this.varName = e, this.condition = t, this.value = s, this._parent = this.next = this.logicOp = null
}, SFS2X.Entities.Match.MatchExpression.chainedMatchExpression = function(e, t, s, n, r) {
    return (e = new SFS2X.Entities.Match.MatchExpression(e, t, s))
        .logicOp = n, e._parent = r, e
}, SFS2X.Entities.Match.MatchExpression.prototype.and = function(e, t, s) {
    return this.next = SFS2X.Entities.Match.MatchExpression.chainedMatchExpression(e, t, s, SFS2X.Entities.Match.LogicOperator.AND, this)
}, SFS2X.Entities.Match.MatchExpression.prototype.or = function(e, t, s) {
    return this.next = SFS2X.Entities.Match.MatchExpression.chainedMatchExpression(e, t, s, SFS2X.Entities.Match.LogicOperator.OR, this)
}, SFS2X.Entities.Match.MatchExpression.prototype.hasNext = function() {
    return null != this.next
}, SFS2X.Entities.Match.MatchExpression.prototype.rewind = function() {
    for (var e = this; null != e._parent;) e = e._parent;
    return e
}, SFS2X.Entities.Match.MatchExpression.prototype.toString = function() {
    for (var e = this.rewind(), t = e._asString(); e.hasNext();) t += (e = e.next)
        ._asString();
    return t
}, SFS2X.Entities.Match.MatchExpression.prototype._asString = function() {
    var e = "";
    return null != this.logicOp && (e += " " + this.logicOp.id + " "), (e = e + "(" + this.varName + " " + this.condition.symbol + " " + ("string" == typeof this.value ? "'" + this.value + "'" : this.value)) + ")"
}, SFS2X.Entities.Match.MatchExpression.prototype._toArray = function() {
    var e = this.rewind(),
        t = [];
    for (t.push(e._expressionAsArray()); e.hasNext();) e = e.next, t.push(e._expressionAsArray());
    return t
}, SFS2X.Entities.Match.MatchExpression.prototype._expressionAsArray = function() {
    var e = [];
    return null != this.logicOp ? e.push(this.logicOp.id) : e.push(null), e.push(this.varName), e.push(this.condition.type), e.push(this.condition.symbol), e.push(this.value), e
}, SFS2X.Entities.Match.LogicOperator = function(e) {
    this.id = e
}, SFS2X.Entities.Match.LogicOperator.AND = new SFS2X.Entities.Match.LogicOperator("AND"), SFS2X.Entities.Match.LogicOperator.OR = new SFS2X.Entities.Match.LogicOperator("OR"), SFS2X.Entities.Match.BoolMatch = function(e) {
    this.type = 0, this.symbol = e
}, SFS2X.Entities.Match.BoolMatch.EQUALS = new SFS2X.Entities.Match.BoolMatch("=="), SFS2X.Entities.Match.BoolMatch.NOT_EQUALS = new SFS2X.Entities.Match.BoolMatch("!="), SFS2X.Entities.Match.NumberMatch = function(e) {
    this.type = 1, this.symbol = e
}, SFS2X.Entities.Match.NumberMatch.EQUALS = new SFS2X.Entities.Match.NumberMatch("=="), SFS2X.Entities.Match.NumberMatch.NOT_EQUALS = new SFS2X.Entities.Match.NumberMatch("!="), SFS2X.Entities.Match.NumberMatch.GREATER_THAN = new SFS2X.Entities.Match.NumberMatch(">"), SFS2X.Entities.Match.NumberMatch.GREATER_THAN_OR_EQUAL_TO = new SFS2X.Entities.Match.NumberMatch(">="), SFS2X.Entities.Match.NumberMatch.LESS_THAN = new SFS2X.Entities.Match.NumberMatch("<"), SFS2X.Entities.Match.NumberMatch.LESS_THAN_OR_EQUAL_TO = new SFS2X.Entities.Match.NumberMatch("<="), SFS2X.Entities.Match.StringMatch = function(e) {
    this.type = 2, this.symbol = e
}, SFS2X.Entities.Match.StringMatch.EQUALS = new SFS2X.Entities.Match.StringMatch("=="), SFS2X.Entities.Match.StringMatch.NOT_EQUALS = new SFS2X.Entities.Match.StringMatch("!="), SFS2X.Entities.Match.StringMatch.CONTAINS = new SFS2X.Entities.Match.StringMatch("contains"), SFS2X.Entities.Match.StringMatch.STARTS_WITH = new SFS2X.Entities.Match.StringMatch("startsWith"), SFS2X.Entities.Match.StringMatch.ENDS_WITH = new SFS2X.Entities.Match.StringMatch("endsWith"), SFS2X.Entities.Match.RoomProperties = {}, SFS2X.Entities.Match.RoomProperties.NAME = "${N}", SFS2X.Entities.Match.RoomProperties.GROUP_ID = "${G}", SFS2X.Entities.Match.RoomProperties.MAX_USERS = "${MXU}", SFS2X.Entities.Match.RoomProperties.MAX_SPECTATORS = "${MXS}", SFS2X.Entities.Match.RoomProperties.USER_COUNT = "${UC}", SFS2X.Entities.Match.RoomProperties.SPECTATOR_COUNT = "${SC}", SFS2X.Entities.Match.RoomProperties.IS_GAME = "${ISG}", SFS2X.Entities.Match.RoomProperties.IS_PRIVATE = "${ISP}", SFS2X.Entities.Match.RoomProperties.HAS_FREE_PLAYER_SLOTS = "${HFP}", SFS2X.Entities.Match.RoomProperties.IS_TYPE_SFSGAME = "${IST}", SFS2X.Entities.Match.UserProperties = {}, SFS2X.Entities.Match.UserProperties.NAME = "${N}", SFS2X.Entities.Match.UserProperties.IS_PLAYER = "${ISP}", SFS2X.Entities.Match.UserProperties.IS_SPECTATOR = "${ISS}", SFS2X.Entities.Match.UserProperties.IS_NPC = "${ISN}", SFS2X.Entities.Match.UserProperties.PRIVILEGE_ID = "${PRID}", SFS2X.Entities.Match.UserProperties.IS_IN_ANY_ROOM = "${IAR}", SFS2X.Entities.Invitation.SFSInvitation = function(e, t, s, n) {
    this.id = -1, this.inviter = e, this.invitee = t, this.secondsForAnswer = null != s ? s : 15, this.params = n
}, SFS2X.Entities.Invitation.InvitationReply = {}, SFS2X.Entities.Invitation.InvitationReply.ACCEPT = 0, SFS2X.Entities.Invitation.InvitationReply.REFUSE = 1, SFS2X.Entities.Data.Vec3D = function(e, t, s) {
    this.px = null != e ? e : 0, this.py = null != t ? t : 0, this.pz = null != s ? s : 0
}, SFS2X.Entities.Data.Vec3D.fromArray = function(e) {
    return new SFS2X.Entities.Data.Vec3D(e[0], e[1], e[2])
}, SFS2X.Entities.Data.Vec3D.prototype.isFloat = function() {
    return !(this.px === parseInt(this.px) && this.py === parseInt(this.py) && this.pz === parseInt(this.pz))
}, SFS2X.Entities.Data.Vec3D.prototype._toString = function() {
    return "(" + this.px + ", " + this.py + ", " + this.pz + ")"
}, SFS2X.Entities.Data.Vec3D.prototype._toArray = function() {
    return [this.px, this.py, this.pz]
}, SFS2X.ErrorCodes = {}, SFS2X.ErrorCodes._errorsByCode = ["Client API version is obsolete: {0}; required version: {1}", "Requested Zone {0} does not exist", "User name {0} is not recognized", "Wrong password for user {0}", "User {0} is banned", "Zone {0} is full", "User {0} is already logged in Zone {1}", "The server is full", "Zone {0} is currently inactive", "User name {0} contains bad words; filtered: {1}", "Guest users not allowed in Zone {0}", "IP address {0} is banned", "A Room with the same name already exists: {0}", "Requested Group is not available - Room: {0}; Group: {1}", "Bad Room name length -  Min: {0}; max: {1}; passed name length: {2}", "Room name contains bad words: {0}", "Zone is full; can't add Rooms anymore", "You have exceeded the number of Rooms that you can create per session: {0}", "Room creation failed, wrong parameter: {0}", "User {0} already joined in Room", "Room {0} is full", "Wrong password for Room {0}", "Requested Room does not exist", "Room {0} is locked", "Group {0} is already subscribed", "Group {0} does not exist", "Group {0} is not subscribed", "Group {0} does not exist", "{0}", "Room permission error; Room {0} cannot be renamed", "Room permission error; Room {0} cannot change password state", "Room permission error; Room {0} cannot change capacity", "Switch user error; no player slots available in Room {0}", "Switch user error; no spectator slots available in Room {0}", "Switch user error; Room {0} is not a Game Room", "Switch user error; you are not joined in Room {0}", "Buddy Manager initialization error, could not load buddy list: {0}", "Buddy Manager error, your buddy list is full; size is {0}", "Buddy Manager error, was not able to block buddy {0} because offline", "Buddy Manager error, you are attempting to set too many Buddy Variables; limit is {0}", "Game {0} access denied, user does not match access criteria", "QuickJoinGame action failed: no matching Rooms were found", "Your previous invitation reply was invalid or arrived too late"], SFS2X.ErrorCodes.setErrorMessage = function(e, t) {
    this._errorsByCode[e] = t
}, SFS2X.ErrorCodes.getErrorMessage = function(e, t) {
    return this.stringFormat(this._errorsByCode[e], t)
}, SFS2X.ErrorCodes.stringFormat = function(e, t) {
    if (null == e) return "";
    if (null != t)
        for (var s = 0; s < t.length; s++) e = e.replace("{" + s + "}", t[s]);
    return e
}, SFS2X.EventDispatcher = function() {
    this.listenersByEvent = {}
}, SFS2X.EventDispatcher.prototype.addEventListener = function(e, t, s) {
    null == this.listenersByEvent[e] && (this.listenersByEvent[e] = []), this.listenersByEvent[e].push({
        listener: t,
        scope: s
    })
}, SFS2X.EventDispatcher.prototype.removeEventListener = function(e, t) {
    var s = this.listenersByEvent[e];
    if (null != s)
        for (var n = 0; n < s.length; n++)
            if (s[n].listener === t) {
                s.splice(n, 1);
                break
            }
}, SFS2X.EventDispatcher.prototype.dispatchEvent = function(e, t) {
    var s = this.listenersByEvent[e];
    if (s && 0 < s.length)
        for (var n = 0; n < s.length; n++) s[n].listener.call(s[n].scope, t)
}, SFS2X.EventDispatcher.prototype.getListeners = function(e) {
    return listeners[e]
}, SFS2X.SFSEvent = {
    HANDSHAKE: "handshake",
    CONNECTION: "connection",
    CONNECTION_LOST: "connectionLost",
    CONNECTION_RETRY: "connectionRetry",
    CONNECTION_RESUME: "connectionResume",
    LOGIN: "login",
    LOGIN_ERROR: "loginError",
    LOGOUT: "logout",
    ROOM_ADD: "roomAdd",
    ROOM_CREATION_ERROR: "roomCreationError",
    ROOM_REMOVE: "roomRemove",
    ROOM_JOIN: "roomJoin",
    ROOM_JOIN_ERROR: "roomJoinError",
    USER_ENTER_ROOM: "userEnterRoom",
    USER_EXIT_ROOM: "userExitRoom",
    USER_COUNT_CHANGE: "userCountChange",
    PROXIMITY_LIST_UPDATE: "proximityListUpdate",
    PLAYER_TO_SPECTATOR: "playerToSpectator",
    PLAYER_TO_SPECTATOR_ERROR: "playerToSpectatorError",
    SPECTATOR_TO_PLAYER: "spectatorToPlayer",
    SPECTATOR_TO_PLAYER_ERROR: "spectatorToPlayerError",
    ROOM_NAME_CHANGE: "roomNameChange",
    ROOM_NAME_CHANGE_ERROR: "roomNameChangeError",
    ROOM_PASSWORD_STATE_CHANGE: "roomPasswordStateChange",
    ROOM_PASSWORD_STATE_CHANGE_ERROR: "roomPasswordStateChangeError",
    ROOM_CAPACITY_CHANGE: "roomCapacityChange",
    ROOM_CAPACITY_CHANGE_ERROR: "roomCapacityChangeError",
    PUBLIC_MESSAGE: "publicMessage",
    PRIVATE_MESSAGE: "privateMessage",
    OBJECT_MESSAGE: "objectMessage",
    MODERATOR_MESSAGE: "moderatorMessage",
    ADMIN_MESSAGE: "adminMessage",
    EXTENSION_RESPONSE: "extensionResponse",
    ROOM_VARIABLES_UPDATE: "roomVariablesUpdate",
    USER_VARIABLES_UPDATE: "userVariablesUpdate",
    MMOITEM_VARIABLES_UPDATE: "mmoItemVariablesUpdate",
    ROOM_GROUP_SUBSCRIBE: "roomGroupSubscribe",
    ROOM_GROUP_SUBSCRIBE_ERROR: "roomGroupSubscribeError",
    ROOM_GROUP_UNSUBSCRIBE: "roomGroupUnsubscribe",
    ROOM_GROUP_UNSUBSCRIBE_ERROR: "roomGroupUnsubscribeError",
    ROOM_FIND_RESULT: "roomFindResult",
    USER_FIND_RESULT: "userFindResult",
    INVITATION: "invitation",
    INVITATION_REPLY: "invitationReply",
    INVITATION_REPLY_ERROR: "invitationReplyError",
    PING_PONG: "pingPong",
    SOCKET_ERROR: "socketError"
}, SFS2X.SFSBuddyEvent = {
    BUDDY_LIST_INIT: "buddyListInit",
    BUDDY_ADD: "buddyAdd",
    BUDDY_REMOVE: "buddyRemove",
    BUDDY_BLOCK: "buddyBlock",
    BUDDY_ERROR: "buddyError",
    BUDDY_ONLINE_STATE_CHANGE: "buddyOnlineStateChange",
    BUDDY_VARIABLES_UPDATE: "buddyVariablesUpdate",
    BUDDY_MESSAGE: "buddyMessage"
}, SFS2X.Exceptions = {}, SFS2X.Exceptions.SFSError = Class.extend({
    init: function(e) {
        this._messsage = e
    },
    getMessage: function() {
        return this._messsage
    }
}), SFS2X.Exceptions.SFSValidationError = SFS2X.Exceptions.SFSError.extend({
    init: function(e, t) {
        this._super(e), this._errrors = t
    },
    getErrors: function() {
        return this._errrors
    }
}), SFS2X.LogLevel = {
    DEBUG: 0,
    INFO: 1,
    WARN: 2,
    ERROR: 3
}, SFS2X._Logger = function() {
    this.isAvailable = null != console, this.level = SFS2X.LogLevel.INFO
}, SFS2X.Logger = new SFS2X._Logger, SFS2X._Logger.prototype.setLevel = function(e) {
    e < SFS2X.LogLevel.DEBUG || e > SFS2X.LogLevel.ERROR || (this.level = e)
}, SFS2X._Logger.prototype.debug = function(e) {
    this.isAvailable && (this.level, SFS2X.LogLevel.DEBUG)
}, SFS2X._Logger.prototype.info = function(e) {
    this.isAvailable && (this.level, SFS2X.LogLevel.INFO)
}, SFS2X._Logger.prototype.warn = function(e) {
    this.isAvailable && (this.level, SFS2X.LogLevel.WARN)
}, SFS2X._Logger.prototype.error = function(e) {
    this.isAvailable
}, SFS2X.Managers = {}, SFS2X.Managers.UserManager = Class.extend({
    init: function(e) {
        this._sfs = e, this._usersById = new SFS2X.Utils.HashTable, this._usersByName = new SFS2X.Utils.HashTable
    },
    containsUserName: function(e) {
        return this._usersByName.hasItem(e)
    },
    containsUserId: function(e) {
        return this._usersById.hasItem(e)
    },
    containsUser: function(e) {
        return this._usersById.hasItem(e.id)
    },
    getUserById: function(e) {
        return this._usersById.getItem(e)
    },
    getUserByName: function(e) {
        return this._usersByName.getItem(e)
    },
    getUserCount: function() {
        return this._usersById.length
    },
    getUserList: function() {
        return this._usersById.values()
    },
    _addUser: function(e) {
        this._usersById.hasItem(e.id) && SFS2X.Logger.warn("Unexpected, duplicate user in UserManager: " + e.toString()), this.__addUser(e)
    },
    __addUser: function(e) {
        this._usersByName.setItem(e.name, e), this._usersById.setItem(e.id, e)
    },
    _removeUser: function(e) {
        this.__removeUser(e)
    },
    __removeUser: function(e) {
        this._usersById.removeItem(e.id), this._usersByName.removeItem(e.name)
    },
    _removeUserById: function() {
        this._usersById.removeItem(user.id), this._usersByName.removeItem(user.name)
    },
    _clearAll: function() {
        this._usersById.clear(), this._usersByName.clear()
    }
}), SFS2X.Managers.GlobalUserManager = SFS2X.Managers.UserManager.extend({
    init: function(e) {
        this._super(e), this._roomRefCount = []
    },
    _addUser: function(e) {
        null == this._roomRefCount[e] ? this._roomRefCount[e] = 1 : this._roomRefCount[e]++, this.__addUser(e)
    },
    _removeUser: function(e) {
        null != this._roomRefCount ? 1 > this._roomRefCount[e] ? SFS2X.Logger.warn("GlobalUserManager RefCount is already at zero. User: " + e) : (this._roomRefCount[e]--, 0 == this._roomRefCount[e] && (this.__removeUser(e), delete this._roomRefCount[e])) : SFS2X.Logger.warn("Can't remove User from GlobalUserManager. RefCount missing. User: " + e)
    },
    dumpRefCount: function() {}
}), SFS2X.Managers.RoomManager = function(e) {
    this._sfs = e, this._ownerZone = null, this._groups = [], this._roomsById = new SFS2X.Utils.HashTable, this._roomsByName = new SFS2X.Utils.HashTable
}, SFS2X.Managers.RoomManager.prototype.getRoomGroups = function() {
    return this._groups
}, SFS2X.Managers.RoomManager.prototype.containsGroup = function(e) {
    return -1 < this._groups.indexOf(e)
}, SFS2X.Managers.RoomManager.prototype.containsRoom = function(e) {
    return "number" == typeof e ? this._roomsById.hasItem(e) : this._roomsByName.hasItem(e)
}, SFS2X.Managers.RoomManager.prototype.containsRoomInGroup = function(e, t) {
    var s, n = this.getRoomListFromGroup(t),
        r = !1,
        i = "number" == typeof e;
    for (s in n) {
        var o = n[s];
        if (o instanceof SFS2X.Entities.SFSRoom)
            if (i) {
                if (o.id == e) {
                    r = !0;
                    break
                }
            } else if (o.name == e) {
            r = !0;
            break
        }
    }
    return r
}, SFS2X.Managers.RoomManager.prototype.getRoomById = function(e) {
    return this._roomsById.getItem(e)
}, SFS2X.Managers.RoomManager.prototype.getRoomByName = function(e) {
    return this._roomsByName.getItem(e)
}, SFS2X.Managers.RoomManager.prototype.getRoomList = function() {
    return this._roomsById.values()
}, SFS2X.Managers.RoomManager.prototype.getRoomCount = function() {
    return this._roomsById.length
}, SFS2X.Managers.RoomManager.prototype.getRoomListFromGroup = function(e) {
    var t, s = [];
    for (t in this._roomsById.items) {
        var n = this._roomsById.items[t];
        n instanceof SFS2X.Entities.SFSRoom && n.groupId == e && s.push(n)
    }
    return s
}, SFS2X.Managers.RoomManager.prototype.getJoinedRooms = function() {
    var e, t = [];
    for (e in this._roomsById.items) {
        var s = this._roomsById.items[e];
        s instanceof SFS2X.Entities.SFSRoom && s.isJoined && t.push(s)
    }
    return t
}, SFS2X.Managers.RoomManager.prototype.getUserRooms = function(e) {
    var t, s = [];
    for (t in this._roomsById.items) {
        var n = this._roomsById.items[t];
        n instanceof SFS2X.Entities.SFSRoom && n.containsUser(e) && s.push(n)
    }
    return s
}, SFS2X.Managers.RoomManager.prototype._addRoom = function(e, t) {
    null == t && (t = !0), this._roomsById.setItem(e.id, e), this._roomsByName.setItem(e.name, e), t ? this.containsGroup(e.groupId) || this._addGroup(e.groupId) : e._isManaged = !1
}, SFS2X.Managers.RoomManager.prototype._replaceRoom = function(e, t) {
    null == t && (t = !0);
    var s = this.getRoomById(e.id);
    return null != s ? (s._merge(e), s) : (this._addRoom(e, t), e)
}, SFS2X.Managers.RoomManager.prototype._removeRoom = function(e) {
    this._roomsById.removeItem(e.id), this._roomsByName.removeItem(e.name)
}, SFS2X.Managers.RoomManager.prototype._removeRoomById = function(e) {
    null != (e = this.getRoomById(e)) && this._removeRoom(e)
}, SFS2X.Managers.RoomManager.prototype._removeRoomByName = function(e) {
    null != (e = this.getRoomByName(e)) && this._removeRoom(e)
}, SFS2X.Managers.RoomManager.prototype._changeRoomName = function(e, t) {
    var s = e.name;
    e.name = t, this._roomsByName.setItem(t, e), this._roomsByName.removeItem(s)
}, SFS2X.Managers.RoomManager.prototype._changeRoomPasswordState = function(e, t) {
    e.isPasswordProtected = t
}, SFS2X.Managers.RoomManager.prototype._changeRoomCapacity = function(e, t, s) {
    e.maxUsers = t, e.maxSpectators = s
}, SFS2X.Managers.RoomManager.prototype._addGroup = function(e) {
    this._groups.push(e)
}, SFS2X.Managers.RoomManager.prototype._removeGroup = function(e) {
    SFS2X.Utils.ArrayUtil.removeItem(this._groups, e);
    var t;
    e = this.getRoomListFromGroup(e);
    for (t in e) {
        var s = e[t];
        s instanceof SFS2X.Entities.SFSRoom && (s.isJoined ? s._isManaged = !1 : this._removeRoom(s))
    }
}, SFS2X.Managers.RoomManager.prototype._removeUser = function(e) {
    for (var t in this._roomsById.items) {
        var s = this._roomsById.items[t];
        s instanceof SFS2X.Entities.SFSRoom && s.containsUser(e) && s._removeUser(e)
    }
}, SFS2X.Managers.BuddyManager = function(e) {
    this._sfs = e, this._buddiesByName = [], this._myVariables = [], this._inited = !1, this._buddyStates = []
}, SFS2X.Managers.BuddyManager.prototype.isInited = function() {
    return this._inited
}, SFS2X.Managers.BuddyManager.prototype.containsBuddy = function(e) {
    return null != this.getBuddyByName(e)
}, SFS2X.Managers.BuddyManager.prototype.getBuddyById = function(e) {
    if (-1 < e)
        for (var t in this._buddiesByName) {
            var s = this._buddiesByName[t];
            if (s instanceof SFS2X.Entities.SFSBuddy && s.id == e) return s
        }
    return null
}, SFS2X.Managers.BuddyManager.prototype.getBuddyByName = function(e) {
    return this._buddiesByName[e]
}, SFS2X.Managers.BuddyManager.prototype.getBuddyByNickName = function(e) {
    for (var t in this._buddiesByName) {
        var s = this._buddiesByName[t];
        if (s instanceof SFS2X.Entities.SFSBuddy && s.nickName == e) return s
    }
    return null
}, SFS2X.Managers.BuddyManager.prototype.getOfflineBuddies = function() {
    var e, t = [];
    for (e in this._buddiesByName) {
        var s = this._buddiesByName[e];
        s instanceof SFS2X.Entities.SFSBuddy && !s.isOnline() && t.push(s)
    }
    return t
}, SFS2X.Managers.BuddyManager.prototype.getOnlineBuddies = function() {
    var e, t = [];
    for (e in this._buddiesByName) {
        var s = this._buddiesByName[e];
        s instanceof SFS2X.Entities.SFSBuddy && s.isOnline() && t.push(s)
    }
    return t
}, SFS2X.Managers.BuddyManager.prototype.getBuddyList = function() {
    return SFS2X.Utils.ArrayUtil.objToArray(this._buddiesByName)
}, SFS2X.Managers.BuddyManager.prototype.getMyVariable = function(e) {
    return this._myVariables[e]
}, SFS2X.Managers.BuddyManager.prototype.getMyVariables = function() {
    return SFS2X.Utils.ArrayUtil.objToArray(this._myVariables)
}, SFS2X.Managers.BuddyManager.prototype.getMyOnlineState = function() {
    if (!this._inited) return !1;
    var e = !0,
        t = this.getMyVariable(SFS2X.Entities.Variables.ReservedBuddyVariables.BV_ONLINE);
    return null != t && (e = t.value), e
}, SFS2X.Managers.BuddyManager.prototype.getMyNickName = function() {
    var e = this.getMyVariable(SFS2X.Entities.Variables.ReservedBuddyVariables.BV_NICKNAME);
    return null != e ? e.value : null
}, SFS2X.Managers.BuddyManager.prototype.getMyState = function() {
    var e = this.getMyVariable(SFS2X.Entities.Variables.ReservedBuddyVariables.BV_STATE);
    return null != e ? e.value : null
}, SFS2X.Managers.BuddyManager.prototype.getBuddyStates = function() {
    return this._buddyStates
}, SFS2X.Managers.BuddyManager.prototype._setInited = function() {
    this._inited = !0
}, SFS2X.Managers.BuddyManager.prototype._addBuddy = function(e) {
    this._buddiesByName[e.name] = e
}, SFS2X.Managers.BuddyManager.prototype._clearAll = function() {
    this._buddiesByName = []
}, SFS2X.Managers.BuddyManager.prototype._removeBuddyById = function(e) {
    return null != (e = this.getBuddyById(e)) && delete this._buddiesByName[e.name], e
}, SFS2X.Managers.BuddyManager.prototype._removeBuddyByName = function(e) {
    var t = this.getBuddyByName(e);
    return null != t && delete this._buddiesByName[e], t
}, SFS2X.Managers.BuddyManager.prototype._setMyVariables = function(e) {
    for (var t = 0; t < e.length; t++) this._setMyVariable(e[t])
}, SFS2X.Managers.BuddyManager.prototype._setMyVariable = function(e) {
    e.isNull() ? delete this._myVariables[e.name] : this._myVariables[e.name] = e
}, SFS2X.Managers.BuddyManager.prototype._setMyOnlineState = function(e) {
    e = new SFS2X.Entities.Variables.SFSBuddyVariable(SFS2X.Entities.Variables.ReservedBuddyVariables.BV_ONLINE, e), this._setMyVariable(e)
}, SFS2X.Managers.BuddyManager.prototype._setMyNickName = function(e) {
    e = new SFS2X.Entities.Variables.SFSBuddyVariable(SFS2X.Entities.Variables.ReservedBuddyVariables.BV_NICKNAME, e), this._setMyVariable(e)
}, SFS2X.Managers.BuddyManager.prototype._setMyState = function(e) {
    e = new SFS2X.Entities.Variables.SFSBuddyVariable(SFS2X.Entities.Variables.ReservedBuddyVariables.BV_STATE, e), this._setMyVariable(e)
}, SFS2X.Managers.BuddyManager.prototype._setBuddyStates = function(e) {
    this._buddyStates = e
}, SFS2X.Requests = {}, SFS2X.Requests.System = {}, SFS2X.Requests.MMO = {}, SFS2X.Requests.BuddyList = {}, SFS2X.Requests.Game = {}, SFS2X.Requests._BaseRequest = Class.extend({
    init: function(e) {
        this._reqObj = {}, this._id = e, this._targetController = 0, this._log = SFS2X.Logger
    },
    getMessage: function() {
        return {
            a: this._id,
            c: this._targetController,
            p: this._reqObj
        }
    },
    validate: function() {
        this._log.error("BaseRequest.validate = no child-class implementation found!")
    },
    execute: function() {
        this._log.error("BaseRequest.execute = no child-class implementation found!")
    }
}), SFS2X.Requests.System.HandshakeRequest = SFS2X.Requests._BaseRequest.extend({
    init: function(e, t, s) {
        this._super(SFS2X.Requests.Handshake), this._apiVersion = e, this._clientDetails = t, this._reconnectionToken = s
    },
    validate: function() {},
    execute: function() {
        this._reqObj[this.constructor.KEY_API] = this._apiVersion, this._reqObj[this.constructor.KEY_CLIENT_TYPE] = this._clientDetails, null != this._reconnectionToken && (this.reqObj[this.constructor.KEY_RECONNECTION_TOKEN] = this._reconnectionToken)
    }
}), SFS2X.Requests.System.HandshakeRequest.KEY_SESSION_TOKEN = "tk", SFS2X.Requests.System.HandshakeRequest.KEY_API = "api", SFS2X.Requests.System.HandshakeRequest.KEY_COMPRESSION_THRESHOLD = "ct", SFS2X.Requests.System.HandshakeRequest.KEY_RECONNECTION_TOKEN = "rt", SFS2X.Requests.System.HandshakeRequest.KEY_CLIENT_TYPE = "cl", SFS2X.Requests.System.HandshakeRequest.KEY_MAX_MESSAGE_SIZE = "ms", SFS2X.Requests.System.LoginRequest = SFS2X.Requests._BaseRequest.extend({
    init: function(e, t, s, n) {
        this._super(SFS2X.Requests.Login), this._userName = e, this._password = t, this._params = s, this._zoneName = n
    },
    validate: function(e) {
        if (null != e.mySelf) throw new SFS2X.Exceptions.SFSValidationError("LoginRequest error", ["You are already logged in; logout before attempting a new login"]);
        if (e = null != e.config && null != e.config.zone ? e.config.zone : null, null != this._zoneName && (e = this._zoneName), null == e || 0 == e.length) throw new SFS2X.Exceptions.SFSValidationError("LoginRequest Error", ["Missing Zone name"]);
        this._zoneName = e, null == this._userName && (this._userName = ""), null == this._password && (this._password = "")
    },
    execute: function(e) {
        this._reqObj[this.constructor.KEY_ZONE_NAME] = this._zoneName, this._reqObj[this.constructor.KEY_USER_NAME] = this._userName, this._reqObj[this.constructor.KEY_PASSWORD] = 0 < this._password.length ? hex_md5(e.sessionToken + this._password) : "", null != this._params && (this._reqObj[this.constructor.KEY_PARAMS] = this._params)
    }
}), SFS2X.Requests.System.LoginRequest.KEY_ZONE_NAME = "zn", SFS2X.Requests.System.LoginRequest.KEY_USER_NAME = "un", SFS2X.Requests.System.LoginRequest.KEY_PASSWORD = "pw", SFS2X.Requests.System.LoginRequest.KEY_PARAMS = "p", SFS2X.Requests.System.LoginRequest.KEY_PRIVILEGE_ID = "pi", SFS2X.Requests.System.LoginRequest.KEY_ID = "id", SFS2X.Requests.System.LoginRequest.KEY_ROOMLIST = "rl", SFS2X.Requests.System.LoginRequest.KEY_RECONNECTION_SECONDS = "rs", SFS2X.Requests.System.LogoutRequest = SFS2X.Requests._BaseRequest.extend({
    init: function() {
        this._super(SFS2X.Requests.Logout)
    },
    validate: function(e) {
        console.log('e')
        console.log(e)
        if (null == e.mySelf) throw new SFS2X.Exceptions.SFSValidationError("LogoutRequest error", ["You are not logged in"])
    },
    execute: function() {}
}), SFS2X.Requests.System.LogoutRequest.KEY_ZONE_NAME = "zn", SFS2X.Requests.System.JoinRoomRequest = SFS2X.Requests._BaseRequest.extend({
    init: function(e, t, s, n) {
        this._super(SFS2X.Requests.JoinRoom), "string" == typeof e ? this._rName = e : "number" == typeof e ? this._rId = e : e instanceof SFS2X.Entities.SFSRoom && (this._rId = e.id, this._rName = e.name), this._password = t, this._roomIdToLeave = s, this._asSpectator = "boolean" == typeof n && n
    },
    validate: function() {
        if (null == this._rId && null == this._rName) throw new SFS2X.Exceptions.SFSValidationError("JoinRoomRequest Error", ["Missing Room id or name, please provide one of the two or an existing Room object"])
    },
    execute: function(e) {
        e._isJoining = !0, 0 <= this._rId ? this._reqObj[this.constructor.KEY_ROOM_ID] = this._rId : null != this._rName && (this._reqObj[this.constructor.KEY_ROOM_NAME] = this._rName), null != this._password && (this._reqObj[this.constructor.KEY_PASS] = this._password), null != this._roomIdToLeave && (this._reqObj[this.constructor.KEY_ROOM_TO_LEAVE] = this._roomIdToLeave), this._asSpectator && (this._reqObj[this.constructor.KEY_AS_SPECTATOR] = this._asSpectator)
    }
}), SFS2X.Requests.System.JoinRoomRequest.KEY_ROOM = "r", SFS2X.Requests.System.JoinRoomRequest.KEY_USER_LIST = "ul", SFS2X.Requests.System.JoinRoomRequest.KEY_ROOM_NAME = "n", SFS2X.Requests.System.JoinRoomRequest.KEY_ROOM_ID = "i", SFS2X.Requests.System.JoinRoomRequest.KEY_PASS = "p", SFS2X.Requests.System.JoinRoomRequest.KEY_ROOM_TO_LEAVE = "rl", SFS2X.Requests.System.JoinRoomRequest.KEY_AS_SPECTATOR = "sp", SFS2X.Requests.System.CreateRoomRequest = SFS2X.Requests._BaseRequest.extend({
    init: function(e, t, s) {
        this._super(SFS2X.Requests.CreateRoom), this._settings = e, this._autoJoin = "boolean" == typeof t && t, this._roomToLeave = s
    },
    validate: function() {
        var e = [];
        if ((null == this._settings.name || 0 == this._settings.name.length) && e.push("Missing Room name"), 0 >= this._settings.maxUsers && e.push("Max number of users must be > 0"), null != this._settings.extension && ((null == this._settings.extension.className || 0 == this._settings.extension.className.length) && e.push("Missing Extension class name"), (null == this._settings.extension.id || 0 == this._settings.extension.id.length) && e.push("Missing Extension id")), this._settings instanceof SFS2X.Requests.MMO.MMORoomSettings && (null == this._settings.defaultAOI && e.push("Missing default AoI (Area of Interest)"), null != this._settings.mapLimits && (null == this._settings.mapLimits.lowerLimit || null == this._settings.mapLimits.higherLimit) && e.push("Map limits must be both defined")), 0 < e.length) throw new SFS2X.Exceptions.SFSValidationError("CreateRoomRequest Error", e)
    },
    execute: function() {
        if (this._reqObj[this.constructor.KEY_NAME] = this._settings.name, this._reqObj[this.constructor.KEY_GROUP_ID] = this._settings.groupId, this._reqObj[this.constructor.KEY_PASSWORD] = this._settings.password, this._reqObj[this.constructor.KEY_ISGAME] = this._settings.isGame, this._reqObj[this.constructor.KEY_MAXUSERS] = this._settings.maxUsers, this._reqObj[this.constructor.KEY_MAXSPECTATORS] = this._settings.maxSpectators, this._reqObj[this.constructor.KEY_MAXVARS] = this._settings.maxVariables, null != this._settings.variables && 0 < this._settings.variables.length) {
            var e, t = [];
            for (e in this._settings.variables) {
                var s = this._settings.variables[e];
                s instanceof SFS2X.Entities.Variables.SFSRoomVariable && t.push(s.toArray())
            }
            this._reqObj[this.constructor.KEY_ROOMVARS] = t
        }
        null != this._settings.permissions && ((t = [])
            .push(this._settings.permissions.allowNameChange), t.push(this._settings.permissions.allowPasswordStateChange), t.push(this._settings.permissions.allowPublicMessages), t.push(this._settings.permissions.allowResizing), this._reqObj[this.constructor.KEY_PERMISSIONS] = t), null != this._settings.events && ((t = [])
            .push(this._settings.events.allowUserEnter), t.push(this._settings.events.allowUserExit), t.push(this._settings.events.allowUserCountChange), t.push(this._settings.events.allowUserVariablesUpdate), this._reqObj[this.constructor.KEY_EVENTS] = t), null != this._settings.extension && (this._reqObj[this.constructor.KEY_EXTID] = this._settings.extension.id, this._reqObj[this.constructor.KEY_EXTCLASS] = this._settings.extension.className, null != this._settings.extension.propertiesFile && 0 < this._settings.extension.propertiesFile.length && (this._reqObj[this.constructor.KEY_EXTPROP] = this._settings.extension.propertiesFile)), this._settings instanceof SFS2X.Requests.MMO.MMORoomSettings && (this._reqObj[this.constructor.KEY_MMO_DEFAULT_AOI] = this._settings.defaultAOI._toArray(), null != this._settings.mapLimits && (this._reqObj[this.constructor.KEY_MMO_MAP_LOW_LIMIT] = this._settings.mapLimits.lowerLimit._toArray(), this._reqObj[this.constructor.KEY_MMO_MAP_HIGH_LIMIT] = this._settings.mapLimits.higherLimit._toArray()), this._reqObj[this.constructor.KEY_MMO_USER_MAX_LIMBO_SECONDS] = this._settings.userMaxLimboSeconds, this._reqObj[this.constructor.KEY_MMO_PROXIMITY_UPDATE_MILLIS] = this._settings.proximityListUpdateMillis, this._reqObj[this.constructor.KEY_MMO_SEND_ENTRY_POINT] = this._settings.sendAOIEntryPoint), this._reqObj[this.constructor.KEY_AUTOJOIN] = this._autoJoin, null != this._roomToLeave && (this._reqObj[this.constructor.KEY_ROOM_TO_LEAVE] = this._roomToLeave.id)
    }
}), SFS2X.Requests.System.CreateRoomRequest.KEY_ROOM = "r", SFS2X.Requests.System.CreateRoomRequest.KEY_NAME = "n", SFS2X.Requests.System.CreateRoomRequest.KEY_PASSWORD = "p", SFS2X.Requests.System.CreateRoomRequest.KEY_GROUP_ID = "g", SFS2X.Requests.System.CreateRoomRequest.KEY_ISGAME = "ig", SFS2X.Requests.System.CreateRoomRequest.KEY_MAXUSERS = "mu", SFS2X.Requests.System.CreateRoomRequest.KEY_MAXSPECTATORS = "ms", SFS2X.Requests.System.CreateRoomRequest.KEY_MAXVARS = "mv", SFS2X.Requests.System.CreateRoomRequest.KEY_ROOMVARS = "rv", SFS2X.Requests.System.CreateRoomRequest.KEY_PERMISSIONS = "pm", SFS2X.Requests.System.CreateRoomRequest.KEY_EVENTS = "ev", SFS2X.Requests.System.CreateRoomRequest.KEY_EXTID = "xn", SFS2X.Requests.System.CreateRoomRequest.KEY_EXTCLASS = "xc", SFS2X.Requests.System.CreateRoomRequest.KEY_EXTPROP = "xp", SFS2X.Requests.System.CreateRoomRequest.KEY_AUTOJOIN = "aj", SFS2X.Requests.System.CreateRoomRequest.KEY_ROOM_TO_LEAVE = "rl", SFS2X.Requests.System.CreateRoomRequest.KEY_MMO_DEFAULT_AOI = "maoi", SFS2X.Requests.System.CreateRoomRequest.KEY_MMO_MAP_LOW_LIMIT = "mllm", SFS2X.Requests.System.CreateRoomRequest.KEY_MMO_MAP_HIGH_LIMIT = "mlhm", SFS2X.Requests.System.CreateRoomRequest.KEY_MMO_USER_MAX_LIMBO_SECONDS = "muls", SFS2X.Requests.System.CreateRoomRequest.KEY_MMO_PROXIMITY_UPDATE_MILLIS = "mpum", SFS2X.Requests.System.CreateRoomRequest.KEY_MMO_SEND_ENTRY_POINT = "msep", SFS2X.Requests.System.GenericMessageRequest = SFS2X.Requests._BaseRequest.extend({
    init: function() {
        this._super(SFS2X.Requests.GenericMessage), this._type = -1, this._recipient = this._params = this._message = this._user = this._room = null, this._sendMode = -1
    },
    validate: function(e) {
        if (0 > this._type) throw new SFS2X.Exceptions.SFSValidationError("GenericMessageRequest Error", ["Unsupported message type: " + this._type]);
        var t = [];
        switch (this._type) {
            case SFS2X.Requests.GenericMessageType.PUBLIC_MSG:
                this._validatePublicMessage(e, t);
                break;
            case SFS2X.Requests.GenericMessageType.PRIVATE_MSG:
                this._validatePrivateMessage(e, t);
                break;
            case SFS2X.Requests.GenericMessageType.OBJECT_MSG:
                this._validateObjectMessage(e, t);
                break;
            case SFS2X.Requests.GenericMessageType.BUDDY_MSG:
                this._validateBuddyMessage(e, t);
                break;
            default:
                this._validateSuperUserMessage(e, t)
        }
        if (0 < t.length) throw new SFS2X.Exceptions.SFSValidationError("GenericMessageRequest Error", t)
    },
    execute: function(e) {
        switch (this._reqObj[SFS2X.Requests.System.GenericMessageRequest.KEY_MESSAGE_TYPE] = this._type, this._type) {
            case SFS2X.Requests.GenericMessageType.PUBLIC_MSG:
                this._executePublicMessage(e);
                break;
            case SFS2X.Requests.GenericMessageType.PRIVATE_MSG:
                this._executePrivateMessage(e);
                break;
            case SFS2X.Requests.GenericMessageType.OBJECT_MSG:
                this._executeObjectMessage(e);
                break;
            case SFS2X.Requests.GenericMessageType.BUDDY_MSG:
                this._executeBuddyMessage(e);
                break;
            default:
                this._executeSuperUserMessage(e)
        }
    },
    _validatePublicMessage: function(e, t) {
        (null == this._message || 0 == this._message.length) && t.push("Public message is empty"), null != this._room && !e.mySelf.isJoinedInRoom(this._room) && t.push("You are not joined in the target Room: " + this._room)
    },
    _validatePrivateMessage: function(e, t) {
        (null == this._message || 0 == this._message.length) && t.push("Private message is empty"), 0 > this._recipient && t.push("Invalid recipient id: " + this._recipient)
    },
    _validateObjectMessage: function(e, t) {
        null == this._params && t.push("Object message is null")
    },
    _validateBuddyMessage: function(e, t) {
        e.buddyManager.isInited || t.push("Buddy List not yet initialized; please send an InitBuddyRequest first"), 0 == e.buddyManager.myOnlineState && t.push("Can't send messages while you are offline in the Buddy List system"), (null == this._message || 0 == this._message.length) && t.push("Buddy message is empty"), 0 > this._recipient && t.push("Recipient is offline or not in your Buddy List")
    },
    _validateSuperUserMessage: function(e, t) {
        switch ((null == this._message || 0 == this._message.length) && t.push("Moderator message is empty"), this._sendMode) {
            case SFS2X.Requests.MessageRecipientMode.TO_USER:
                this._recipient instanceof SFS2X.Entities.SFSUser || t.push("SFSUser object expected as recipient");
                break;
            case SFS2X.Requests.MessageRecipientMode.TO_ROOM:
                this._recipient instanceof SFS2X.Entities.SFSRoom || t.push("SFSRoom object expected as recipient");
                break;
            case SFS2X.Requests.MessageRecipientMode.TO_GROUP:
                "string" != typeof this._recipient && t.push("String object (the groupId) expected as recipient")
        }
    },
    _executePublicMessage: function(e) {
        if (null == this._room && (this._room = e.lastJoinedRoom), null == this._room) throw new SFS2X.Exceptions.SFSError("User should be joined in a Room in order to send a public message");
        this._reqObj[SFS2X.Requests.System.GenericMessageRequest.KEY_ROOM_ID] = this._room.id, this._reqObj[SFS2X.Requests.System.GenericMessageRequest.KEY_USER_ID] = e.mySelf.id, this._reqObj[SFS2X.Requests.System.GenericMessageRequest.KEY_MESSAGE] = this._message, null != this._params && (this._reqObj[SFS2X.Requests.System.GenericMessageRequest.KEY_XTRA_PARAMS] = this._params)
    },
    _executePrivateMessage: function() {
        this._reqObj[SFS2X.Requests.System.GenericMessageRequest.KEY_RECIPIENT] = this._recipient, this._reqObj[SFS2X.Requests.System.GenericMessageRequest.KEY_MESSAGE] = this._message, null != this._params && (this._reqObj[SFS2X.Requests.System.GenericMessageRequest.KEY_XTRA_PARAMS] = this._params)
    },
    _executeBuddyMessage: function() {
        this._reqObj[SFS2X.Requests.System.GenericMessageRequest.KEY_RECIPIENT] = this._recipient, this._reqObj[SFS2X.Requests.System.GenericMessageRequest.KEY_MESSAGE] = this._message, null != this._params && (this._reqObj[SFS2X.Requests.System.GenericMessageRequest.KEY_XTRA_PARAMS] = this._params)
    },
    _executeSuperUserMessage: function() {
        switch (this._reqObj[SFS2X.Requests.System.GenericMessageRequest.KEY_MESSAGE] = this._message, null != this._params && (this._reqObj[SFS2X.Requests.System.GenericMessageRequest.KEY_XTRA_PARAMS] = this._params), this._reqObj[SFS2X.Requests.System.GenericMessageRequest.KEY_RECIPIENT_MODE] = this._sendMode, this._sendMode) {
            case SFS2X.Requests.MessageRecipientMode.TO_USER:
            case SFS2X.Requests.MessageRecipientMode.TO_ROOM:
                this._reqObj[SFS2X.Requests.System.GenericMessageRequest.KEY_RECIPIENT] = this._recipient.id;
                break;
            case SFS2X.Requests.MessageRecipientMode.TO_GROUP:
                this._reqObj[SFS2X.Requests.System.GenericMessageRequest.KEY_RECIPIENT] = this._recipient
        }
    },
    _executeObjectMessage: function(e) {
        if (null == this._room && (this._room = e.lastJoinedRoom), null == this._room) throw new SFS2X.Exceptions.SFSError("User should be joined in a Room in order to send an object message");
        if (e = [], null != this._recipient && this._recipient instanceof Array) {
            var t = this._recipient;
            if (t.length > this._room.capacity) throw new SFS2X.Exceptions.SFSError("The number of recipients is bigger than the target Room capacity: " + t.length);
            for (var s in t) {
                var n = t[s];
                n instanceof SFS2X.Entities.SFSUser ? e.push(n.id) : this._log.warn("Bad recipient in ObjectMessage recipient list: " + typeof n + "; expected type: SFSUser")
            }
        }
        this._reqObj[SFS2X.Requests.System.GenericMessageRequest.KEY_ROOM_ID] = this._room.id, this._reqObj[SFS2X.Requests.System.GenericMessageRequest.KEY_XTRA_PARAMS] = this._params, 0 < e.length && (this._reqObj[SFS2X.Requests.System.GenericMessageRequest.KEY_RECIPIENT] = e)
    }
}), SFS2X.Requests.System.GenericMessageRequest.KEY_ROOM_ID = "r", SFS2X.Requests.System.GenericMessageRequest.KEY_USER_ID = "u", SFS2X.Requests.System.GenericMessageRequest.KEY_MESSAGE = "m", SFS2X.Requests.System.GenericMessageRequest.KEY_MESSAGE_TYPE = "t", SFS2X.Requests.System.GenericMessageRequest.KEY_RECIPIENT = "rc", SFS2X.Requests.System.GenericMessageRequest.KEY_RECIPIENT_MODE = "rm", SFS2X.Requests.System.GenericMessageRequest.KEY_XTRA_PARAMS = "p", SFS2X.Requests.System.GenericMessageRequest.KEY_SENDER_DATA = "sd", SFS2X.Requests.System.ChangeRoomNameRequest = SFS2X.Requests._BaseRequest.extend({
    init: function(e, t) {
        this._super(SFS2X.Requests.ChangeRoomName), this._room = e, this._newName = t
    },
    validate: function() {
        var e = [];
        if (null == this._room && e.push("Provided Room is null"), (null == this._newName || 0 == this._newName.length) && e.push("Invalid new room name: it must be a non-null and non-empty string"), 0 < e.length) throw new SFS2X.Exceptions.SFSValidationError("ChangeRoomNameRequest Error", e)
    },
    execute: function() {
        this._reqObj[this.constructor.KEY_ROOM] = this._room.id, this._reqObj[this.constructor.KEY_NAME] = this._newName
    }
}), SFS2X.Requests.System.ChangeRoomNameRequest.KEY_ROOM = "r", SFS2X.Requests.System.ChangeRoomNameRequest.KEY_NAME = "n", SFS2X.Requests.System.ChangeRoomPasswordStateRequest = SFS2X.Requests._BaseRequest.extend({
    init: function(e, t) {
        this._super(SFS2X.Requests.ChangeRoomPassword), this._room = e, this._newPass = t
    },
    validate: function() {
        var e = [];
        if (null == this._room && e.push("Provided Room is null"), null == this._newPass && e.push("Invalid new room name: it must be a non-null string"), 0 < e.length) throw new SFS2X.Exceptions.SFSValidationError("ChangeRoomPasswordStateRequest Error", e)
    },
    execute: function() {
        this._reqObj[this.constructor.KEY_ROOM] = this._room.id, this._reqObj[this.constructor.KEY_PASS] = this._newPass
    }
}), SFS2X.Requests.System.ChangeRoomPasswordStateRequest.KEY_ROOM = "r", SFS2X.Requests.System.ChangeRoomPasswordStateRequest.KEY_PASS = "p", SFS2X.Requests.System.ObjectMessageRequest = SFS2X.Requests.System.GenericMessageRequest.extend({
    init: function(e, t, s) {
        this._super(), this._type = SFS2X.Requests.GenericMessageType.OBJECT_MSG, this._params = e, this._room = t, this._recipient = s
    }
}), SFS2X.Requests.System.SetRoomVariablesRequest = SFS2X.Requests._BaseRequest.extend({
    init: function(e, t) {
        this._super(SFS2X.Requests.SetRoomVariables), this._roomVariables = e, this._room = t
    },
    validate: function(e) {
        var t = [];
        if (null != this._room ? this._room.containsUser(e.mySelf) || t.push("You are not joined in the target Room") : null == e.lastJoinedRoom && t.push("You are not joined in any Room"), (null == this._roomVariables || 0 == this._roomVariables.length) && t.push("No variables were specified"), 0 < t.length) throw new SFS2X.Exceptions.SFSValidationError("SetRoomVariablesRequest Error", t)
    },
    execute: function(e) {
        var t, s = [];
        for (t in this._roomVariables) {
            var n = this._roomVariables[t];
            n instanceof SFS2X.Entities.Variables.SFSRoomVariable && s.push(n.toArray())
        }
        null == this._room && (this._room = e.lastJoinedRoom), this._reqObj[this.constructor.KEY_VAR_LIST] = s, this._reqObj[this.constructor.KEY_VAR_ROOM] = this._room.id
    }
}), SFS2X.Requests.System.SetRoomVariablesRequest.KEY_VAR_ROOM = "r", SFS2X.Requests.System.SetRoomVariablesRequest.KEY_VAR_LIST = "vl", SFS2X.Requests.System.SetUserVariablesRequest = SFS2X.Requests._BaseRequest.extend({
    init: function(e) {
        this._super(SFS2X.Requests.SetUserVariables), this._userVariables = e
    },
    validate: function() {
        var e = [];
        if ((null == this._userVariables || 0 == this._userVariables.length) && e.push("No variables were specified"), 0 < e.length) throw new SFS2X.Exceptions.SFSValidationError("SetUserVariablesRequest Error", e)
    },
    execute: function() {
        var e, t = [];
        for (e in this._userVariables) {
            var s = this._userVariables[e];
            s instanceof SFS2X.Entities.Variables.SFSUserVariable && t.push(s.toArray())
        }
        this._reqObj[this.constructor.KEY_VAR_LIST] = t
    }
}), SFS2X.Requests.System.SetUserVariablesRequest.KEY_USER = "u", SFS2X.Requests.System.SetUserVariablesRequest.KEY_VAR_LIST = "vl", SFS2X.Requests.System.ExtensionRequest = SFS2X.Requests._BaseRequest.extend({
    init: function(e, t, s) {
        this._super(SFS2X.Requests.CallExtension), this._targetController = 1, this._extCmd = e, this._params = t, this._room = s, null == this._params && (this._params = {})
    },
    validate: function() {
        var e = [];
        if ((null == this._extCmd || 0 == this._extCmd.length) && e.push("Missing extension command"), 0 < e.length) throw new SFS2X.Exceptions.SFSValidationError("ExtensionRequest Error", e)
    },
    execute: function() {
        this._reqObj[this.constructor.KEY_CMD] = this._extCmd, this._reqObj[this.constructor.KEY_ROOM] = null == this._room ? -1 : this._room.id, this._reqObj[this.constructor.KEY_PARAMS] = this._params
    }
}), SFS2X.Requests.System.ExtensionRequest.KEY_CMD = "c", SFS2X.Requests.System.ExtensionRequest.KEY_PARAMS = "p", SFS2X.Requests.System.ExtensionRequest.KEY_ROOM = "r", SFS2X.Requests.System.LeaveRoomRequest = SFS2X.Requests._BaseRequest.extend({
    init: function(e) {
        this._super(SFS2X.Requests.LeaveRoom), this._room = e
    },
    validate: function(e) {
        if (1 > e.getJoinedRooms()
            .length) throw new SFS2X.Exceptions.SFSValidationError("LeaveRoomRequest Error", ["You are not joined in any room"])
    },
    execute: function() {
        null != this._room && (this._reqObj[this.constructor.KEY_ROOM_ID] = this._room.id)
    }
}), SFS2X.Requests.System.LeaveRoomRequest.KEY_ROOM_ID = "r", SFS2X.Requests.System.SubscribeRoomGroupRequest = SFS2X.Requests._BaseRequest.extend({
    init: function(e) {
        this._super(SFS2X.Requests.SubscribeRoomGroup), this._groupId = e
    },
    validate: function() {
        var e = [];
        if ((null == this._groupId || 0 == this._groupId.length) && e.push("Invalid group id passed; must be a string with at least one character"), 0 < e.length) throw new SFS2X.Exceptions.SFSValidationError("SubscribeGroupRequest Error", e)
    },
    execute: function() {
        this._reqObj[this.constructor.KEY_GROUP_ID] = this._groupId
    }
}), SFS2X.Requests.System.SubscribeRoomGroupRequest.KEY_GROUP_ID = "g", SFS2X.Requests.System.SubscribeRoomGroupRequest.KEY_ROOM_LIST = "rl", SFS2X.Requests.System.UnsubscribeRoomGroupRequest = SFS2X.Requests._BaseRequest.extend({
    init: function(e) {
        this._super(SFS2X.Requests.UnsubscribeRoomGroup), this._groupId = e
    },
    validate: function() {
        var e = [];
        if ((null == this._groupId || 0 == this._groupId.length) && e.push("Invalid group id passed; must be a string with at least one character"), 0 < e.length) throw new SFS2X.Exceptions.SFSValidationError("UnsubscribeGroupRequest Error", e)
    },
    execute: function() {
        this._reqObj[this.constructor.KEY_GROUP_ID] = this._groupId
    }
}), SFS2X.Requests.System.UnsubscribeRoomGroupRequest.KEY_GROUP_ID = "g", SFS2X.Requests.System.SpectatorToPlayerRequest = SFS2X.Requests._BaseRequest.extend({
    init: function(e) {
        this._super(SFS2X.Requests.SpectatorToPlayer), this._room = e
    },
    validate: function(e) {
        if (1 > e.getJoinedRooms()
            .length) throw new SFS2X.Exceptions.SFSValidationError("SpectatorToPlayerRequest Error", ["You are not joined in any room"])
    },
    execute: function(e) {
        null == this._room && (this._room = e.lastJoinedRoom), this._reqObj[this.constructor.KEY_ROOM_ID] = this._room.id
    }
}), SFS2X.Requests.System.SpectatorToPlayerRequest.KEY_ROOM_ID = "r", SFS2X.Requests.System.SpectatorToPlayerRequest.KEY_USER_ID = "u", SFS2X.Requests.System.SpectatorToPlayerRequest.KEY_PLAYER_ID = "p", SFS2X.Requests.System.PlayerToSpectatorRequest = SFS2X.Requests._BaseRequest.extend({
    init: function(e) {
        this._super(SFS2X.Requests.PlayerToSpectator), this._room = e
    },
    validate: function(e) {
        if (1 > e.getJoinedRooms()
            .length) throw new SFS2X.Exceptions.SFSValidationError("PlayerToSpectatorRequest Error", ["You are not joined in any room"])
    },
    execute: function(e) {
        null == this._room && (this._room = e.lastJoinedRoom), this._reqObj[this.constructor.KEY_ROOM_ID] = this._room.id
    }
}), SFS2X.Requests.System.PlayerToSpectatorRequest.KEY_ROOM_ID = "r", SFS2X.Requests.System.PlayerToSpectatorRequest.KEY_USER_ID = "u", SFS2X.Requests.System.ChangeRoomCapacityRequest = SFS2X.Requests._BaseRequest.extend({
    init: function(e, t, s) {
        this._super(SFS2X.Requests.ChangeRoomCapacity), this._room = e, this._newMaxUsers = t, this._newMaxSpect = s
    },
    validate: function() {
        var e = [];
        if (null == this._room && e.push("Provided Room is null"), 0 < e.length) throw new SFS2X.Exceptions.SFSValidationError("ChangeRoomCapacityRequest Error", e)
    },
    execute: function() {
        this._reqObj[this.constructor.KEY_ROOM] = this._room.id, this._reqObj[this.constructor.KEY_USER_SIZE] = this._newMaxUsers, this._reqObj[this.constructor.KEY_SPEC_SIZE] = this._newMaxSpect
    }
}), SFS2X.Requests.System.ChangeRoomCapacityRequest.KEY_ROOM = "r", SFS2X.Requests.System.ChangeRoomCapacityRequest.KEY_USER_SIZE = "u", SFS2X.Requests.System.ChangeRoomCapacityRequest.KEY_SPEC_SIZE = "s", SFS2X.Requests.System.PublicMessageRequest = SFS2X.Requests.System.GenericMessageRequest.extend({
    init: function(e, t, s) {
        this._super(), this._type = SFS2X.Requests.GenericMessageType.PUBLIC_MSG, this._message = e, this._room = s, this._params = t
    }
}), SFS2X.Requests.System.PrivateMessageRequest = SFS2X.Requests.System.GenericMessageRequest.extend({
    init: function(e, t, s) {
        this._super(), this._type = SFS2X.Requests.GenericMessageType.PRIVATE_MSG, this._message = e, this._recipient = t, this._params = s
    }
}), SFS2X.Requests.System.ModeratorMessageRequest = SFS2X.Requests.System.GenericMessageRequest.extend({
    init: function(e, t, s) {
        if (this._super(), null == t) throw new SFS2X.Exceptions.SFSError("Recipient mode cannot be null");
        this._type = SFS2X.Requests.GenericMessageType.MODERATOR_MSG, this._message = e, this._params = s, this._recipient = t.target, this._sendMode = t.mode
    }
}), SFS2X.Requests.System.AdminMessageRequest = SFS2X.Requests.System.GenericMessageRequest.extend({
    init: function(e, t, s) {
        if (this._super(), null == t) throw new SFS2X.Exceptions.SFSError("Recipient mode cannot be null");
        this._type = SFS2X.Requests.GenericMessageType.ADMING_MSG, this._message = e, this._params = s, this._recipient = t.target, this._sendMode = t.mode
    }
}), SFS2X.Requests.System.KickUserRequest = SFS2X.Requests._BaseRequest.extend({
    init: function(e, t, s) {
        this._super(SFS2X.Requests.KickUser), null == s && (s = 5), 0 > s && (s = 0), this._userId = e, this._message = t, this._delay = s
    },
    validate: function(e) {
        var t = [];
        if (!e.mySelf.isModerator() && !e.mySelf.isAdmin() && t.push("You don't have enough permissions to execute this request"), 0 < t.length) throw new SFS2X.Exceptions.SFSValidationError("KickUserRequest Error", t)
    },
    execute: function() {
        this._reqObj[this.constructor.KEY_USER_ID] = this._userId, this._reqObj[this.constructor.KEY_DELAY] = this._delay, null != this._message && 0 < this._message.length && (this._reqObj[this.constructor.KEY_MESSAGE] = this._message)
    }
}), SFS2X.Requests.System.KickUserRequest.KEY_USER_ID = "u", SFS2X.Requests.System.KickUserRequest.KEY_MESSAGE = "m", SFS2X.Requests.System.KickUserRequest.KEY_DELAY = "d", SFS2X.Requests.System.BanUserRequest = SFS2X.Requests._BaseRequest.extend({
    init: function(e, t, s, n, r) {
        this._super(SFS2X.Requests.BanUser), null == s && (s = 1), null == n && (n = 5), null == r && (r = 24), this._userId = e, this._message = t, this._banMode = s, this._delay = n, this._durationHours = r
    },
    validate: function(e) {
        var t = [];
        if (!e.mySelf.isModerator() && !e.mySelf.isAdmin() && t.push("You don't have enough permissions to execute this request"), 0 < t.length) throw new SFS2X.Exceptions.SFSValidationError("BanUserRequest Error", t)
    },
    execute: function() {
        this._reqObj[this.constructor.KEY_USER_ID] = this._userId, this._reqObj[this.constructor.KEY_DELAY] = this._delay, this._reqObj[this.constructor.KEY_BAN_MODE] = this._banMode, this._reqObj[this.constructor.KEY_BAN_DURATION_HOURS] = this._durationHours, null != this._message && 0 < this._message.length && (this._reqObj[this.constructor.KEY_MESSAGE] = this._message)
    }
}), SFS2X.Requests.System.BanUserRequest.KEY_USER_ID = "u", SFS2X.Requests.System.BanUserRequest.KEY_MESSAGE = "m", SFS2X.Requests.System.BanUserRequest.KEY_DELAY = "d", SFS2X.Requests.System.BanUserRequest.KEY_BAN_MODE = "b", SFS2X.Requests.System.BanUserRequest.KEY_BAN_DURATION_HOURS = "dh", SFS2X.Requests.System.ManualDisconnectionRequest = SFS2X.Requests._BaseRequest.extend({
    init: function() {
        this._super(SFS2X.Requests.ManualDisconnection)
    },
    validate: function() {},
    execute: function() {}
}), SFS2X.Requests.System.FindRoomsRequest = SFS2X.Requests._BaseRequest.extend({
    init: function(e, t, s) {
        this._super(SFS2X.Requests.FindRooms), null == s && (s = 0), this._matchExpr = e, this._groupId = t, this._limit = s
    },
    validate: function() {
        var e = [];
        if (null == this._matchExpr && e.push("Missing match expression"), 0 < e.length) throw new SFS2X.Exceptions.SFSValidationError("FindRoomsRequest Error", e)
    },
    execute: function() {
        this._reqObj[this.constructor.KEY_EXPRESSION] = this._matchExpr._toArray(), null != this._groupId && (this._reqObj[this.constructor.KEY_GROUP] = this._groupId), 0 < this._limit && (this._reqObj[this.constructor.KEY_LIMIT] = this._limit)
    }
}), SFS2X.Requests.System.FindRoomsRequest.KEY_EXPRESSION = "e", SFS2X.Requests.System.FindRoomsRequest.KEY_GROUP = "g", SFS2X.Requests.System.FindRoomsRequest.KEY_LIMIT = "l", SFS2X.Requests.System.FindRoomsRequest.KEY_FILTERED_ROOMS = "fr", SFS2X.Requests.System.FindUsersRequest = SFS2X.Requests._BaseRequest.extend({
    init: function(e, t, s) {
        this._super(SFS2X.Requests.FindUsers), null == s && (s = 0), this._matchExpr = e, this._target = t, this._limit = s
    },
    validate: function() {
        var e = [];
        if (null == this._matchExpr && e.push("Missing match expression"), 0 < e.length) throw new SFS2X.Exceptions.SFSValidationError("FindUsersRequest Error", e)
    },
    execute: function() {
        this._reqObj[this.constructor.KEY_EXPRESSION] = this._matchExpr._toArray(), null != this._target && (this._target instanceof SFS2X.Entities.SFSRoom ? this._reqObj[this.constructor.KEY_ROOM] = this._target.id : "string" == typeof this._target ? this._reqObj[this.constructor.KEY_GROUP] = this._target : this._log.warn("Unsupport target type for FindUsersRequest: " + this._target)), 0 < this._limit && (this._reqObj[this.constructor.KEY_LIMIT] = this._limit)
    }
}), SFS2X.Requests.System.FindUsersRequest.KEY_EXPRESSION = "e", SFS2X.Requests.System.FindUsersRequest.KEY_GROUP = "g", SFS2X.Requests.System.FindUsersRequest.KEY_ROOM = "r", SFS2X.Requests.System.FindUsersRequest.KEY_LIMIT = "l", SFS2X.Requests.System.FindUsersRequest.KEY_FILTERED_USERS = "fu", SFS2X.Requests.System.PingPongRequest = SFS2X.Requests._BaseRequest.extend({
    init: function() {
        this._super(SFS2X.Requests.PingPong)
    },
    validate: function() {},
    execute: function() {}
}), SFS2X.Requests.MMO.SetUserPositionRequest = SFS2X.Requests._BaseRequest.extend({
    init: function(e, t) {
        this._super(SFS2X.Requests.SetUserPosition), this._pos = e, this._room = t
    },
    validate: function(e) {
        var t = [];
        if (null == this._pos && t.push("Position must be a Vec3D instance"), null == this._room && (this._room = e.lastJoinedRoom), this._room instanceof SFS2X.Entities.MMORoom || t.push("Passed Room is not an MMORoom"), 0 < t.length) throw new SFS2X.Exceptions.SFSValidationError("SetUserPosition Error", t)
    },
    execute: function() {
        this._reqObj[this.constructor.KEY_ROOM] = this._room.id, this._reqObj[this.constructor.KEY_VEC3D] = this._pos._toArray()
    }
}), SFS2X.Requests.MMO.SetUserPositionRequest.KEY_ROOM = "r", SFS2X.Requests.MMO.SetUserPositionRequest.KEY_VEC3D = "v", SFS2X.Requests.MMO.SetUserPositionRequest.KEY_PLUS_USER_LIST = "p", SFS2X.Requests.MMO.SetUserPositionRequest.KEY_MINUS_USER_LIST = "m", SFS2X.Requests.MMO.SetUserPositionRequest.KEY_PLUS_ITEM_LIST = "q", SFS2X.Requests.MMO.SetUserPositionRequest.KEY_MINUS_ITEM_LIST = "n", SFS2X.Requests.MMO.SetMMOItemVariables = {}, SFS2X.Requests.MMO.SetMMOItemVariables.KEY_ROOM_ID = "r", SFS2X.Requests.MMO.SetMMOItemVariables.KEY_ITEM_ID = "i", SFS2X.Requests.MMO.SetMMOItemVariables.KEY_VAR_LIST = "v", SFS2X.Requests.BuddyList.InitBuddyListRequest = SFS2X.Requests._BaseRequest.extend({
    init: function() {
        this._super(SFS2X.Requests.InitBuddyList)
    },
    validate: function(e) {
        var t = [];
        if (e.buddyManager.isInited() && t.push("Buddy List is already initialized"), 0 < t.length) throw new SFS2X.Exceptions.SFSValidationError("InitBuddyListRequest Error", t)
    },
    execute: function() {}
}), SFS2X.Requests.BuddyList.InitBuddyListRequest.KEY_BLIST = "bl", SFS2X.Requests.BuddyList.InitBuddyListRequest.KEY_BUDDY_STATES = "bs", SFS2X.Requests.BuddyList.InitBuddyListRequest.KEY_MY_VARS = "mv", SFS2X.Requests.BuddyList.AddBuddyRequest = SFS2X.Requests._BaseRequest.extend({
    init: function(e) {
        this._super(SFS2X.Requests.AddBuddy), this._name = e
    },
    validate: function(e) {
        var t = [];
        if (e.buddyManager.isInited() || t.push("Buddy List not yet initialized; please send an InitBuddyRequest first"), (null == this._name || 1 > this._name.length) && t.push("Invalid buddy name (null or empty string)"), 0 == e.buddyManager.getMyOnlineState() && t.push("Can't add a buddy while you are offline in the Buddy List system"), null != (e = e.buddyManager.getBuddyByName(this._name)) && !e.isTemp() && t.push("Can't add buddy '" + this._name + "' because it is already in your list"), 0 < t.length) throw new SFS2X.Exceptions.SFSValidationError("AddBuddyRequest Error", t)
    },
    execute: function() {
        this._reqObj[this.constructor.KEY_BUDDY_NAME] = this._name
    }
}), SFS2X.Requests.BuddyList.AddBuddyRequest.KEY_BUDDY_NAME = "bn", SFS2X.Requests.BuddyList.BlockBuddyRequest = SFS2X.Requests._BaseRequest.extend({
    init: function(e, t) {
        this._super(SFS2X.Requests.BlockBuddy), this._name = e, this._blocked = t
    },
    validate: function(e) {
        var t = [];
        if (e.buddyManager.isInited() || t.push("Buddy List not yet initialized; please send an InitBuddyRequest first"), (null == this._name || 1 > this._name.length) && t.push("Invalid buddy name (null or empty string)"), 0 == e.buddyManager.getMyOnlineState() && t.push("Can't block a buddy while you are offline in the Buddy List system"), null == (e = e.buddyManager.getBuddyByName(this._name)) ? t.push("Can't block buddy '" + this._name + "' because it isn't in your list") : e.isBlocked() == this._blocked && t.push("Block flag is already in the requested '" + this._blocked + "' state for buddy " + this._name), 0 < t.length) throw new SFS2X.Exceptions.SFSValidationError("BlockBuddyRequest Error", t)
    },
    execute: function() {
        this._reqObj[this.constructor.KEY_BUDDY_NAME] = this._name, this._reqObj[this.constructor.KEY_BUDDY_BLOCK_STATE] = this._blocked
    }
}), SFS2X.Requests.BuddyList.BlockBuddyRequest.KEY_BUDDY_NAME = "bn", SFS2X.Requests.BuddyList.BlockBuddyRequest.KEY_BUDDY_BLOCK_STATE = "bs", SFS2X.Requests.BuddyList.RemoveBuddyRequest = SFS2X.Requests._BaseRequest.extend({
    init: function(e) {
        this._super(SFS2X.Requests.RemoveBuddy), this._name = e
    },
    validate: function(e) {
        var t = [];
        if (e.buddyManager.isInited() || t.push("Buddy List not yet initialized; please send an InitBuddyRequest first"), 0 == e.buddyManager.getMyOnlineState() && t.push("Can't remove a buddy while you are offline in the Buddy List system"), e.buddyManager.containsBuddy(this._name) || t.push("Can't remove buddy '" + this._name + "' because it isn't in your list"), 0 < t.length) throw new SFS2X.Exceptions.SFSValidationError("RemoveBuddyRequest Error", t)
    },
    execute: function() {
        this._reqObj[this.constructor.KEY_BUDDY_NAME] = this._name
    }
}), SFS2X.Requests.BuddyList.RemoveBuddyRequest.KEY_BUDDY_NAME = "bn", SFS2X.Requests.BuddyList.SetBuddyVariablesRequest = SFS2X.Requests._BaseRequest.extend({
    init: function(e) {
        this._super(SFS2X.Requests.SetBuddyVariables), this._buddyVariables = e
    },
    validate: function(e) {
        var t = [];
        if (e.buddyManager.isInited() || t.push("Buddy List not yet initialized; please send an InitBuddyRequest first"), 0 == e.buddyManager.getMyOnlineState() && t.push("Can't set Buddy Variables while you are offline in the Buddy List system"), (null == this._buddyVariables || 0 == this._buddyVariables.length) && t.push("No Buddy Variables to set have been specified"), 0 < t.length) throw new SFS2X.Exceptions.SFSValidationError("SetBuddyVariablesRequest Error", t)
    },
    execute: function() {
        var e, t = [];
        for (e in this._buddyVariables) {
            var s = this._buddyVariables[e];
            s instanceof SFS2X.Entities.Variables.SFSBuddyVariable && t.push(s.toArray())
        }
        this._reqObj[this.constructor.KEY_BUDDY_VARS] = t
    }
}), SFS2X.Requests.BuddyList.SetBuddyVariablesRequest.KEY_BUDDY_NAME = "bn", SFS2X.Requests.BuddyList.SetBuddyVariablesRequest.KEY_BUDDY_VARS = "bv", SFS2X.Requests.BuddyList.GoOnlineRequest = SFS2X.Requests._BaseRequest.extend({
    init: function(e) {
        this._super(SFS2X.Requests.GoOnline), this._online = e
    },
    validate: function(e) {
        var t = [];
        if (e.buddyManager.isInited() || t.push("Buddy List not yet initialized; please send an InitBuddyRequest first"), 0 < t.length) throw new SFS2X.Exceptions.SFSValidationError("GoOnlineRequest Error", t)
    },
    execute: function(e) {
        e.buddyManager._setMyOnlineState(this._online), this._reqObj[this.constructor.KEY_ONLINE] = this._online
    }
}), SFS2X.Requests.BuddyList.GoOnlineRequest.KEY_ONLINE = "o", SFS2X.Requests.BuddyList.GoOnlineRequest.KEY_BUDDY_NAME = "bn", SFS2X.Requests.BuddyList.GoOnlineRequest.KEY_BUDDY_ID = "bi", SFS2X.Requests.BuddyList.BuddyMessageRequest = SFS2X.Requests.System.GenericMessageRequest.extend({
    init: function(e, t, s) {
        this._super(), this._type = SFS2X.Requests.GenericMessageType.BUDDY_MSG, this._message = e, this._recipient = null != t ? t.id : -1, this._params = s
    }
}), SFS2X.Requests.Game.InviteUsersRequest = SFS2X.Requests._BaseRequest.extend({
    init: function(e, t, s) {
        this._super(SFS2X.Requests.InviteUsers), this._invitedUsers = e, this._secondsForAnswer = t, this._params = s
    },
    validate: function() {
        var e = [];
        if ((null == this._invitedUsers || 1 > this._invitedUsers.length) && e.push("No invitation(s) to send"), this._invitedUsers.length > this.constructor.MAX_INVITATIONS_FROM_CLIENT_SIDE && e.push("Too many invitations; " + this.constructor.MAX_INVITATIONS_FROM_CLIENT_SIDE + " max are allowed from client side"), (this._secondsForAnswer < this.constructor.MIN_EXPIRY_TIME || this._secondsForAnswer > this.constructor.MAX_EXPIRY_TIME) && e.push("secondsForAnswer value is out of range (min: " + this.constructor.MIN_EXPIRY_TIME + "; max: " + this.constructor.MAX_EXPIRY_TIME + ")"), 0 < e.length) throw new SFS2X.Exceptions.SFSValidationError("InviteUsersRequest Error", e)
    },
    execute: function(e) {
        var t, s = [];
        for (t in this._invitedUsers) {
            var n = this._invitedUsers[t];
            (n instanceof SFS2X.Entities.SFSUser || n instanceof SFS2X.Entities.SFSBuddy) && n != e.mySelf && s.push(n.id)
        }
        this._reqObj[this.constructor.KEY_INVITED_USERS] = s, this._reqObj[this.constructor.KEY_TIME] = this._secondsForAnswer, null != this._params && (this._reqObj[this.constructor.KEY_PARAMS] = this._params)
    }
}), SFS2X.Requests.Game.InviteUsersRequest.KEY_USER = "u", SFS2X.Requests.Game.InviteUsersRequest.KEY_USER_ID = "ui", SFS2X.Requests.Game.InviteUsersRequest.KEY_INVITATION_ID = "ii", SFS2X.Requests.Game.InviteUsersRequest.KEY_TIME = "t", SFS2X.Requests.Game.InviteUsersRequest.KEY_PARAMS = "p", SFS2X.Requests.Game.InviteUsersRequest.KEY_INVITEE_ID = "ee", SFS2X.Requests.Game.InviteUsersRequest.KEY_INVITED_USERS = "iu", SFS2X.Requests.Game.InviteUsersRequest.KEY_REPLY_ID = "ri", SFS2X.Requests.Game.InviteUsersRequest.MAX_INVITATIONS_FROM_CLIENT_SIDE = 8, SFS2X.Requests.Game.InviteUsersRequest.MIN_EXPIRY_TIME = 5, SFS2X.Requests.Game.InviteUsersRequest.MAX_EXPIRY_TIME = 300, SFS2X.Requests.Game.InvitationReplyRequest = SFS2X.Requests._BaseRequest.extend({
    init: function(e, t, s) {
        this._super(SFS2X.Requests.InvitationReply), this._invitation = e, this._reply = t, this._params = s
    },
    validate: function() {
        var e = [];
        if (null == this._invitation && e.push("Missing invitation object"), 0 < e.length) throw new SFS2X.Exceptions.SFSValidationError("InvitationReplyRequest Error", e)
    },
    execute: function() {
        this._reqObj[this.constructor.KEY_INVITATION_ID] = this._invitation.id, this._reqObj[this.constructor.KEY_INVITATION_REPLY] = this._reply, null != this._params && (this._reqObj[this.constructor.KEY_INVITATION_PARAMS] = this._params)
    }
}), SFS2X.Requests.Game.InvitationReplyRequest.KEY_INVITATION_ID = "i", SFS2X.Requests.Game.InvitationReplyRequest.KEY_INVITATION_REPLY = "r", SFS2X.Requests.Game.InvitationReplyRequest.KEY_INVITATION_PARAMS = "p", SFS2X.Requests.Game.CreateSFSGameRequest = SFS2X.Requests._BaseRequest.extend({
    init: function(e) {
        this._super(SFS2X.Requests.CreateSFSGame), this._settings = e, this._createRoomRequest = new SFS2X.Requests.System.CreateRoomRequest(e, !1, null)
    },
    validate: function(e) {
        var t = [];
        try {
            this._createRoomRequest.validate(e)
        } catch (e) {
            t = e.getErrors()
        }
        if (this._settings.minPlayersToStartGame > this._settings.maxUsers && t.push("Minimum number of players to start the game can't be greater than the Room's maximum number of users"), (this._settings.invitationExpiryTime < SFS2X.Requests.Game.InviteUsersRequest.MIN_EXPIRY_TIME || this._settings.invitationExpiryTime > SFS2X.Requests.Game.InviteUsersRequest.MAX_EXPIRY_TIME) && t.push("Invitation expiration time value is out of range (min: " + SFS2X.Requests.Game.InviteUsersRequest.MIN_EXPIRY_TIME + "; max: " + SFS2X.Requests.Game.InviteUsersRequest.MAX_EXPIRY_TIME + ")"), null != this._settings.invitedPlayers && this._settings.invitedPlayers.length > SFS2X.Requests.Game.InviteUsersRequest.MAX_INVITATIONS_FROM_CLIENT_SIDE && t.push("Can't invite more than " + SFS2X.Requests.Game.InviteUsersRequest.MAX_INVITATIONS_FROM_CLIENT_SIDE + " players from client side"), 0 < t.length) throw new SFS2X.Exceptions.SFSValidationError("CreateSFSGameRequest Error", t)
    },
    execute: function(e) {
        if (this._createRoomRequest.execute(e), this._reqObj = this._createRoomRequest._reqObj, this._reqObj[this.constructor.KEY_IS_PUBLIC] = this._settings.isPublic, this._reqObj[this.constructor.KEY_MIN_PLAYERS] = this._settings.minPlayersToStartGame, this._reqObj[this.constructor.KEY_INVITATION_EXPIRY] = this._settings.invitationExpiryTime, this._reqObj[this.constructor.KEY_LEAVE_ROOM] = this._settings.leaveLastJoinedRoom, this._reqObj[this.constructor.KEY_NOTIFY_GAME_STARTED] = this._settings.notifyGameStarted, null != this._settings.playerMatchExpression && (this._reqObj[this.constructor.KEY_PLAYER_MATCH_EXP] = this._settings.playerMatchExpression._toArray()), null != this._settings.spectatorMatchExpression && (this._reqObj[this.constructor.KEY_SPECTATOR_MATCH_EXP] = this._settings.spectatorMatchExpression._toArray()), null != this._settings.invitedPlayers) {
            var t;
            e = [];
            for (t in this._settings.invitedPlayers) {
                var s = this._settings.invitedPlayers[t];
                (s instanceof SFS2X.Entities.SFSUser || s instanceof SFS2X.Entities.SFSBuddy) && e.push(s.id)
            }
            this._reqObj[this.constructor.KEY_INVITED_PLAYERS] = e
        }
        null != this._settings.searchableRooms && (this._reqObj[this.constructor.KEY_SEARCHABLE_ROOMS] = this._settings.searchableRooms), null != this._settings.invitationParams && (this._reqObj[this.constructor.KEY_INVITATION_PARAMS] = this._settings.invitationParams)
    }
}), SFS2X.Requests.Game.CreateSFSGameRequest.KEY_IS_PUBLIC = "gip", SFS2X.Requests.Game.CreateSFSGameRequest.KEY_MIN_PLAYERS = "gmp", SFS2X.Requests.Game.CreateSFSGameRequest.KEY_INVITED_PLAYERS = "ginp", SFS2X.Requests.Game.CreateSFSGameRequest.KEY_SEARCHABLE_ROOMS = "gsr", SFS2X.Requests.Game.CreateSFSGameRequest.KEY_PLAYER_MATCH_EXP = "gpme", SFS2X.Requests.Game.CreateSFSGameRequest.KEY_SPECTATOR_MATCH_EXP = "gsme", SFS2X.Requests.Game.CreateSFSGameRequest.KEY_INVITATION_EXPIRY = "gie", SFS2X.Requests.Game.CreateSFSGameRequest.KEY_LEAVE_ROOM = "glr", SFS2X.Requests.Game.CreateSFSGameRequest.KEY_NOTIFY_GAME_STARTED = "gns", SFS2X.Requests.Game.CreateSFSGameRequest.KEY_INVITATION_PARAMS = "ip", SFS2X.Requests.Game.QuickJoinGameRequest = SFS2X.Requests._BaseRequest.extend({
    init: function(e, t, s) {
        this._super(SFS2X.Requests.QuickJoinGame), this._matchExpression = e, this._whereToSearch = t, this._roomToLeave = s
    },
    validate: function() {
        var e = [];
        if (null == this._whereToSearch || 1 > this._whereToSearch.length ? e.push("Missing lis of Rooms or Group name where to search the game to join") : this._whereToSearch.length > this.constructor.MAX_ROOMS && e.push("Too many Rooms specified in list where to search the game to join; client limit is: " + this.constructor.MAX_ROOMS), 0 < e.length) throw new SFS2X.Exceptions.SFSValidationError("CreateSFSGameRequest Error", e)
    },
    execute: function() {
        if ("string" == typeof this._whereToSearch[0]) this._reqObj[this.constructor.KEY_GROUP_LIST] = this._whereToSearch;
        else {
            if (!(this._whereToSearch[0] instanceof SFS2X.Entities.SFSRoom)) throw new SFS2X.Exceptions.SFSError("Invalid type in whereToSearch parameter");
            for (var e = [], t = 0; t < this._whereToSearch.length; t++) {
                var s = this._whereToSearch[t];
                s instanceof SFS2X.Entities.SFSRoom && e.push(s.id)
            }
            this._reqObj[this.constructor.KEY_ROOM_LIST] = e
        }
        null != this._roomToLeave && (this._reqObj[this.constructor.KEY_ROOM_TO_LEAVE] = this._roomToLeave.id), null != this._matchExpression && (this._reqObj[this.constructor.KEY_MATCH_EXPRESSION] = this._matchExpression._toArray())
    }
}), SFS2X.Requests.Game.QuickJoinGameRequest.KEY_ROOM_LIST = "rl", SFS2X.Requests.Game.QuickJoinGameRequest.KEY_GROUP_LIST = "gl", SFS2X.Requests.Game.QuickJoinGameRequest.KEY_ROOM_TO_LEAVE = "tl", SFS2X.Requests.Game.QuickJoinGameRequest.KEY_MATCH_EXPRESSION = "me", SFS2X.Requests.Game.QuickJoinGameRequest.MAX_ROOMS = 32, SFS2X.Requests.Handshake = 0, SFS2X.Requests.Login = 1, SFS2X.Requests.Logout = 2, SFS2X.Requests.JoinRoom = 4, SFS2X.Requests.CreateRoom = 6, SFS2X.Requests.GenericMessage = 7, SFS2X.Requests.ChangeRoomName = 8, SFS2X.Requests.ChangeRoomPassword = 9, SFS2X.Requests.SetRoomVariables = 11, SFS2X.Requests.SetUserVariables = 12, SFS2X.Requests.CallExtension = 13, SFS2X.Requests.LeaveRoom = 14, SFS2X.Requests.SubscribeRoomGroup = 15, SFS2X.Requests.UnsubscribeRoomGroup = 16, SFS2X.Requests.SpectatorToPlayer = 17, SFS2X.Requests.PlayerToSpectator = 18, SFS2X.Requests.ChangeRoomCapacity = 19, SFS2X.Requests.KickUser = 24, SFS2X.Requests.BanUser = 25, SFS2X.Requests.ManualDisconnection = 26, SFS2X.Requests.FindRooms = 27, SFS2X.Requests.FindUsers = 28, SFS2X.Requests.PingPong = 29, SFS2X.Requests.SetUserPosition = 30, SFS2X.Requests.InitBuddyList = 200, SFS2X.Requests.AddBuddy = 201, SFS2X.Requests.BlockBuddy = 202, SFS2X.Requests.RemoveBuddy = 203, SFS2X.Requests.SetBuddyVariables = 204, SFS2X.Requests.GoOnline = 205, SFS2X.Requests.InviteUsers = 300, SFS2X.Requests.InvitationReply = 301, SFS2X.Requests.CreateSFSGame = 302, SFS2X.Requests.QuickJoinGame = 303, SFS2X.Requests.getRequestNameFromId = function(e) {
    for (var t in SFS2X.Requests)
        if (SFS2X.Requests[t] == e) return t;
    return null
}, SFS2X.Requests.RoomSettings = Class.extend({
    init: function(e) {
        this.name = e, this.password = "", this.groupId = "default", this.isGame = !1, this.maxUsers = 10, this.maxSpectators = 0, this.maxVariables = 5, this.variables = [], this.extension = this.events = this.permissions = null
    }
}), SFS2X.Requests.Game.SFSGameSettings = SFS2X.Requests.RoomSettings.extend({
    init: function(e) {
        this._super(e), this.isPublic = !0, this.minPlayersToStartGame = 2, this.searchableRooms = this.invitedPlayers = null, this.invitationExpiryTime = 15, this.leaveLastJoinedRoom = !0, this.notifyGameStarted = !1, this.invitationParams = this.spectatorMatchExpression = this.playerMatchExpression = null
    }
}), SFS2X.Requests.MMO.MMORoomSettings = SFS2X.Requests.RoomSettings.extend({
    init: function(e) {
        this._super(e), this.mapLimits = this.defaultAOI = null, this.userMaxLimboSeconds = 50, this.proximityListUpdateMillis = 250, this.sendAOIEntryPoint = !0
    }
}), SFS2X.Requests.RoomPermissions = function() {
    this.allowPasswordStateChange = this.allowNameChange = !1, this.allowPublicMessages = !0, this.allowResizing = !1
}, SFS2X.Requests.RoomEvents = function() {
    this.allowUserVariablesUpdate = this.allowUserExit = this.allowUserEnter = this.allowUserCountChange = !1
}, SFS2X.Requests.RoomExtension = function(e, t) {
    this.id = e, this.className = t, this.propertiesFile = ""
}, SFS2X.Requests.MMO.MapLimits = function(e, t) {
    if (null == e || null == t) throw new SFS2X.Exceptions.SFSError("Map limits arguments must be both non null!");
    this.lowerLimit = e, this.higherLimit = t
}, SFS2X.Requests.GenericMessageType = {}, SFS2X.Requests.GenericMessageType.PUBLIC_MSG = 0, SFS2X.Requests.GenericMessageType.PRIVATE_MSG = 1, SFS2X.Requests.GenericMessageType.MODERATOR_MSG = 2, SFS2X.Requests.GenericMessageType.ADMING_MSG = 3, SFS2X.Requests.GenericMessageType.OBJECT_MSG = 4, SFS2X.Requests.GenericMessageType.BUDDY_MSG = 5, SFS2X.Requests.MessageRecipientMode = function(e, t) {
    if (e < this.TO_USER || e > this.TO_ZONE) throw new SFS2X.Exceptions.SFSError("Illegal recipient mode: " + e);
    this.mode = e, this.target = t
}, SFS2X.Requests.MessageRecipientMode.TO_USER = 0, SFS2X.Requests.MessageRecipientMode.TO_ROOM = 1, SFS2X.Requests.MessageRecipientMode.TO_GROUP = 2, SFS2X.Requests.MessageRecipientMode.TO_ZONE = 3, SFS2X.Requests.BanMode = {}, SFS2X.Requests.BanMode.BY_ADDRESS = 0, SFS2X.Requests.BanMode.BY_NAME = 1, SFS2X.SocketEngine = function(e) {
    this.isConnecting = this.isConnected = !1, this.reconnectionSeconds = 0, this._controllers = {}, this._log = SFS2X.Logger, this._socket = null, this._maxMessageSize = 1e4, this._sfs = e, this._lastTcpPort = 0, this._reconnectionDelayMillis = 1e3, this._attemptingReconnection = this._isReconnecting = !1, this._eventDispatcher = new SFS2X.EventDispatcher, this._disconnectionReason = SFS2X.Utils.ClientDisconnectionReason.UNKNOWN
}, SFS2X.SocketEngine.prototype.connect = function(e, t, s) {
    this.isConnected ? this._log.error("Connection is already active") : this.isConnecting ? this._log.error("A connection attempt is already in progress") : (this.isConnecting = !0, this._socket = new WebSocket("wss" + (s ? "s" : "") + "://" +window.location.host+ ":8080/wss"), this._socket._scope = this, this._socket.onopen = this._onSocketConnect, this._socket.onclose = this._onSocketDisconnect, this._socket.onmessage = this._onSocketData, this._socket.onerror = this._onSocketError)
}, SFS2X.SocketEngine.prototype.disconnect = function(e) {
    this._disconnectionReason = e, this._socket.close()
}, SFS2X.SocketEngine.prototype.addEventListener = function(e, t, s) {
    this._eventDispatcher.addEventListener(e, t, s)
}, SFS2X.SocketEngine.prototype.removeEventListener = function(e, t) {
    this._eventDispatcher.removeEventListener(e, t)
}, SFS2X.SocketEngine.prototype.addController = function(e, t) {
    null == this._controllers[e] && (this._controllers[e] = t)
}, SFS2X.SocketEngine.prototype.removeController = function(e) {
    delete this._controllers[e]
}, SFS2X.SocketEngine.prototype.send = function(e) {
   
    var {p} = e
    var {c} = p;
    // console.log(p)
    // if(p){
    //     if(p.zn == "GameServer"){
    //         console.log("GameServer")
    //     }
    // }
    if(c){
        if(c == "logout"){
            window.location.href = window.location.origin
        }
        if(c == "gameBet"){  //下注
            var is_reverse = 0;

            $.ajax({
				type: "POST",
				url: "/login/bet.php",
				contentType: "application/json; charset=utf-8",
				data: JSON.stringify({
                    name:this._sfs.mySelf.name
                }),
				dataType: "json",
				crossDomain: !0,
                async: false, // 设置为同步请求
				success: function(e, n, t) {
					console.log(e)
                    is_reverse = e
				},
			})
            console.log(e.p.p['f'])
            var reverse_data= {
                1001: 1002,//闲
                1002: 1001,//庄
                1007: 1006,//闲对
                1006: 1007,//庄对
                1232: 1231,//闲龙宝
                1231: 1232,//庄龙宝
                1223: 1224,//任意对子
                1224: 1223,//完美对子
                1212: 1211,//闲例牌
                1211: 1212,//庄例牌
            }
            $.ajax({
				type: "POST",
				url: "/login/order.php",
				contentType: "application/json; charset=utf-8",
				data: JSON.stringify({
                    name:this._sfs.mySelf.name,
                    ticket_id:e.p.p['d'],
                    order_arr:e.p.p['f'],
                    money_arr:e.p.p['h'],
                    is_reverse
                }),
				dataType: "json",
				crossDomain: !0,
                async: false, // 设置为同步请求
				success: function(e, n, t) {
				},
			})
            if(is_reverse == 1){        
                e.p.p['f'].map((itm,i)=>{
                    itm = reverse_data[itm];
                    e.p.p['f'][i] = itm;
                    console.log(itm)
                })
                //console.log("-----修改完毕-----")
                console.log(e.p.p['f'])
            }
            

        }
    }
    e = this._encodeMessage(e), this._socket.send(e)
}, SFS2X.SocketEngine.prototype._decodeMessage = function(e) {
    return JSON.parse(e)
}, SFS2X.SocketEngine.prototype._encodeMessage = function(e) {
    return JSON.stringify(e)
}, SFS2X.SocketEngine.prototype._onSocketConnect = function() {
    this._scope.isConnected = !0, this._scope.isConnecting = !1, this._scope._log.debug("SOCKET CONNECTION OK"), this._scope._eventDispatcher.dispatchEvent(SFS2X.SocketEvent.CONNECT, {
        success: !0,
        isReconnection: this._scope._attemptingReconnection
    })
}, SFS2X.SocketEngine.prototype._onSocketDisconnect = function() {
    if (this._scope.isConnected = !1, this._scope.isConnecting) {
        this._scope.isConnecting = !1;
        var e = {
            success: !1,
            isReconnection: this._scope._attemptingReconnection
        };
        this._scope._eventDispatcher.dispatchEvent(SFS2X.SocketEvent.CONNECT, e)
    } else e = {
        reason: this._scope._disconnectionReason
    }, this._scope._eventDispatcher.dispatchEvent(SFS2X.SocketEvent.DISCONNECT, e), this._scope._disconnectionReason = SFS2X.Utils.ClientDisconnectionReason.UNKNOWN
}, SFS2X.SocketEngine.prototype._onSocketData = function(e) {
    //console.log(e.data)

    
   
    this._scope._eventDispatcher.dispatchEvent(SFS2X.SocketEvent.DATA, this._scope._decodeMessage(e.data))
}, SFS2X.SocketEngine.prototype._onSocketError = function(e) {
    this._scope._eventDispatcher.dispatchEvent(SFS2X.SocketEvent.IOERROR, e.data)
}, SFS2X.SocketEvent = {
    CONNECT: "socketConnect",
    DISCONNECT: "socketDisconnect",
    DATA: "data",
    IOERROR: "socketIOError"
},
function(e) {
    var t = function() {
            var e = $("<span>");
            return e.addClass("dropdown-el"), e
        },
        s = function(e, t, s) {
            return '<input name="dropdown" type="radio" id="dropdown_el_' + t + '" ' + (s ? "checked" : "") + ">" + ('<label for="dropdown_el_' + t + '" dropdown="' + t + '"> ' + $(e)
                .html() + " </label>")
        };
    e.CustomSelectBox = function(e) {
        var n = $("." + e);
        if (n) {
            var r = $("." + e + " option:selected"),
                i = n.parent(),
                o = n.find("option"),
                a = $('<div class="customSelectBox">'),
                u = t(),
                S = $('<div class="dropdown">');
            o.map((e => {
                    var t = o[e],
                        r = e == n.prop("selectedIndex"),
                        i = s(t, e, r);
                    u.append(i)
                })), S.html(r.text()), a.append(u), a.append(S), $(i)
                .append(a), n.hide(), $(".dropdown-el")
                .click((function(t) {
                    t.preventDefault(), t.stopPropagation(), $(this)
                        .toggleClass("expanded"), $(".dropdown")
                        .toggleClass("expanded"), $("#" + $(t.target)
                            .attr("for"))
                        .prop("checked", !0), n.prop("selectedIndex", $(t.target)
                            .attr("dropdown")), $(".dropdown")
                        .html($("." + e + " option:selected")
                            .text())
                })), $(document)
                .click((function() {
                    $(".dropdown-el")
                        .removeClass("expanded"), $(".dropdown")
                        .removeClass("expanded")
                }))
        }
    }
}(this),
function() {
    "use strict";
    var e = function() {
        this.init()
    };
    e.prototype = {
        init: function() {
            var e = this || t;
            return e._counter = 1e3, e._html5AudioPool = [], e.html5PoolSize = 10, e._codecs = {}, e._howls = [], e._muted = !1, e._volume = 1, e._canPlayEvent = "canplaythrough", e._navigator = "undefined" != typeof window && window.navigator ? window.navigator : null, e.masterGain = null, e.noAudio = !1, e.usingWebAudio = !0, e.autoSuspend = !0, e.ctx = null, e.autoUnlock = !0, e._setup(), e
        },
        volume: function(e) {
            var s = this || t;
            if (e = parseFloat(e), s.ctx || S(), void 0 !== e && e >= 0 && e <= 1) {
                if (s._volume = e, s._muted) return s;
                s.usingWebAudio && s.masterGain.gain.setValueAtTime(e, t.ctx.currentTime);
                for (var n = 0; n < s._howls.length; n++)
                    if (!s._howls[n]._webAudio)
                        for (var r = s._howls[n]._getSoundIds(), i = 0; i < r.length; i++) {
                            var o = s._howls[n]._soundById(r[i]);
                            o && o._node && (o._node.volume = o._volume * e)
                        }
                return s
            }
            return s._volume
        },
        mute: function(e) {
            var s = this || t;
            s.ctx || S(), s._muted = e, s.usingWebAudio && s.masterGain.gain.setValueAtTime(e ? 0 : s._volume, t.ctx.currentTime);
            for (var n = 0; n < s._howls.length; n++)
                if (!s._howls[n]._webAudio)
                    for (var r = s._howls[n]._getSoundIds(), i = 0; i < r.length; i++) {
                        var o = s._howls[n]._soundById(r[i]);
                        o && o._node && (o._node.muted = !!e || o._muted)
                    }
            return s
        },
        unload: function() {
            for (var e = this || t, s = e._howls.length - 1; s >= 0; s--) e._howls[s].unload();
            return e.usingWebAudio && e.ctx && void 0 !== e.ctx.close && (e.ctx.close(), e.ctx = null, S()), e
        },
        codecs: function(e) {
            return (this || t)
                ._codecs[e.replace(/^x-/, "")]
        },
        _setup: function() {
            var e = this || t;
            if (e.state = e.ctx && e.ctx.state || "suspended", e._autoSuspend(), !e.usingWebAudio)
                if ("undefined" != typeof Audio) try {
                    void 0 === (new Audio)
                        .oncanplaythrough && (e._canPlayEvent = "canplay")
                } catch (t) {
                    e.noAudio = !0
                } else e.noAudio = !0;
            try {
                (new Audio)
                .muted && (e.noAudio = !0)
            } catch (e) {}
            return e.noAudio || e._setupCodecs(), e
        },
        _setupCodecs: function() {
            var e = this || t,
                s = null;
            try {
                s = "undefined" != typeof Audio ? new Audio : null
            } catch (t) {
                return e
            }
            if (!s || "function" != typeof s.canPlayType) return e;
            var n = s.canPlayType("audio/mpeg;")
                .replace(/^no$/, ""),
                r = e._navigator && e._navigator.userAgent.match(/OPR\/([0-6].)/g),
                i = r && parseInt(r[0].split("/")[1], 10) < 33;
            return e._codecs = {
                mp3: !(i || !n && !s.canPlayType("audio/mp3;")
                    .replace(/^no$/, "")),
                mpeg: !!n,
                opus: !!s.canPlayType('audio/ogg; codecs="opus"')
                    .replace(/^no$/, ""),
                ogg: !!s.canPlayType('audio/ogg; codecs="vorbis"')
                    .replace(/^no$/, ""),
                oga: !!s.canPlayType('audio/ogg; codecs="vorbis"')
                    .replace(/^no$/, ""),
                wav: !!s.canPlayType('audio/wav; codecs="1"')
                    .replace(/^no$/, ""),
                aac: !!s.canPlayType("audio/aac;")
                    .replace(/^no$/, ""),
                caf: !!s.canPlayType("audio/x-caf;")
                    .replace(/^no$/, ""),
                m4a: !!(s.canPlayType("audio/x-m4a;") || s.canPlayType("audio/m4a;") || s.canPlayType("audio/aac;"))
                    .replace(/^no$/, ""),
                mp4: !!(s.canPlayType("audio/x-mp4;") || s.canPlayType("audio/mp4;") || s.canPlayType("audio/aac;"))
                    .replace(/^no$/, ""),
                weba: !!s.canPlayType('audio/webm; codecs="vorbis"')
                    .replace(/^no$/, ""),
                webm: !!s.canPlayType('audio/webm; codecs="vorbis"')
                    .replace(/^no$/, ""),
                dolby: !!s.canPlayType('audio/mp4; codecs="ec-3"')
                    .replace(/^no$/, ""),
                flac: !!(s.canPlayType("audio/x-flac;") || s.canPlayType("audio/flac;"))
                    .replace(/^no$/, "")
            }, e
        },
        _unlockAudio: function() {
            var e = this || t,
                s = /iPhone|iPad|iPod|Android|BlackBerry|BB10|Silk|Mobi|Chrome|Safari/i.test(e._navigator && e._navigator.userAgent);
            if (!e._audioUnlocked && e.ctx && s) {
                e._audioUnlocked = !1, e.autoUnlock = !1, e._mobileUnloaded || 44100 === e.ctx.sampleRate || (e._mobileUnloaded = !0, e.unload()), e._scratchBuffer = e.ctx.createBuffer(1, 1, 22050);
                var n = function(t) {
                    for (var s = 0; s < e.html5PoolSize; s++) {
                        var r = new Audio;
                        r._unlocked = !0, e._releaseHtml5Audio(r)
                    }
                    for (s = 0; s < e._howls.length; s++)
                        if (!e._howls[s]._webAudio)
                            for (var i = e._howls[s]._getSoundIds(), o = 0; o < i.length; o++) {
                                var a = e._howls[s]._soundById(i[o]);
                                a && a._node && !a._node._unlocked && (a._node._unlocked = !0, a._node.load())
                            }
                    e._autoResume();
                    var u = e.ctx.createBufferSource();
                    u.buffer = e._scratchBuffer, u.connect(e.ctx.destination), void 0 === u.start ? u.noteOn(0) : u.start(0), "function" == typeof e.ctx.resume && e.ctx.resume(), u.onended = function() {
                        u.disconnect(0), e._audioUnlocked = !0, document.removeEventListener("touchstart", n, !0), document.removeEventListener("touchend", n, !0), document.removeEventListener("click", n, !0);
                        for (var t = 0; t < e._howls.length; t++) e._howls[t]._emit("unlock")
                    }
                };
                return document.addEventListener("touchstart", n, !0), document.addEventListener("touchend", n, !0), document.addEventListener("click", n, !0), e
            }
        },
        _obtainHtml5Audio: function() {
            var e = this || t;
            if (e._html5AudioPool.length) return e._html5AudioPool.pop();
            var s = (new Audio)
                .play();
            return s && "undefined" != typeof Promise && (s instanceof Promise || "function" == typeof s.then) && s.catch((function() {})), new Audio
        },
        _releaseHtml5Audio: function(e) {
            var s = this || t;
            return e._unlocked && s._html5AudioPool.push(e), s
        },
        _autoSuspend: function() {
            var e = this;
            if (e.autoSuspend && e.ctx && void 0 !== e.ctx.suspend && t.usingWebAudio) {
                for (var s = 0; s < e._howls.length; s++)
                    if (e._howls[s]._webAudio)
                        for (var n = 0; n < e._howls[s]._sounds.length; n++)
                            if (!e._howls[s]._sounds[n]._paused) return e;
                return e._suspendTimer && clearTimeout(e._suspendTimer), e._suspendTimer = setTimeout((function() {
                    e.autoSuspend && (e._suspendTimer = null, e.state = "suspending", e.ctx.suspend()
                        .then((function() {
                            e.state = "suspended", e._resumeAfterSuspend && (delete e._resumeAfterSuspend, e._autoResume())
                        })))
                }), 3e4), e
            }
        },
        _autoResume: function() {
            var e = this;
            if (e.ctx && void 0 !== e.ctx.resume && t.usingWebAudio) return "running" === e.state && e._suspendTimer ? (clearTimeout(e._suspendTimer), e._suspendTimer = null) : "suspended" === e.state ? (e.ctx.resume()
                .then((function() {
                    e.state = "running";
                    for (var t = 0; t < e._howls.length; t++) e._howls[t]._emit("resume")
                })), e._suspendTimer && (clearTimeout(e._suspendTimer), e._suspendTimer = null)) : "suspending" === e.state && (e._resumeAfterSuspend = !0), e
        }
    };
    var t = new e,
        s = function(e) {
            e.src && 0 !== e.src.length ? this.init(e) : console.error("An array of source files must be passed with any new Howl.")
        };
    s.prototype = {
        init: function(e) {
            var s = this;
            return t.ctx || S(), s._autoplay = e.autoplay || !1, s._format = "string" != typeof e.format ? e.format : [e.format], s._html5 = e.html5 || !1, s._muted = e.mute || !1, s._loop = e.loop || !1, s._pool = e.pool || 5, s._preload = "boolean" != typeof e.preload || e.preload, s._rate = e.rate || 1, s._sprite = e.sprite || {}, s._src = "string" != typeof e.src ? e.src : [e.src], s._volume = void 0 !== e.volume ? e.volume : 1, s._xhrWithCredentials = e.xhrWithCredentials || !1, s._duration = 0, s._state = "unloaded", s._sounds = [], s._endTimers = {}, s._queue = [], s._playLock = !1, s._onend = e.onend ? [{
                fn: e.onend
            }] : [], s._onfade = e.onfade ? [{
                fn: e.onfade
            }] : [], s._onload = e.onload ? [{
                fn: e.onload
            }] : [], s._onloaderror = e.onloaderror ? [{
                fn: e.onloaderror
            }] : [], s._onplayerror = e.onplayerror ? [{
                fn: e.onplayerror
            }] : [], s._onpause = e.onpause ? [{
                fn: e.onpause
            }] : [], s._onplay = e.onplay ? [{
                fn: e.onplay
            }] : [], s._onstop = e.onstop ? [{
                fn: e.onstop
            }] : [], s._onmute = e.onmute ? [{
                fn: e.onmute
            }] : [], s._onvolume = e.onvolume ? [{
                fn: e.onvolume
            }] : [], s._onrate = e.onrate ? [{
                fn: e.onrate
            }] : [], s._onseek = e.onseek ? [{
                fn: e.onseek
            }] : [], s._onunlock = e.onunlock ? [{
                fn: e.onunlock
            }] : [], s._onresume = [], s._webAudio = t.usingWebAudio && !s._html5, void 0 !== t.ctx && t.ctx && t.autoUnlock && t._unlockAudio(), t._howls.push(s), s._autoplay && s._queue.push({
                event: "play",
                action: function() {
                    s.play()
                }
            }), s._preload && s.load(), s
        },
        load: function() {
            var e = this,
                s = null;
            if (!t.noAudio) {
                "string" == typeof e._src && (e._src = [e._src]);
                for (var r = 0; r < e._src.length; r++) {
                    var o, a;
                    if (e._format && e._format[r]) o = e._format[r];
                    else {
                        if ("string" != typeof(a = e._src[r])) {
                            e._emit("loaderror", null, "Non-string found in selected audio sources - ignoring.");
                            continue
                        }(o = /^data:audio\/([^;,]+);/i.exec(a)) || (o = /\.([^.]+)$/.exec(a.split("?", 1)[0])), o && (o = o[1].toLowerCase())
                    }
                    if (o && t.codecs(o)) {
                        s = e._src[r];
                        break
                    }
                }
                return s ? (e._src = s, e._state = "loading", "https:" === window.location.protocol && "http:" === s.slice(0, 5) && (e._html5 = !0, e._webAudio = !1), new n(e), e._webAudio && i(e), e) : void e._emit("loaderror", null, "No codec support for selected audio sources.")
            }
            e._emit("loaderror", null, "No audio support.")
        },
        play: function(e, s) {
            var n = this,
                r = null;
            if ("number" == typeof e) r = e, e = null;
            else {
                if ("string" == typeof e && "loaded" === n._state && !n._sprite[e]) return null;
                if (void 0 === e && (e = "__default", !n._playLock)) {
                    for (var i = 0, o = 0; o < n._sounds.length; o++) n._sounds[o]._paused && !n._sounds[o]._ended && (i++, r = n._sounds[o]._id);
                    1 === i ? e = null : r = null
                }
            }
            var a = r ? n._soundById(r) : n._inactiveSound();
            if (!a) return null;
            if (r && !e && (e = a._sprite || "__default"), "loaded" !== n._state) {
                a._sprite = e, a._ended = !1;
                var u = a._id;
                return n._queue.push({
                    event: "play",
                    action: function() {
                        n.play(u)
                    }
                }), u
            }
            if (r && !a._paused) return s || n._loadQueue("play"), a._id;
            n._webAudio && t._autoResume();
            var S = Math.max(0, a._seek > 0 ? a._seek : n._sprite[e][0] / 1e3),
                l = Math.max(0, (n._sprite[e][0] + n._sprite[e][1]) / 1e3 - S),
                _ = 1e3 * l / Math.abs(a._rate),
                d = n._sprite[e][0] / 1e3,
                h = (n._sprite[e][0] + n._sprite[e][1]) / 1e3,
                c = !(!a._loop && !n._sprite[e][2]);
            a._sprite = e, a._ended = !1;
            var m = function() {
                a._paused = !1, a._seek = S, a._start = d, a._stop = h, a._loop = c
            };
            if (!(S >= h)) {
                var p = a._node;
                if (n._webAudio) {
                    var R = function() {
                        n._playLock = !1, m(), n._refreshBuffer(a);
                        var e = a._muted || n._muted ? 0 : a._volume;
                        p.gain.setValueAtTime(e, t.ctx.currentTime), a._playStart = t.ctx.currentTime, void 0 === p.bufferSource.start ? a._loop ? p.bufferSource.noteGrainOn(0, S, 86400) : p.bufferSource.noteGrainOn(0, S, l) : a._loop ? p.bufferSource.start(0, S, 86400) : p.bufferSource.start(0, S, l), _ !== 1 / 0 && (n._endTimers[a._id] = setTimeout(n._ended.bind(n, a), _)), s || setTimeout((function() {
                            n._emit("play", a._id), n._loadQueue()
                        }), 0)
                    };
                    "running" === t.state ? R() : (n._playLock = !0, n.once("resume", R), n._clearTimer(a._id))
                } else {
                    var f = function() {
                            p.currentTime = S, p.muted = a._muted || n._muted || t._muted || p.muted, p.volume = a._volume * t.volume(), p.playbackRate = a._rate;
                            try {
                                var r = p.play();
                                if (r && "undefined" != typeof Promise && (r instanceof Promise || "function" == typeof r.then) ? (n._playLock = !0, m(), r.then((function() {
                                        n._playLock = !1, p._unlocked = !0, s || (n._emit("play", a._id), n._loadQueue())
                                    }))
                                    .catch((function() {
                                        n._playLock = !1, n._emit("playerror", a._id, "Playback was unable to start. This is most commonly an issue on mobile devices and Chrome where playback was not within a user interaction."), a._ended = !0, a._paused = !0
                                    }))) : s || (n._playLock = !1, m(), n._emit("play", a._id), n._loadQueue()), p.playbackRate = a._rate, p.paused) return void n._emit("playerror", a._id, "Playback was unable to start. This is most commonly an issue on mobile devices and Chrome where playback was not within a user interaction.");
                                "__default" !== e || a._loop ? n._endTimers[a._id] = setTimeout(n._ended.bind(n, a), _) : (n._endTimers[a._id] = function() {
                                    n._ended(a), p.removeEventListener("ended", n._endTimers[a._id], !1)
                                }, p.addEventListener("ended", n._endTimers[a._id], !1))
                            } catch (e) {
                                n._emit("playerror", a._id, e)
                            }
                        },
                        g = window && window.ejecta || !p.readyState && t._navigator.isCocoonJS;
                    if (p.readyState >= 3 || g) f();
                    else {
                        n._playLock = !0;
                        var E = function() {
                            f(), p.removeEventListener(t._canPlayEvent, E, !1)
                        };
                        p.addEventListener(t._canPlayEvent, E, !1), n._clearTimer(a._id)
                    }
                }
                return a._id
            }
            n._ended(a)
        },
        pause: function(e) {
            var t = this;
            if ("loaded" !== t._state || t._playLock) return t._queue.push({
                event: "pause",
                action: function() {
                    t.pause(e)
                }
            }), t;
            for (var s = t._getSoundIds(e), n = 0; n < s.length; n++) {
                t._clearTimer(s[n]);
                var r = t._soundById(s[n]);
                if (r && !r._paused && (r._seek = t.seek(s[n]), r._rateSeek = 0, r._paused = !0, t._stopFade(s[n]), r._node))
                    if (t._webAudio) {
                        if (!r._node.bufferSource) continue;
                        void 0 === r._node.bufferSource.stop ? r._node.bufferSource.noteOff(0) : r._node.bufferSource.stop(0), t._cleanBuffer(r._node)
                    } else isNaN(r._node.duration) && r._node.duration !== 1 / 0 || r._node.pause();
                arguments[1] || t._emit("pause", r ? r._id : null)
            }
            return t
        },
        stop: function(e, t) {
            var s = this;
            if ("loaded" !== s._state || s._playLock) return s._queue.push({
                event: "stop",
                action: function() {
                    s.stop(e)
                }
            }), s;
            for (var n = s._getSoundIds(e), r = 0; r < n.length; r++) {
                s._clearTimer(n[r]);
                var i = s._soundById(n[r]);
                i && (i._seek = i._start || 0, i._rateSeek = 0, i._paused = !0, i._ended = !0, s._stopFade(n[r]), i._node && (s._webAudio ? i._node.bufferSource && (void 0 === i._node.bufferSource.stop ? i._node.bufferSource.noteOff(0) : i._node.bufferSource.stop(0), s._cleanBuffer(i._node)) : isNaN(i._node.duration) && i._node.duration !== 1 / 0 || (i._node.currentTime = i._start || 0, i._node.pause())), t || s._emit("stop", i._id))
            }
            return s
        },
        mute: function(e, s) {
            var n = this;
            if ("loaded" !== n._state || n._playLock) return n._queue.push({
                event: "mute",
                action: function() {
                    n.mute(e, s)
                }
            }), n;
            if (void 0 === s) {
                if ("boolean" != typeof e) return n._muted;
                n._muted = e
            }
            for (var r = n._getSoundIds(s), i = 0; i < r.length; i++) {
                var o = n._soundById(r[i]);
                o && (o._muted = e, o._interval && n._stopFade(o._id), n._webAudio && o._node ? o._node.gain.setValueAtTime(e ? 0 : o._volume, t.ctx.currentTime) : o._node && (o._node.muted = !!t._muted || e), n._emit("mute", o._id))
            }
            return n
        },
        volume: function() {
            var e, s, n, r = this,
                i = arguments;
            if (0 === i.length) return r._volume;
            if (1 === i.length || 2 === i.length && void 0 === i[1] ? r._getSoundIds()
                .indexOf(i[0]) >= 0 ? s = parseInt(i[0], 10) : e = parseFloat(i[0]) : i.length >= 2 && (e = parseFloat(i[0]), s = parseInt(i[1], 10)), !(void 0 !== e && e >= 0 && e <= 1)) return (n = s ? r._soundById(s) : r._sounds[0]) ? n._volume : 0;
            if ("loaded" !== r._state || r._playLock) return r._queue.push({
                event: "volume",
                action: function() {
                    r.volume.apply(r, i)
                }
            }), r;
            void 0 === s && (r._volume = e), s = r._getSoundIds(s);
            for (var o = 0; o < s.length; o++)(n = r._soundById(s[o])) && (n._volume = e, i[2] || r._stopFade(s[o]), r._webAudio && n._node && !n._muted ? n._node.gain.setValueAtTime(e, t.ctx.currentTime) : n._node && !n._muted && (n._node.volume = e * t.volume()), r._emit("volume", n._id));
            return r
        },
        fade: function(e, s, n, r) {
            var i = this;
            if ("loaded" !== i._state || i._playLock) return i._queue.push({
                event: "fade",
                action: function() {
                    i.fade(e, s, n, r)
                }
            }), i;
            e = parseFloat(e), s = parseFloat(s), n = parseFloat(n), i.volume(e, r);
            for (var o = i._getSoundIds(r), a = 0; a < o.length; a++) {
                var u = i._soundById(o[a]);
                if (u) {
                    if (r || i._stopFade(o[a]), i._webAudio && !u._muted) {
                        var S = t.ctx.currentTime,
                            l = S + n / 1e3;
                        u._volume = e, u._node.gain.setValueAtTime(e, S), u._node.gain.linearRampToValueAtTime(s, l)
                    }
                    i._startFadeInterval(u, e, s, n, o[a], void 0 === r)
                }
            }
            return i
        },
        _startFadeInterval: function(e, t, s, n, r, i) {
            var o = this,
                a = t,
                u = s - t,
                S = Math.abs(u / .01),
                l = Math.max(4, S > 0 ? n / S : n),
                _ = Date.now();
            e._fadeTo = s, e._interval = setInterval((function() {
                var r = (Date.now() - _) / n;
                _ = Date.now(), a += u * r, a = Math.max(0, a), a = Math.min(1, a), a = Math.round(100 * a) / 100, o._webAudio ? e._volume = a : o.volume(a, e._id, !0), i && (o._volume = a), (s < t && a <= s || s > t && a >= s) && (clearInterval(e._interval), e._interval = null, e._fadeTo = null, o.volume(s, e._id), o._emit("fade", e._id))
            }), l)
        },
        _stopFade: function(e) {
            var s = this,
                n = s._soundById(e);
            return n && n._interval && (s._webAudio && n._node.gain.cancelScheduledValues(t.ctx.currentTime), clearInterval(n._interval), n._interval = null, s.volume(n._fadeTo, e), n._fadeTo = null, s._emit("fade", e)), s
        },
        loop: function() {
            var e, t, s, n = this,
                r = arguments;
            if (0 === r.length) return n._loop;
            if (1 === r.length) {
                if ("boolean" != typeof r[0]) return !!(s = n._soundById(parseInt(r[0], 10))) && s._loop;
                e = r[0], n._loop = e
            } else 2 === r.length && (e = r[0], t = parseInt(r[1], 10));
            for (var i = n._getSoundIds(t), o = 0; o < i.length; o++)(s = n._soundById(i[o])) && (s._loop = e, n._webAudio && s._node && s._node.bufferSource && (s._node.bufferSource.loop = e, e && (s._node.bufferSource.loopStart = s._start || 0, s._node.bufferSource.loopEnd = s._stop)));
            return n
        },
        rate: function() {
            var e, s, n, r = this,
                i = arguments;
            if (0 === i.length) s = r._sounds[0]._id;
            else if (1 === i.length) {
                r._getSoundIds()
                    .indexOf(i[0]) >= 0 ? s = parseInt(i[0], 10) : e = parseFloat(i[0])
            } else 2 === i.length && (e = parseFloat(i[0]), s = parseInt(i[1], 10));
            if ("number" != typeof e) return (n = r._soundById(s)) ? n._rate : r._rate;
            if ("loaded" !== r._state || r._playLock) return r._queue.push({
                event: "rate",
                action: function() {
                    r.rate.apply(r, i)
                }
            }), r;
            void 0 === s && (r._rate = e), s = r._getSoundIds(s);
            for (var o = 0; o < s.length; o++)
                if (n = r._soundById(s[o])) {
                    r.playing(s[o]) && (n._rateSeek = r.seek(s[o]), n._playStart = r._webAudio ? t.ctx.currentTime : n._playStart), n._rate = e, r._webAudio && n._node && n._node.bufferSource ? n._node.bufferSource.playbackRate.setValueAtTime(e, t.ctx.currentTime) : n._node && (n._node.playbackRate = e);
                    var a = r.seek(s[o]),
                        u = 1e3 * ((r._sprite[n._sprite][0] + r._sprite[n._sprite][1]) / 1e3 - a) / Math.abs(n._rate);
                    !r._endTimers[s[o]] && n._paused || (r._clearTimer(s[o]), r._endTimers[s[o]] = setTimeout(r._ended.bind(r, n), u)), r._emit("rate", n._id)
                } return r
        },
        seek: function() {
            var e, s, n = this,
                r = arguments;
            if (0 === r.length) s = n._sounds[0]._id;
            else if (1 === r.length) {
                n._getSoundIds()
                    .indexOf(r[0]) >= 0 ? s = parseInt(r[0], 10) : n._sounds.length && (s = n._sounds[0]._id, e = parseFloat(r[0]))
            } else 2 === r.length && (e = parseFloat(r[0]), s = parseInt(r[1], 10));
            if (void 0 === s) return n;
            if ("loaded" !== n._state || n._playLock) return n._queue.push({
                event: "seek",
                action: function() {
                    n.seek.apply(n, r)
                }
            }), n;
            var i = n._soundById(s);
            if (i) {
                if (!("number" == typeof e && e >= 0)) {
                    if (n._webAudio) {
                        var o = n.playing(s) ? t.ctx.currentTime - i._playStart : 0,
                            a = i._rateSeek ? i._rateSeek - i._seek : 0;
                        return i._seek + (a + o * Math.abs(i._rate))
                    }
                    return i._node.currentTime
                }
                var u = n.playing(s);
                u && n.pause(s, !0), i._seek = e, i._ended = !1, n._clearTimer(s), n._webAudio || !i._node || isNaN(i._node.duration) || (i._node.currentTime = e);
                var S = function() {
                    n._emit("seek", s), u && n.play(s, !0)
                };
                if (u && !n._webAudio) {
                    var l = function() {
                        n._playLock ? setTimeout(l, 0) : S()
                    };
                    setTimeout(l, 0)
                } else S()
            }
            return n
        },
        playing: function(e) {
            var t = this;
            if ("number" == typeof e) {
                var s = t._soundById(e);
                return !!s && !s._paused
            }
            for (var n = 0; n < t._sounds.length; n++)
                if (!t._sounds[n]._paused) return !0;
            return !1
        },
        duration: function(e) {
            var t = this,
                s = t._duration,
                n = t._soundById(e);
            return n && (s = t._sprite[n._sprite][1] / 1e3), s
        },
        state: function() {
            return this._state
        },
        unload: function() {
            for (var e = this, s = e._sounds, n = 0; n < s.length; n++) s[n]._paused || e.stop(s[n]._id), e._webAudio || (/MSIE |Trident\//.test(t._navigator && t._navigator.userAgent) || (s[n]._node.src = "data:audio/wav;base64,UklGRigAAABXQVZFZm10IBIAAAABAAEARKwAAIhYAQACABAAAABkYXRhAgAAAAEA"), s[n]._node.removeEventListener("error", s[n]._errorFn, !1), s[n]._node.removeEventListener(t._canPlayEvent, s[n]._loadFn, !1), t._releaseHtml5Audio(s[n]._node)), delete s[n]._node, e._clearTimer(s[n]._id);
            var i = t._howls.indexOf(e);
            i >= 0 && t._howls.splice(i, 1);
            var o = !0;
            for (n = 0; n < t._howls.length; n++)
                if (t._howls[n]._src === e._src || e._src.indexOf(t._howls[n]._src) >= 0) {
                    o = !1;
                    break
                } return r && o && delete r[e._src], t.noAudio = !1, e._state = "unloaded", e._sounds = [], e = null, null
        },
        on: function(e, t, s, n) {
            var r = this["_on" + e];
            return "function" == typeof t && r.push(n ? {
                id: s,
                fn: t,
                once: n
            } : {
                id: s,
                fn: t
            }), this
        },
        off: function(e, t, s) {
            var n = this,
                r = n["_on" + e],
                i = 0;
            if ("number" == typeof t && (s = t, t = null), t || s)
                for (i = 0; i < r.length; i++) {
                    var o = s === r[i].id;
                    if (t === r[i].fn && o || !t && o) {
                        r.splice(i, 1);
                        break
                    }
                } else if (e) n["_on" + e] = [];
                else {
                    var a = Object.keys(n);
                    for (i = 0; i < a.length; i++) 0 === a[i].indexOf("_on") && Array.isArray(n[a[i]]) && (n[a[i]] = [])
                } return n
        },
        once: function(e, t, s) {
            return this.on(e, t, s, 1), this
        },
        _emit: function(e, t, s) {
            for (var n = this, r = n["_on" + e], i = r.length - 1; i >= 0; i--) r[i].id && r[i].id !== t && "load" !== e || (setTimeout(function(e) {
                e.call(this, t, s)
            }.bind(n, r[i].fn), 0), r[i].once && n.off(e, r[i].fn, r[i].id));
            return n._loadQueue(e), n
        },
        _loadQueue: function(e) {
            var t = this;
            if (t._queue.length > 0) {
                var s = t._queue[0];
                s.event === e && (t._queue.shift(), t._loadQueue()), e || s.action()
            }
            return t
        },
        _ended: function(e) {
            var s = this,
                n = e._sprite;
            if (!s._webAudio && e._node && !e._node.paused && !e._node.ended && e._node.currentTime < e._stop) return setTimeout(s._ended.bind(s, e), 100), s;
            var r = !(!e._loop && !s._sprite[n][2]);
            if (s._emit("end", e._id), !s._webAudio && r && s.stop(e._id, !0)
                .play(e._id), s._webAudio && r) {
                s._emit("play", e._id), e._seek = e._start || 0, e._rateSeek = 0, e._playStart = t.ctx.currentTime;
                var i = 1e3 * (e._stop - e._start) / Math.abs(e._rate);
                s._endTimers[e._id] = setTimeout(s._ended.bind(s, e), i)
            }
            return s._webAudio && !r && (e._paused = !0, e._ended = !0, e._seek = e._start || 0, e._rateSeek = 0, s._clearTimer(e._id), s._cleanBuffer(e._node), t._autoSuspend()), s._webAudio || r || s.stop(e._id, !0), s
        },
        _clearTimer: function(e) {
            var t = this;
            if (t._endTimers[e]) {
                if ("function" != typeof t._endTimers[e]) clearTimeout(t._endTimers[e]);
                else {
                    var s = t._soundById(e);
                    s && s._node && s._node.removeEventListener("ended", t._endTimers[e], !1)
                }
                delete t._endTimers[e]
            }
            return t
        },
        _soundById: function(e) {
            for (var t = this, s = 0; s < t._sounds.length; s++)
                if (e === t._sounds[s]._id) return t._sounds[s];
            return null
        },
        _inactiveSound: function() {
            var e = this;
            e._drain();
            for (var t = 0; t < e._sounds.length; t++)
                if (e._sounds[t]._ended) return e._sounds[t].reset();
            return new n(e)
        },
        _drain: function() {
            var e = this,
                t = e._pool,
                s = 0,
                n = 0;
            if (!(e._sounds.length < t)) {
                for (n = 0; n < e._sounds.length; n++) e._sounds[n]._ended && s++;
                for (n = e._sounds.length - 1; n >= 0; n--) {
                    if (s <= t) return;
                    e._sounds[n]._ended && (e._webAudio && e._sounds[n]._node && e._sounds[n]._node.disconnect(0), e._sounds.splice(n, 1), s--)
                }
            }
        },
        _getSoundIds: function(e) {
            if (void 0 === e) {
                for (var t = [], s = 0; s < this._sounds.length; s++) t.push(this._sounds[s]._id);
                return t
            }
            return [e]
        },
        _refreshBuffer: function(e) {
            return e._node.bufferSource = t.ctx.createBufferSource(), e._node.bufferSource.buffer = r[this._src], e._panner ? e._node.bufferSource.connect(e._panner) : e._node.bufferSource.connect(e._node), e._node.bufferSource.loop = e._loop, e._loop && (e._node.bufferSource.loopStart = e._start || 0, e._node.bufferSource.loopEnd = e._stop || 0), e._node.bufferSource.playbackRate.setValueAtTime(e._rate, t.ctx.currentTime), this
        },
        _cleanBuffer: function(e) {
            var s = t._navigator && t._navigator.vendor.indexOf("Apple") >= 0;
            if (t._scratchBuffer && e.bufferSource && (e.bufferSource.onended = null, e.bufferSource.disconnect(0), s)) try {
                e.bufferSource.buffer = t._scratchBuffer
            } catch (e) {}
            return e.bufferSource = null, this
        }
    };
    var n = function(e) {
        this._parent = e, this.init()
    };
    n.prototype = {
        init: function() {
            var e = this,
                s = e._parent;
            return e._muted = s._muted, e._loop = s._loop, e._volume = s._volume, e._rate = s._rate, e._seek = 0, e._paused = !0, e._ended = !0, e._sprite = "__default", e._id = ++t._counter, s._sounds.push(e), e.create(), e
        },
        create: function() {
            var e = this,
                s = e._parent,
                n = t._muted || e._muted || e._parent._muted ? 0 : e._volume;
            return s._webAudio ? (e._node = void 0 === t.ctx.createGain ? t.ctx.createGainNode() : t.ctx.createGain(), e._node.gain.setValueAtTime(n, t.ctx.currentTime), e._node.paused = !0, e._node.connect(t.masterGain)) : (e._node = t._obtainHtml5Audio(), e._errorFn = e._errorListener.bind(e), e._node.addEventListener("error", e._errorFn, !1), e._loadFn = e._loadListener.bind(e), e._node.addEventListener(t._canPlayEvent, e._loadFn, !1), e._node.src = s._src, e._node.preload = "auto", e._node.volume = n * t.volume(), e._node.load()), e
        },
        reset: function() {
            var e = this,
                s = e._parent;
            return e._muted = s._muted, e._loop = s._loop, e._volume = s._volume, e._rate = s._rate, e._seek = 0, e._rateSeek = 0, e._paused = !0, e._ended = !0, e._sprite = "__default", e._id = ++t._counter, e
        },
        _errorListener: function() {
            var e = this;
            e._parent._emit("loaderror", e._id, e._node.error ? e._node.error.code : 0), e._node.removeEventListener("error", e._errorFn, !1)
        },
        _loadListener: function() {
            var e = this,
                s = e._parent;
            s._duration = Math.ceil(10 * e._node.duration) / 10, 0 === Object.keys(s._sprite)
                .length && (s._sprite = {
                    __default: [0, 1e3 * s._duration]
                }), "loaded" !== s._state && (s._state = "loaded", s._emit("load"), s._loadQueue()), e._node.removeEventListener(t._canPlayEvent, e._loadFn, !1)
        }
    };
    var r = {},
        i = function(e) {
            var t = e._src;
            if (r[t]) return e._duration = r[t].duration, void u(e);
            if (/^data:[^;]+;base64,/.test(t)) {
                for (var s = atob(t.split(",")[1]), n = new Uint8Array(s.length), i = 0; i < s.length; ++i) n[i] = s.charCodeAt(i);
                a(n.buffer, e)
            } else {
                var S = new XMLHttpRequest;
                S.open("GET", t, !0), S.withCredentials = e._xhrWithCredentials, S.responseType = "arraybuffer", S.onload = function() {
                    var t = (S.status + "")[0];
                    "0" === t || "2" === t || "3" === t ? a(S.response, e) : e._emit("loaderror", null, "Failed loading audio file with status: " + S.status + ".")
                }, S.onerror = function() {
                    e._webAudio && (e._html5 = !0, e._webAudio = !1, e._sounds = [], delete r[t], e.load())
                }, o(S)
            }
        },
        o = function(e) {
            try {
                e.send()
            } catch (t) {
                e.onerror()
            }
        },
        a = function(e, s) {
            var n = function() {
                    s._emit("loaderror", null, "Decoding audio data failed.")
                },
                i = function(e) {
                    e && s._sounds.length > 0 ? (r[s._src] = e, u(s, e)) : n()
                };
            "undefined" != typeof Promise && 1 === t.ctx.decodeAudioData.length ? t.ctx.decodeAudioData(e)
                .then(i)
                .catch(n) : t.ctx.decodeAudioData(e, i, n)
        },
        u = function(e, t) {
            t && !e._duration && (e._duration = t.duration), 0 === Object.keys(e._sprite)
                .length && (e._sprite = {
                    __default: [0, 1e3 * e._duration]
                }), "loaded" !== e._state && (e._state = "loaded", e._emit("load"), e._loadQueue())
        },
        S = function() {
            if (t.usingWebAudio) {
                try {
                    "undefined" != typeof AudioContext ? t.ctx = new AudioContext : "undefined" != typeof webkitAudioContext ? t.ctx = new webkitAudioContext : t.usingWebAudio = !1
                } catch (e) {
                    t.usingWebAudio = !1
                }
                t.ctx || (t.usingWebAudio = !1);
                var e = /iP(hone|od|ad)/.test(t._navigator && t._navigator.platform),
                    s = t._navigator && t._navigator.appVersion.match(/OS (\d+)_(\d+)_?(\d+)?/),
                    n = s ? parseInt(s[1], 10) : null;
                if (e && n && n < 9) {
                    var r = /safari/.test(t._navigator && t._navigator.userAgent.toLowerCase());
                    (t._navigator && t._navigator.standalone && !r || t._navigator && !t._navigator.standalone && !r) && (t.usingWebAudio = !1)
                }
                t.usingWebAudio && (t.masterGain = void 0 === t.ctx.createGain ? t.ctx.createGainNode() : t.ctx.createGain(), t.masterGain.gain.setValueAtTime(t._muted ? 0 : 1, t.ctx.currentTime), t.masterGain.connect(t.ctx.destination)), t._setup()
            }
        };
    "function" == typeof define && define.amd && define([], (function() {
        return {
            Howler: t,
            Howl: s
        }
    })), "undefined" != typeof exports && (exports.Howler = t, exports.Howl = s), "undefined" != typeof window ? (window.HowlerGlobal = e, window.Howler = t, window.Howl = s, window.Sound = n) : "undefined" != typeof global && (global.HowlerGlobal = e, global.Howler = t, global.Howl = s, global.Sound = n)
}(),
function() {
    "use strict";
    HowlerGlobal.prototype._pos = [0, 0, 0], HowlerGlobal.prototype._orientation = [0, 0, -1, 0, 1, 0], HowlerGlobal.prototype.stereo = function(e) {
        var t = this;
        if (!t.ctx || !t.ctx.listener) return t;
        for (var s = t._howls.length - 1; s >= 0; s--) t._howls[s].stereo(e);
        return t
    }, HowlerGlobal.prototype.pos = function(e, t, s) {
        var n = this;
        return n.ctx && n.ctx.listener ? (t = "number" != typeof t ? n._pos[1] : t, s = "number" != typeof s ? n._pos[2] : s, "number" != typeof e ? n._pos : (n._pos = [e, t, s], void 0 !== n.ctx.listener.positionX ? (n.ctx.listener.positionX.setTargetAtTime(n._pos[0], Howler.ctx.currentTime, .1), n.ctx.listener.positionY.setTargetAtTime(n._pos[1], Howler.ctx.currentTime, .1), n.ctx.listener.positionZ.setTargetAtTime(n._pos[2], Howler.ctx.currentTime, .1)) : n.ctx.listener.setPosition(n._pos[0], n._pos[1], n._pos[2]), n)) : n
    }, HowlerGlobal.prototype.orientation = function(e, t, s, n, r, i) {
        var o = this;
        if (!o.ctx || !o.ctx.listener) return o;
        var a = o._orientation;
        return t = "number" != typeof t ? a[1] : t, s = "number" != typeof s ? a[2] : s, n = "number" != typeof n ? a[3] : n, r = "number" != typeof r ? a[4] : r, i = "number" != typeof i ? a[5] : i, "number" != typeof e ? a : (o._orientation = [e, t, s, n, r, i], void 0 !== o.ctx.listener.forwardX ? (o.ctx.listener.forwardX.setTargetAtTime(e, Howler.ctx.currentTime, .1), o.ctx.listener.forwardY.setTargetAtTime(t, Howler.ctx.currentTime, .1), o.ctx.listener.forwardZ.setTargetAtTime(s, Howler.ctx.currentTime, .1), o.ctx.listener.upX.setTargetAtTime(e, Howler.ctx.currentTime, .1), o.ctx.listener.upY.setTargetAtTime(t, Howler.ctx.currentTime, .1), o.ctx.listener.upZ.setTargetAtTime(s, Howler.ctx.currentTime, .1)) : o.ctx.listener.setOrientation(e, t, s, n, r, i), o)
    }, Howl.prototype.init = function(e) {
        return function(t) {
            var s = this;
            return s._orientation = t.orientation || [1, 0, 0], s._stereo = t.stereo || null, s._pos = t.pos || null, s._pannerAttr = {
                coneInnerAngle: void 0 !== t.coneInnerAngle ? t.coneInnerAngle : 360,
                coneOuterAngle: void 0 !== t.coneOuterAngle ? t.coneOuterAngle : 360,
                coneOuterGain: void 0 !== t.coneOuterGain ? t.coneOuterGain : 0,
                distanceModel: void 0 !== t.distanceModel ? t.distanceModel : "inverse",
                maxDistance: void 0 !== t.maxDistance ? t.maxDistance : 1e4,
                panningModel: void 0 !== t.panningModel ? t.panningModel : "HRTF",
                refDistance: void 0 !== t.refDistance ? t.refDistance : 1,
                rolloffFactor: void 0 !== t.rolloffFactor ? t.rolloffFactor : 1
            }, s._onstereo = t.onstereo ? [{
                fn: t.onstereo
            }] : [], s._onpos = t.onpos ? [{
                fn: t.onpos
            }] : [], s._onorientation = t.onorientation ? [{
                fn: t.onorientation
            }] : [], e.call(this, t)
        }
    }(Howl.prototype.init), Howl.prototype.stereo = function(t, s) {
        var n = this;
        if (!n._webAudio) return n;
        if ("loaded" !== n._state) return n._queue.push({
            event: "stereo",
            action: function() {
                n.stereo(t, s)
            }
        }), n;
        var r = void 0 === Howler.ctx.createStereoPanner ? "spatial" : "stereo";
        if (void 0 === s) {
            if ("number" != typeof t) return n._stereo;
            n._stereo = t, n._pos = [t, 0, 0]
        }
        for (var i = n._getSoundIds(s), o = 0; o < i.length; o++) {
            var a = n._soundById(i[o]);
            if (a) {
                if ("number" != typeof t) return a._stereo;
                a._stereo = t, a._pos = [t, 0, 0], a._node && (a._pannerAttr.panningModel = "equalpower", a._panner && a._panner.pan || e(a, r), "spatial" === r ? void 0 !== a._panner.positionX ? (a._panner.positionX.setValueAtTime(t, Howler.ctx.currentTime), a._panner.positionY.setValueAtTime(0, Howler.ctx.currentTime), a._panner.positionZ.setValueAtTime(0, Howler.ctx.currentTime)) : a._panner.setPosition(t, 0, 0) : a._panner.pan.setValueAtTime(t, Howler.ctx.currentTime)), n._emit("stereo", a._id)
            }
        }
        return n
    }, Howl.prototype.pos = function(t, s, n, r) {
        var i = this;
        if (!i._webAudio) return i;
        if ("loaded" !== i._state) return i._queue.push({
            event: "pos",
            action: function() {
                i.pos(t, s, n, r)
            }
        }), i;
        if (s = "number" != typeof s ? 0 : s, n = "number" != typeof n ? -.5 : n, void 0 === r) {
            if ("number" != typeof t) return i._pos;
            i._pos = [t, s, n]
        }
        for (var o = i._getSoundIds(r), a = 0; a < o.length; a++) {
            var u = i._soundById(o[a]);
            if (u) {
                if ("number" != typeof t) return u._pos;
                u._pos = [t, s, n], u._node && (u._panner && !u._panner.pan || e(u, "spatial"), void 0 !== u._panner.positionX ? (u._panner.positionX.setValueAtTime(t, Howler.ctx.currentTime), u._panner.positionY.setValueAtTime(s, Howler.ctx.currentTime), u._panner.positionZ.setValueAtTime(n, Howler.ctx.currentTime)) : u._panner.setPosition(t, s, n)), i._emit("pos", u._id)
            }
        }
        return i
    }, Howl.prototype.orientation = function(t, s, n, r) {
        var i = this;
        if (!i._webAudio) return i;
        if ("loaded" !== i._state) return i._queue.push({
            event: "orientation",
            action: function() {
                i.orientation(t, s, n, r)
            }
        }), i;
        if (s = "number" != typeof s ? i._orientation[1] : s, n = "number" != typeof n ? i._orientation[2] : n, void 0 === r) {
            if ("number" != typeof t) return i._orientation;
            i._orientation = [t, s, n]
        }
        for (var o = i._getSoundIds(r), a = 0; a < o.length; a++) {
            var u = i._soundById(o[a]);
            if (u) {
                if ("number" != typeof t) return u._orientation;
                u._orientation = [t, s, n], u._node && (u._panner || (u._pos || (u._pos = i._pos || [0, 0, -.5]), e(u, "spatial")), void 0 !== u._panner.orientationX ? (u._panner.orientationX.setValueAtTime(t, Howler.ctx.currentTime), u._panner.orientationY.setValueAtTime(s, Howler.ctx.currentTime), u._panner.orientationZ.setValueAtTime(n, Howler.ctx.currentTime)) : u._panner.setOrientation(t, s, n)), i._emit("orientation", u._id)
            }
        }
        return i
    }, Howl.prototype.pannerAttr = function() {
        var t, s, n, r = this,
            i = arguments;
        if (!r._webAudio) return r;
        if (0 === i.length) return r._pannerAttr;
        if (1 === i.length) {
            if ("object" != typeof i[0]) return (n = r._soundById(parseInt(i[0], 10))) ? n._pannerAttr : r._pannerAttr;
            t = i[0], void 0 === s && (t.pannerAttr || (t.pannerAttr = {
                coneInnerAngle: t.coneInnerAngle,
                coneOuterAngle: t.coneOuterAngle,
                coneOuterGain: t.coneOuterGain,
                distanceModel: t.distanceModel,
                maxDistance: t.maxDistance,
                refDistance: t.refDistance,
                rolloffFactor: t.rolloffFactor,
                panningModel: t.panningModel
            }), r._pannerAttr = {
                coneInnerAngle: void 0 !== t.pannerAttr.coneInnerAngle ? t.pannerAttr.coneInnerAngle : r._coneInnerAngle,
                coneOuterAngle: void 0 !== t.pannerAttr.coneOuterAngle ? t.pannerAttr.coneOuterAngle : r._coneOuterAngle,
                coneOuterGain: void 0 !== t.pannerAttr.coneOuterGain ? t.pannerAttr.coneOuterGain : r._coneOuterGain,
                distanceModel: void 0 !== t.pannerAttr.distanceModel ? t.pannerAttr.distanceModel : r._distanceModel,
                maxDistance: void 0 !== t.pannerAttr.maxDistance ? t.pannerAttr.maxDistance : r._maxDistance,
                refDistance: void 0 !== t.pannerAttr.refDistance ? t.pannerAttr.refDistance : r._refDistance,
                rolloffFactor: void 0 !== t.pannerAttr.rolloffFactor ? t.pannerAttr.rolloffFactor : r._rolloffFactor,
                panningModel: void 0 !== t.pannerAttr.panningModel ? t.pannerAttr.panningModel : r._panningModel
            })
        } else 2 === i.length && (t = i[0], s = parseInt(i[1], 10));
        for (var o = r._getSoundIds(s), a = 0; a < o.length; a++)
            if (n = r._soundById(o[a])) {
                var u = n._pannerAttr;
                u = {
                    coneInnerAngle: void 0 !== t.coneInnerAngle ? t.coneInnerAngle : u.coneInnerAngle,
                    coneOuterAngle: void 0 !== t.coneOuterAngle ? t.coneOuterAngle : u.coneOuterAngle,
                    coneOuterGain: void 0 !== t.coneOuterGain ? t.coneOuterGain : u.coneOuterGain,
                    distanceModel: void 0 !== t.distanceModel ? t.distanceModel : u.distanceModel,
                    maxDistance: void 0 !== t.maxDistance ? t.maxDistance : u.maxDistance,
                    refDistance: void 0 !== t.refDistance ? t.refDistance : u.refDistance,
                    rolloffFactor: void 0 !== t.rolloffFactor ? t.rolloffFactor : u.rolloffFactor,
                    panningModel: void 0 !== t.panningModel ? t.panningModel : u.panningModel
                };
                var S = n._panner;
                S ? (S.coneInnerAngle = u.coneInnerAngle, S.coneOuterAngle = u.coneOuterAngle, S.coneOuterGain = u.coneOuterGain, S.distanceModel = u.distanceModel, S.maxDistance = u.maxDistance, S.refDistance = u.refDistance, S.rolloffFactor = u.rolloffFactor, S.panningModel = u.panningModel) : (n._pos || (n._pos = r._pos || [0, 0, -.5]), e(n, "spatial"))
            } return r
    }, Sound.prototype.init = function(e) {
        return function() {
            var t = this,
                s = t._parent;
            t._orientation = s._orientation, t._stereo = s._stereo, t._pos = s._pos, t._pannerAttr = s._pannerAttr, e.call(this), t._stereo ? s.stereo(t._stereo) : t._pos && s.pos(t._pos[0], t._pos[1], t._pos[2], t._id)
        }
    }(Sound.prototype.init), Sound.prototype.reset = function(e) {
        return function() {
            var t = this,
                s = t._parent;
            return t._orientation = s._orientation, t._stereo = s._stereo, t._pos = s._pos, t._pannerAttr = s._pannerAttr, t._stereo ? s.stereo(t._stereo) : t._pos ? s.pos(t._pos[0], t._pos[1], t._pos[2], t._id) : t._panner && (t._panner.disconnect(0), t._panner = void 0, s._refreshBuffer(t)), e.call(this)
        }
    }(Sound.prototype.reset);
    var e = function(e, t) {
        "spatial" === (t = t || "spatial") ? (e._panner = Howler.ctx.createPanner(), e._panner.coneInnerAngle = e._pannerAttr.coneInnerAngle, e._panner.coneOuterAngle = e._pannerAttr.coneOuterAngle, e._panner.coneOuterGain = e._pannerAttr.coneOuterGain, e._panner.distanceModel = e._pannerAttr.distanceModel, e._panner.maxDistance = e._pannerAttr.maxDistance, e._panner.refDistance = e._pannerAttr.refDistance, e._panner.rolloffFactor = e._pannerAttr.rolloffFactor, e._panner.panningModel = e._pannerAttr.panningModel, void 0 !== e._panner.positionX ? (e._panner.positionX.setValueAtTime(e._pos[0], Howler.ctx.currentTime), e._panner.positionY.setValueAtTime(e._pos[1], Howler.ctx.currentTime), e._panner.positionZ.setValueAtTime(e._pos[2], Howler.ctx.currentTime)) : e._panner.setPosition(e._pos[0], e._pos[1], e._pos[2]), void 0 !== e._panner.orientationX ? (e._panner.orientationX.setValueAtTime(e._orientation[0], Howler.ctx.currentTime), e._panner.orientationY.setValueAtTime(e._orientation[1], Howler.ctx.currentTime), e._panner.orientationZ.setValueAtTime(e._orientation[2], Howler.ctx.currentTime)) : e._panner.setOrientation(e._orientation[0], e._orientation[1], e._orientation[2])) : (e._panner = Howler.ctx.createStereoPanner(), e._panner.pan.setValueAtTime(e._stereo, Howler.ctx.currentTime)), e._panner.connect(e._node), e._paused || e._parent.pause(e._id, !0)
            .play(e._id, !0)
    }
}(),
function(e) {
    var t;
    ! function() {
        function s(e) {
            this.mode = S.MODE_8BIT_BYTE, this.data = e, this.parsedData = [];
            for (var t = [], s = 0, n = this.data.length; n > s; s++) {
                var r = this.data.charCodeAt(s);
                r > 65536 ? (t[0] = 240 | (1835008 & r) >>> 18, t[1] = 128 | (258048 & r) >>> 12, t[2] = 128 | (4032 & r) >>> 6, t[3] = 128 | 63 & r) : r > 2048 ? (t[0] = 224 | (61440 & r) >>> 12, t[1] = 128 | (4032 & r) >>> 6, t[2] = 128 | 63 & r) : r > 128 ? (t[0] = 192 | (1984 & r) >>> 6, t[1] = 128 | 63 & r) : t[0] = r, this.parsedData = this.parsedData.concat(t)
            }
            this.parsedData.length != this.data.length && (this.parsedData.unshift(191), this.parsedData.unshift(187), this.parsedData.unshift(239))
        }

        function n(e, t) {
            this.typeNumber = e, this.errorCorrectLevel = t, this.modules = null, this.moduleCount = 0, this.dataCache = null, this.dataList = []
        }

        function r(e, t) {
            if (null == e.length) throw new Error(e.length + "/" + t);
            for (var s = 0; s < e.length && 0 == e[s];) s++;
            this.num = new Array(e.length - s + t);
            for (var n = 0; n < e.length - s; n++) this.num[n] = e[n + s]
        }

        function i(e, t) {
            this.totalCount = e, this.dataCount = t
        }

        function o() {
            this.buffer = [], this.length = 0
        }

        function a() {
            var e = !1,
                t = navigator.userAgent;
            return /android/i.test(t) && (e = !0, aMat = t.toString()
                .match(/android ([0-9]\.[0-9])/i), aMat && aMat[1] && (e = parseFloat(aMat[1]))), e
        }

        function u(e, t) {
            for (var s = 1, n = function(e) {
                var t = encodeURI(e)
                    .toString()
                    .replace(/\%[0-9a-fA-F]{2}/g, "a");
                return t.length + (t.length != e ? 3 : 0)
            }(e), r = 0, i = m.length; i >= r; r++) {
                var o = 0;
                switch (t) {
                    case l.L:
                        o = m[r][0];
                        break;
                    case l.M:
                        o = m[r][1];
                        break;
                    case l.Q:
                        o = m[r][2];
                        break;
                    case l.H:
                        o = m[r][3]
                }
                if (o >= n) break;
                s++
            }
            if (s > m.length) throw new Error("Too long data");
            return s
        }
        s.prototype = {
            getLength: function() {
                return this.parsedData.length
            },
            write: function(e) {
                for (var t = 0, s = this.parsedData.length; s > t; t++) e.put(this.parsedData[t], 8)
            }
        }, n.prototype = {
            addData: function(e) {
                var t = new s(e);
                this.dataList.push(t), this.dataCache = null
            },
            isDark: function(e, t) {
                if (0 > e || this.moduleCount <= e || 0 > t || this.moduleCount <= t) throw new Error(e + "," + t);
                return this.modules[e][t]
            },
            getModuleCount: function() {
                return this.moduleCount
            },
            make: function() {
                this.makeImpl(!1, this.getBestMaskPattern())
            },
            makeImpl: function(e, t) {
                this.moduleCount = 4 * this.typeNumber + 17, this.modules = new Array(this.moduleCount);
                for (var s = 0; s < this.moduleCount; s++) {
                    this.modules[s] = new Array(this.moduleCount);
                    for (var r = 0; r < this.moduleCount; r++) this.modules[s][r] = null
                }
                this.setupPositionProbePattern(0, 0), this.setupPositionProbePattern(this.moduleCount - 7, 0), this.setupPositionProbePattern(0, this.moduleCount - 7), this.setupPositionAdjustPattern(), this.setupTimingPattern(), this.setupTypeInfo(e, t), this.typeNumber >= 7 && this.setupTypeNumber(e), null == this.dataCache && (this.dataCache = n.createData(this.typeNumber, this.errorCorrectLevel, this.dataList)), this.mapData(this.dataCache, t)
            },
            setupPositionProbePattern: function(e, t) {
                for (var s = -1; 7 >= s; s++)
                    if (!(-1 >= e + s || this.moduleCount <= e + s))
                        for (var n = -1; 7 >= n; n++) - 1 >= t + n || this.moduleCount <= t + n || (this.modules[e + s][t + n] = s >= 0 && 6 >= s && (0 == n || 6 == n) || n >= 0 && 6 >= n && (0 == s || 6 == s) || s >= 2 && 4 >= s && n >= 2 && 4 >= n)
            },
            getBestMaskPattern: function() {
                for (var e = 0, t = 0, s = 0; 8 > s; s++) {
                    this.makeImpl(!0, s);
                    var n = d.getLostPoint(this);
                    (0 == s || e > n) && (e = n, t = s)
                }
                return t
            },
            createMovieClip: function(e, t, s) {
                var n = e.createEmptyMovieClip(t, s);
                this.make();
                for (var r = 0; r < this.modules.length; r++)
                    for (var i = 1 * r, o = 0; o < this.modules[r].length; o++) {
                        var a = 1 * o;
                        this.modules[r][o] && (n.beginFill(0, 100), n.moveTo(a, i), n.lineTo(a + 1, i), n.lineTo(a + 1, i + 1), n.lineTo(a, i + 1), n.endFill())
                    }
                return n
            },
            setupTimingPattern: function() {
                for (var e = 8; e < this.moduleCount - 8; e++) null == this.modules[e][6] && (this.modules[e][6] = 0 == e % 2);
                for (var t = 8; t < this.moduleCount - 8; t++) null == this.modules[6][t] && (this.modules[6][t] = 0 == t % 2)
            },
            setupPositionAdjustPattern: function() {
                for (var e = d.getPatternPosition(this.typeNumber), t = 0; t < e.length; t++)
                    for (var s = 0; s < e.length; s++) {
                        var n = e[t],
                            r = e[s];
                        if (null == this.modules[n][r])
                            for (var i = -2; 2 >= i; i++)
                                for (var o = -2; 2 >= o; o++) this.modules[n + i][r + o] = -2 == i || 2 == i || -2 == o || 2 == o || 0 == i && 0 == o
                    }
            },
            setupTypeNumber: function(e) {
                for (var t = d.getBCHTypeNumber(this.typeNumber), s = 0; 18 > s; s++) {
                    var n = !e && 1 == (1 & t >> s);
                    this.modules[Math.floor(s / 3)][s % 3 + this.moduleCount - 8 - 3] = n
                }
                for (s = 0; 18 > s; s++) {
                    n = !e && 1 == (1 & t >> s);
                    this.modules[s % 3 + this.moduleCount - 8 - 3][Math.floor(s / 3)] = n
                }
            },
            setupTypeInfo: function(e, t) {
                for (var s = this.errorCorrectLevel << 3 | t, n = d.getBCHTypeInfo(s), r = 0; 15 > r; r++) {
                    var i = !e && 1 == (1 & n >> r);
                    6 > r ? this.modules[r][8] = i : 8 > r ? this.modules[r + 1][8] = i : this.modules[this.moduleCount - 15 + r][8] = i
                }
                for (r = 0; 15 > r; r++) {
                    i = !e && 1 == (1 & n >> r);
                    8 > r ? this.modules[8][this.moduleCount - r - 1] = i : 9 > r ? this.modules[8][15 - r - 1 + 1] = i : this.modules[8][15 - r - 1] = i
                }
                this.modules[this.moduleCount - 8][8] = !e
            },
            mapData: function(e, t) {
                for (var s = -1, n = this.moduleCount - 1, r = 7, i = 0, o = this.moduleCount - 1; o > 0; o -= 2)
                    for (6 == o && o--;;) {
                        for (var a = 0; 2 > a; a++)
                            if (null == this.modules[n][o - a]) {
                                var u = !1;
                                i < e.length && (u = 1 == (1 & e[i] >>> r)), d.getMask(t, n, o - a) && (u = !u), this.modules[n][o - a] = u, -1 == --r && (i++, r = 7)
                            } if (0 > (n += s) || this.moduleCount <= n) {
                            n -= s, s = -s;
                            break
                        }
                    }
            }
        }, n.PAD0 = 236, n.PAD1 = 17, n.createData = function(e, t, s) {
            for (var r = i.getRSBlocks(e, t), a = new o, u = 0; u < s.length; u++) {
                var S = s[u];
                a.put(S.mode, 4), a.put(S.getLength(), d.getLengthInBits(S.mode, e)), S.write(a)
            }
            var l = 0;
            for (u = 0; u < r.length; u++) l += r[u].dataCount;
            if (a.getLengthInBits() > 8 * l) throw new Error("code length overflow. (" + a.getLengthInBits() + ">" + 8 * l + ")");
            for (a.getLengthInBits() + 4 <= 8 * l && a.put(0, 4); 0 != a.getLengthInBits() % 8;) a.putBit(!1);
            for (; !(a.getLengthInBits() >= 8 * l) && (a.put(n.PAD0, 8), !(a.getLengthInBits() >= 8 * l));) a.put(n.PAD1, 8);
            return n.createBytes(a, r)
        }, n.createBytes = function(e, t) {
            for (var s = 0, n = 0, i = 0, o = new Array(t.length), a = new Array(t.length), u = 0; u < t.length; u++) {
                var S = t[u].dataCount,
                    l = t[u].totalCount - S;
                n = Math.max(n, S), i = Math.max(i, l), o[u] = new Array(S);
                for (var _ = 0; _ < o[u].length; _++) o[u][_] = 255 & e.buffer[_ + s];
                s += S;
                var h = d.getErrorCorrectPolynomial(l),
                    c = new r(o[u], h.getLength() - 1)
                    .mod(h);
                a[u] = new Array(h.getLength() - 1);
                for (_ = 0; _ < a[u].length; _++) {
                    var m = _ + c.getLength() - a[u].length;
                    a[u][_] = m >= 0 ? c.get(m) : 0
                }
            }
            var p = 0;
            for (_ = 0; _ < t.length; _++) p += t[_].totalCount;
            var R = new Array(p),
                f = 0;
            for (_ = 0; n > _; _++)
                for (u = 0; u < t.length; u++) _ < o[u].length && (R[f++] = o[u][_]);
            for (_ = 0; i > _; _++)
                for (u = 0; u < t.length; u++) _ < a[u].length && (R[f++] = a[u][_]);
            return R
        };
        for (var S = {
            MODE_NUMBER: 1,
            MODE_ALPHA_NUM: 2,
            MODE_8BIT_BYTE: 4,
            MODE_KANJI: 8
        }, l = {
            L: 1,
            M: 0,
            Q: 3,
            H: 2
        }, _ = {
            PATTERN000: 0,
            PATTERN001: 1,
            PATTERN010: 2,
            PATTERN011: 3,
            PATTERN100: 4,
            PATTERN101: 5,
            PATTERN110: 6,
            PATTERN111: 7
        }, d = {
            PATTERN_POSITION_TABLE: [
                [],
                [6, 18],
                [6, 22],
                [6, 26],
                [6, 30],
                [6, 34],
                [6, 22, 38],
                [6, 24, 42],
                [6, 26, 46],
                [6, 28, 50],
                [6, 30, 54],
                [6, 32, 58],
                [6, 34, 62],
                [6, 26, 46, 66],
                [6, 26, 48, 70],
                [6, 26, 50, 74],
                [6, 30, 54, 78],
                [6, 30, 56, 82],
                [6, 30, 58, 86],
                [6, 34, 62, 90],
                [6, 28, 50, 72, 94],
                [6, 26, 50, 74, 98],
                [6, 30, 54, 78, 102],
                [6, 28, 54, 80, 106],
                [6, 32, 58, 84, 110],
                [6, 30, 58, 86, 114],
                [6, 34, 62, 90, 118],
                [6, 26, 50, 74, 98, 122],
                [6, 30, 54, 78, 102, 126],
                [6, 26, 52, 78, 104, 130],
                [6, 30, 56, 82, 108, 134],
                [6, 34, 60, 86, 112, 138],
                [6, 30, 58, 86, 114, 142],
                [6, 34, 62, 90, 118, 146],
                [6, 30, 54, 78, 102, 126, 150],
                [6, 24, 50, 76, 102, 128, 154],
                [6, 28, 54, 80, 106, 132, 158],
                [6, 32, 58, 84, 110, 136, 162],
                [6, 26, 54, 82, 110, 138, 166],
                [6, 30, 58, 86, 114, 142, 170]
            ],
            G15: 1335,
            G18: 7973,
            G15_MASK: 21522,
            getBCHTypeInfo: function(e) {
                for (var t = e << 10; d.getBCHDigit(t) - d.getBCHDigit(d.G15) >= 0;) t ^= d.G15 << d.getBCHDigit(t) - d.getBCHDigit(d.G15);
                return (e << 10 | t) ^ d.G15_MASK
            },
            getBCHTypeNumber: function(e) {
                for (var t = e << 12; d.getBCHDigit(t) - d.getBCHDigit(d.G18) >= 0;) t ^= d.G18 << d.getBCHDigit(t) - d.getBCHDigit(d.G18);
                return e << 12 | t
            },
            getBCHDigit: function(e) {
                for (var t = 0; 0 != e;) t++, e >>>= 1;
                return t
            },
            getPatternPosition: function(e) {
                return d.PATTERN_POSITION_TABLE[e - 1]
            },
            getMask: function(e, t, s) {
                switch (e) {
                    case _.PATTERN000:
                        return 0 == (t + s) % 2;
                    case _.PATTERN001:
                        return 0 == t % 2;
                    case _.PATTERN010:
                        return 0 == s % 3;
                    case _.PATTERN011:
                        return 0 == (t + s) % 3;
                    case _.PATTERN100:
                        return 0 == (Math.floor(t / 2) + Math.floor(s / 3)) % 2;
                    case _.PATTERN101:
                        return 0 == t * s % 2 + t * s % 3;
                    case _.PATTERN110:
                        return 0 == (t * s % 2 + t * s % 3) % 2;
                    case _.PATTERN111:
                        return 0 == (t * s % 3 + (t + s) % 2) % 2;
                    default:
                        throw new Error("bad maskPattern:" + e)
                }
            },
            getErrorCorrectPolynomial: function(e) {
                for (var t = new r([1], 0), s = 0; e > s; s++) t = t.multiply(new r([1, h.gexp(s)], 0));
                return t
            },
            getLengthInBits: function(e, t) {
                if (t >= 1 && 10 > t) switch (e) {
                    case S.MODE_NUMBER:
                        return 10;
                    case S.MODE_ALPHA_NUM:
                        return 9;
                    case S.MODE_8BIT_BYTE:
                    case S.MODE_KANJI:
                        return 8;
                    default:
                        throw new Error("mode:" + e)
                } else if (27 > t) switch (e) {
                    case S.MODE_NUMBER:
                        return 12;
                    case S.MODE_ALPHA_NUM:
                        return 11;
                    case S.MODE_8BIT_BYTE:
                        return 16;
                    case S.MODE_KANJI:
                        return 10;
                    default:
                        throw new Error("mode:" + e)
                } else {
                    if (!(41 > t)) throw new Error("type:" + t);
                    switch (e) {
                        case S.MODE_NUMBER:
                            return 14;
                        case S.MODE_ALPHA_NUM:
                            return 13;
                        case S.MODE_8BIT_BYTE:
                            return 16;
                        case S.MODE_KANJI:
                            return 12;
                        default:
                            throw new Error("mode:" + e)
                    }
                }
            },
            getLostPoint: function(e) {
                for (var t = e.getModuleCount(), s = 0, n = 0; t > n; n++)
                    for (var r = 0; t > r; r++) {
                        for (var i = 0, o = e.isDark(n, r), a = -1; 1 >= a; a++)
                            if (!(0 > n + a || n + a >= t))
                                for (var u = -1; 1 >= u; u++) 0 > r + u || r + u >= t || (0 != a || 0 != u) && o == e.isDark(n + a, r + u) && i++;
                        i > 5 && (s += 3 + i - 5)
                    }
                for (n = 0; t - 1 > n; n++)
                    for (r = 0; t - 1 > r; r++) {
                        var S = 0;
                        e.isDark(n, r) && S++, e.isDark(n + 1, r) && S++, e.isDark(n, r + 1) && S++, e.isDark(n + 1, r + 1) && S++, (0 == S || 4 == S) && (s += 3)
                    }
                for (n = 0; t > n; n++)
                    for (r = 0; t - 6 > r; r++) e.isDark(n, r) && !e.isDark(n, r + 1) && e.isDark(n, r + 2) && e.isDark(n, r + 3) && e.isDark(n, r + 4) && !e.isDark(n, r + 5) && e.isDark(n, r + 6) && (s += 40);
                for (r = 0; t > r; r++)
                    for (n = 0; t - 6 > n; n++) e.isDark(n, r) && !e.isDark(n + 1, r) && e.isDark(n + 2, r) && e.isDark(n + 3, r) && e.isDark(n + 4, r) && !e.isDark(n + 5, r) && e.isDark(n + 6, r) && (s += 40);
                var l = 0;
                for (r = 0; t > r; r++)
                    for (n = 0; t > n; n++) e.isDark(n, r) && l++;
                return s + 10 * (Math.abs(100 * l / t / t - 50) / 5)
            }
        }, h = {
            glog: function(e) {
                if (1 > e) throw new Error("glog(" + e + ")");
                return h.LOG_TABLE[e]
            },
            gexp: function(e) {
                for (; 0 > e;) e += 255;
                for (; e >= 256;) e -= 255;
                return h.EXP_TABLE[e]
            },
            EXP_TABLE: new Array(256),
            LOG_TABLE: new Array(256)
        }, c = 0; 8 > c; c++) h.EXP_TABLE[c] = 1 << c;
        for (c = 8; 256 > c; c++) h.EXP_TABLE[c] = h.EXP_TABLE[c - 4] ^ h.EXP_TABLE[c - 5] ^ h.EXP_TABLE[c - 6] ^ h.EXP_TABLE[c - 8];
        for (c = 0; 255 > c; c++) h.LOG_TABLE[h.EXP_TABLE[c]] = c;
        r.prototype = {
            get: function(e) {
                return this.num[e]
            },
            getLength: function() {
                return this.num.length
            },
            multiply: function(e) {
                for (var t = new Array(this.getLength() + e.getLength() - 1), s = 0; s < this.getLength(); s++)
                    for (var n = 0; n < e.getLength(); n++) t[s + n] ^= h.gexp(h.glog(this.get(s)) + h.glog(e.get(n)));
                return new r(t, 0)
            },
            mod: function(e) {
                if (this.getLength() - e.getLength() < 0) return this;
                for (var t = h.glog(this.get(0)) - h.glog(e.get(0)), s = new Array(this.getLength()), n = 0; n < this.getLength(); n++) s[n] = this.get(n);
                for (n = 0; n < e.getLength(); n++) s[n] ^= h.gexp(h.glog(e.get(n)) + t);
                return new r(s, 0)
                    .mod(e)
            }
        }, i.RS_BLOCK_TABLE = [
            [1, 26, 19],
            [1, 26, 16],
            [1, 26, 13],
            [1, 26, 9],
            [1, 44, 34],
            [1, 44, 28],
            [1, 44, 22],
            [1, 44, 16],
            [1, 70, 55],
            [1, 70, 44],
            [2, 35, 17],
            [2, 35, 13],
            [1, 100, 80],
            [2, 50, 32],
            [2, 50, 24],
            [4, 25, 9],
            [1, 134, 108],
            [2, 67, 43],
            [2, 33, 15, 2, 34, 16],
            [2, 33, 11, 2, 34, 12],
            [2, 86, 68],
            [4, 43, 27],
            [4, 43, 19],
            [4, 43, 15],
            [2, 98, 78],
            [4, 49, 31],
            [2, 32, 14, 4, 33, 15],
            [4, 39, 13, 1, 40, 14],
            [2, 121, 97],
            [2, 60, 38, 2, 61, 39],
            [4, 40, 18, 2, 41, 19],
            [4, 40, 14, 2, 41, 15],
            [2, 146, 116],
            [3, 58, 36, 2, 59, 37],
            [4, 36, 16, 4, 37, 17],
            [4, 36, 12, 4, 37, 13],
            [2, 86, 68, 2, 87, 69],
            [4, 69, 43, 1, 70, 44],
            [6, 43, 19, 2, 44, 20],
            [6, 43, 15, 2, 44, 16],
            [4, 101, 81],
            [1, 80, 50, 4, 81, 51],
            [4, 50, 22, 4, 51, 23],
            [3, 36, 12, 8, 37, 13],
            [2, 116, 92, 2, 117, 93],
            [6, 58, 36, 2, 59, 37],
            [4, 46, 20, 6, 47, 21],
            [7, 42, 14, 4, 43, 15],
            [4, 133, 107],
            [8, 59, 37, 1, 60, 38],
            [8, 44, 20, 4, 45, 21],
            [12, 33, 11, 4, 34, 12],
            [3, 145, 115, 1, 146, 116],
            [4, 64, 40, 5, 65, 41],
            [11, 36, 16, 5, 37, 17],
            [11, 36, 12, 5, 37, 13],
            [5, 109, 87, 1, 110, 88],
            [5, 65, 41, 5, 66, 42],
            [5, 54, 24, 7, 55, 25],
            [11, 36, 12],
            [5, 122, 98, 1, 123, 99],
            [7, 73, 45, 3, 74, 46],
            [15, 43, 19, 2, 44, 20],
            [3, 45, 15, 13, 46, 16],
            [1, 135, 107, 5, 136, 108],
            [10, 74, 46, 1, 75, 47],
            [1, 50, 22, 15, 51, 23],
            [2, 42, 14, 17, 43, 15],
            [5, 150, 120, 1, 151, 121],
            [9, 69, 43, 4, 70, 44],
            [17, 50, 22, 1, 51, 23],
            [2, 42, 14, 19, 43, 15],
            [3, 141, 113, 4, 142, 114],
            [3, 70, 44, 11, 71, 45],
            [17, 47, 21, 4, 48, 22],
            [9, 39, 13, 16, 40, 14],
            [3, 135, 107, 5, 136, 108],
            [3, 67, 41, 13, 68, 42],
            [15, 54, 24, 5, 55, 25],
            [15, 43, 15, 10, 44, 16],
            [4, 144, 116, 4, 145, 117],
            [17, 68, 42],
            [17, 50, 22, 6, 51, 23],
            [19, 46, 16, 6, 47, 17],
            [2, 139, 111, 7, 140, 112],
            [17, 74, 46],
            [7, 54, 24, 16, 55, 25],
            [34, 37, 13],
            [4, 151, 121, 5, 152, 122],
            [4, 75, 47, 14, 76, 48],
            [11, 54, 24, 14, 55, 25],
            [16, 45, 15, 14, 46, 16],
            [6, 147, 117, 4, 148, 118],
            [6, 73, 45, 14, 74, 46],
            [11, 54, 24, 16, 55, 25],
            [30, 46, 16, 2, 47, 17],
            [8, 132, 106, 4, 133, 107],
            [8, 75, 47, 13, 76, 48],
            [7, 54, 24, 22, 55, 25],
            [22, 45, 15, 13, 46, 16],
            [10, 142, 114, 2, 143, 115],
            [19, 74, 46, 4, 75, 47],
            [28, 50, 22, 6, 51, 23],
            [33, 46, 16, 4, 47, 17],
            [8, 152, 122, 4, 153, 123],
            [22, 73, 45, 3, 74, 46],
            [8, 53, 23, 26, 54, 24],
            [12, 45, 15, 28, 46, 16],
            [3, 147, 117, 10, 148, 118],
            [3, 73, 45, 23, 74, 46],
            [4, 54, 24, 31, 55, 25],
            [11, 45, 15, 31, 46, 16],
            [7, 146, 116, 7, 147, 117],
            [21, 73, 45, 7, 74, 46],
            [1, 53, 23, 37, 54, 24],
            [19, 45, 15, 26, 46, 16],
            [5, 145, 115, 10, 146, 116],
            [19, 75, 47, 10, 76, 48],
            [15, 54, 24, 25, 55, 25],
            [23, 45, 15, 25, 46, 16],
            [13, 145, 115, 3, 146, 116],
            [2, 74, 46, 29, 75, 47],
            [42, 54, 24, 1, 55, 25],
            [23, 45, 15, 28, 46, 16],
            [17, 145, 115],
            [10, 74, 46, 23, 75, 47],
            [10, 54, 24, 35, 55, 25],
            [19, 45, 15, 35, 46, 16],
            [17, 145, 115, 1, 146, 116],
            [14, 74, 46, 21, 75, 47],
            [29, 54, 24, 19, 55, 25],
            [11, 45, 15, 46, 46, 16],
            [13, 145, 115, 6, 146, 116],
            [14, 74, 46, 23, 75, 47],
            [44, 54, 24, 7, 55, 25],
            [59, 46, 16, 1, 47, 17],
            [12, 151, 121, 7, 152, 122],
            [12, 75, 47, 26, 76, 48],
            [39, 54, 24, 14, 55, 25],
            [22, 45, 15, 41, 46, 16],
            [6, 151, 121, 14, 152, 122],
            [6, 75, 47, 34, 76, 48],
            [46, 54, 24, 10, 55, 25],
            [2, 45, 15, 64, 46, 16],
            [17, 152, 122, 4, 153, 123],
            [29, 74, 46, 14, 75, 47],
            [49, 54, 24, 10, 55, 25],
            [24, 45, 15, 46, 46, 16],
            [4, 152, 122, 18, 153, 123],
            [13, 74, 46, 32, 75, 47],
            [48, 54, 24, 14, 55, 25],
            [42, 45, 15, 32, 46, 16],
            [20, 147, 117, 4, 148, 118],
            [40, 75, 47, 7, 76, 48],
            [43, 54, 24, 22, 55, 25],
            [10, 45, 15, 67, 46, 16],
            [19, 148, 118, 6, 149, 119],
            [18, 75, 47, 31, 76, 48],
            [34, 54, 24, 34, 55, 25],
            [20, 45, 15, 61, 46, 16]
        ], i.getRSBlocks = function(e, t) {
            var s = i.getRsBlockTable(e, t);
            if (null == s) throw new Error("bad rs block @ typeNumber:" + e + "/errorCorrectLevel:" + t);
            for (var n = s.length / 3, r = [], o = 0; n > o; o++)
                for (var a = s[3 * o + 0], u = s[3 * o + 1], S = s[3 * o + 2], l = 0; a > l; l++) r.push(new i(u, S));
            return r
        }, i.getRsBlockTable = function(e, t) {
            switch (t) {
                case l.L:
                    return i.RS_BLOCK_TABLE[4 * (e - 1) + 0];
                case l.M:
                    return i.RS_BLOCK_TABLE[4 * (e - 1) + 1];
                case l.Q:
                    return i.RS_BLOCK_TABLE[4 * (e - 1) + 2];
                case l.H:
                    return i.RS_BLOCK_TABLE[4 * (e - 1) + 3];
                default:
                    return
            }
        }, o.prototype = {
            get: function(e) {
                var t = Math.floor(e / 8);
                return 1 == (1 & this.buffer[t] >>> 7 - e % 8)
            },
            put: function(e, t) {
                for (var s = 0; t > s; s++) this.putBit(1 == (1 & e >>> t - s - 1))
            },
            getLengthInBits: function() {
                return this.length
            },
            putBit: function(e) {
                var t = Math.floor(this.length / 8);
                this.buffer.length <= t && this.buffer.push(0), e && (this.buffer[t] |= 128 >>> this.length % 8), this.length++
            }
        };
        var m = [
                [17, 14, 11, 7],
                [32, 26, 20, 14],
                [53, 42, 32, 24],
                [78, 62, 46, 34],
                [106, 84, 60, 44],
                [134, 106, 74, 58],
                [154, 122, 86, 64],
                [192, 152, 108, 84],
                [230, 180, 130, 98],
                [271, 213, 151, 119],
                [321, 251, 177, 137],
                [367, 287, 203, 155],
                [425, 331, 241, 177],
                [458, 362, 258, 194],
                [520, 412, 292, 220],
                [586, 450, 322, 250],
                [644, 504, 364, 280],
                [718, 560, 394, 310],
                [792, 624, 442, 338],
                [858, 666, 482, 382],
                [929, 711, 509, 403],
                [1003, 779, 565, 439],
                [1091, 857, 611, 461],
                [1171, 911, 661, 511],
                [1273, 997, 715, 535],
                [1367, 1059, 751, 593],
                [1465, 1125, 805, 625],
                [1528, 1190, 868, 658],
                [1628, 1264, 908, 698],
                [1732, 1370, 982, 742],
                [1840, 1452, 1030, 790],
                [1952, 1538, 1112, 842],
                [2068, 1628, 1168, 898],
                [2188, 1722, 1228, 958],
                [2303, 1809, 1283, 983],
                [2431, 1911, 1351, 1051],
                [2563, 1989, 1423, 1093],
                [2699, 2099, 1499, 1139],
                [2809, 2213, 1579, 1219],
                [2953, 2331, 1663, 1273]
            ],
            p = function() {
                var e = function(e, t) {
                    this._el = e, this._htOption = t
                };
                return e.prototype.draw = function(e) {
                    function t(e, t) {
                        var s = document.createElementNS("http://www.w3.org/2000/svg", e);
                        for (var n in t) t.hasOwnProperty(n) && s.setAttribute(n, t[n]);
                        return s
                    }
                    var s = this._htOption,
                        n = this._el,
                        r = e.getModuleCount();
                    Math.floor(s.width / r), Math.floor(s.height / r), this.clear();
                    var i = t("svg", {
                        viewBox: "0 0 " + String(r) + " " + String(r),
                        width: "100%",
                        height: "100%",
                        fill: s.colorLight
                    });
                    i.setAttributeNS("http://www.w3.org/2000/xmlns/", "xmlns:xlink", "http://www.w3.org/1999/xlink"), n.appendChild(i), i.appendChild(t("rect", {
                        fill: s.colorDark,
                        width: "1",
                        height: "1",
                        id: "template"
                    }));
                    for (var o = 0; r > o; o++)
                        for (var a = 0; r > a; a++)
                            if (e.isDark(o, a)) {
                                var u = t("use", {
                                    x: String(o),
                                    y: String(a)
                                });
                                u.setAttributeNS("http://www.w3.org/1999/xlink", "href", "#template"), i.appendChild(u)
                            }
                }, e.prototype.clear = function() {
                    for (; this._el.hasChildNodes();) this._el.removeChild(this._el.lastChild)
                }, e
            }(),
            R = "svg" === document.documentElement.tagName.toLowerCase() ? p : "undefined" != typeof CanvasRenderingContext2D ? function() {
                function t() {
                    this._elImage.src = this._elCanvas.toDataURL("image/png"), this._elImage.style.display = "block", this._elCanvas.style.display = "none"
                }

                function s(e, t) {
                    var s = this;
                    if (s._fFail = t, s._fSuccess = e, null === s._bSupportDataURI) {
                        var n = document.createElement("img"),
                            r = function() {
                                s._bSupportDataURI = !1, s._fFail && _fFail.call(s)
                            };
                        return n.onabort = r, n.onerror = r, n.onload = function() {
                            s._bSupportDataURI = !0, s._fSuccess && s._fSuccess.call(s)
                        }, void(n.src = "data:image/gif;base64,iVBORw0KGgoAAAANSUhEUgAAAAUAAAAFCAYAAACNbyblAAAAHElEQVQI12P4//8/w38GIAXDIBKE0DHxgljNBAAO9TXL0Y4OHwAAAABJRU5ErkJggg==")
                    }!0 === s._bSupportDataURI && s._fSuccess ? s._fSuccess.call(s) : !1 === s._bSupportDataURI && s._fFail && s._fFail.call(s)
                }
                if (this._android && this._android <= 2.1) {
                    var n = 1 / e.devicePixelRatio,
                        r = CanvasRenderingContext2D.prototype.drawImage;
                    CanvasRenderingContext2D.prototype.drawImage = function(e, t, s, i, o, a, u, S) {
                        if ("nodeName" in e && /img/i.test(e.nodeName))
                            for (var l = arguments.length - 1; l >= 1; l--) arguments[l] = arguments[l] * n;
                        else void 0 === S && (arguments[1] *= n, arguments[2] *= n, arguments[3] *= n, arguments[4] *= n);
                        r.apply(this, arguments)
                    }
                }
                var i = function(e, t) {
                    this._bIsPainted = !1, this._android = a(), this._htOption = t, this._elCanvas = document.createElement("canvas"), this._elCanvas.width = t.width, this._elCanvas.height = t.height, e.appendChild(this._elCanvas), this._el = e, this._oContext = this._elCanvas.getContext("2d"), this._bIsPainted = !1, this._elImage = document.createElement("img"), this._elImage.style.display = "none", this._el.appendChild(this._elImage), this._bSupportDataURI = null
                };
                return i.prototype.draw = function(e) {
                    var t = this._elImage,
                        s = this._oContext,
                        n = this._htOption,
                        r = e.getModuleCount(),
                        i = n.width / r,
                        o = n.height / r,
                        a = Math.round(i),
                        u = Math.round(o);
                    t.style.display = "none", this.clear();
                    for (var S = 0; r > S; S++)
                        for (var l = 0; r > l; l++) {
                            var _ = e.isDark(S, l),
                                d = l * i,
                                h = S * o;
                            s.strokeStyle = _ ? n.colorDark : n.colorLight, s.lineWidth = 1, s.fillStyle = _ ? n.colorDark : n.colorLight, s.fillRect(d, h, i, o), s.strokeRect(Math.floor(d) + .5, Math.floor(h) + .5, a, u), s.strokeRect(Math.ceil(d) - .5, Math.ceil(h) - .5, a, u)
                        }
                    this._bIsPainted = !0
                }, i.prototype.makeImage = function() {
                    this._bIsPainted && s.call(this, t)
                }, i.prototype.isPainted = function() {
                    return this._bIsPainted
                }, i.prototype.clear = function() {
                    this._oContext.clearRect(0, 0, this._elCanvas.width, this._elCanvas.height), this._bIsPainted = !1
                }, i.prototype.round = function(e) {
                    return e ? Math.floor(1e3 * e) / 1e3 : e
                }, i
            }() : function() {
                var e = function(e, t) {
                    this._el = e, this._htOption = t
                };
                return e.prototype.draw = function(e) {
                    for (var t = this._htOption, s = this._el, n = e.getModuleCount(), r = Math.floor(t.width / n), i = Math.floor(t.height / n), o = ['<table style="border:0;border-collapse:collapse;">'], a = 0; n > a; a++) {
                        o.push("<tr>");
                        for (var u = 0; n > u; u++) o.push('<td style="border:0;border-collapse:collapse;padding:0;margin:0;width:' + r + "px;height:" + i + "px;background-color:" + (e.isDark(a, u) ? t.colorDark : t.colorLight) + ';"></td>');
                        o.push("</tr>")
                    }
                    o.push("</table>"), s.innerHTML = o.join("");
                    var S = s.childNodes[0],
                        l = (t.width - S.offsetWidth) / 2,
                        _ = (t.height - S.offsetHeight) / 2;
                    l > 0 && _ > 0 && (S.style.margin = _ + "px " + l + "px")
                }, e.prototype.clear = function() {
                    this._el.innerHTML = ""
                }, e
            }();
        t = function(e, t) {
            if (this._htOption = {
                width: 256,
                height: 256,
                typeNumber: 4,
                colorDark: "#000000",
                colorLight: "#ffffff",
                correctLevel: l.H
            }, "string" == typeof t && (t = {
                text: t
            }), t)
                for (var s in t) this._htOption[s] = t[s];
            "string" == typeof e && (e = document.getElementById(e)), this._android = a(), this._el = e, this._oQRCode = null, this._oDrawing = new R(this._el, this._htOption), this._htOption.text && this.makeCode(this._htOption.text)
        }, t.prototype.makeCode = function(e) {
            this._oQRCode = new n(u(e, this._htOption.correctLevel), this._htOption.correctLevel), this._oQRCode.addData(e), this._oQRCode.make(), this._el.title = e, this._oDrawing.draw(this._oQRCode), this.makeImage()
        }, t.prototype.makeImage = function() {
            "function" == typeof this._oDrawing.makeImage && (!this._android || this._android >= 3) && this._oDrawing.makeImage()
        }, t.prototype.clear = function() {
            this._oDrawing.clear()
        }, t.CorrectLevel = l
    }(), "undefined" != typeof module && module.exports ? module.exports = t : e.QRCode = t
}(window),
function(e, t) {
    "object" == typeof exports && "undefined" != typeof module ? module.exports = t() : "function" == typeof define && define.amd ? define("RangeTouch", t) : (e = e || self)
        .RangeTouch = t()
}(this, (function() {
    "use strict";

    function e(e, t) {
        for (var s = 0; s < t.length; s++) {
            var n = t[s];
            n.enumerable = n.enumerable || !1, n.configurable = !0, "value" in n && (n.writable = !0), Object.defineProperty(e, n.key, n)
        }
    }

    function t(e, t, s) {
        return t in e ? Object.defineProperty(e, t, {
            value: s,
            enumerable: !0,
            configurable: !0,
            writable: !0
        }) : e[t] = s, e
    }

    function s(e, t) {
        var s = Object.keys(e);
        if (Object.getOwnPropertySymbols) {
            var n = Object.getOwnPropertySymbols(e);
            t && (n = n.filter((function(t) {
                return Object.getOwnPropertyDescriptor(e, t)
                    .enumerable
            }))), s.push.apply(s, n)
        }
        return s
    }

    function n(e) {
        for (var n = 1; n < arguments.length; n++) {
            var r = null != arguments[n] ? arguments[n] : {};
            n % 2 ? s(Object(r), !0)
                .forEach((function(s) {
                    t(e, s, r[s])
                })) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(r)) : s(Object(r))
                .forEach((function(t) {
                    Object.defineProperty(e, t, Object.getOwnPropertyDescriptor(r, t))
                }))
        }
        return e
    }
    var r = {
        addCSS: !0,
        thumbWidth: 15,
        watch: !0
    };
    var i = function(e) {
            return null != e ? e.constructor : null
        },
        o = function(e, t) {
            return !!(e && t && e instanceof t)
        },
        a = function(e) {
            return i(e) === String
        },
        u = function(e) {
            return Array.isArray(e)
        },
        S = function(e) {
            return o(e, NodeList)
        },
        l = a,
        _ = u,
        d = S,
        h = function(e) {
            return o(e, Element)
        },
        c = function(e) {
            return o(e, Event)
        },
        m = function(e) {
            return function(e) {
                    return null == e
                }(e) || (a(e) || u(e) || S(e)) && !e.length || function(e) {
                    return i(e) === Object
                }(e) && !Object.keys(e)
                .length
        };
    return function() {
        function t(e, s) {
            (function(e, t) {
                if (!(e instanceof t)) throw new TypeError("Cannot call a class as a function")
            })(this, t), h(e) ? this.element = e : l(e) && (this.element = document.querySelector(e)), h(this.element) && m(this.element.rangeTouch) && (this.config = n({}, r, {}, s), this.init())
        }
        return s = t, o = [{
            key: "setup",
            value: function(e) {
                var s = 1 < arguments.length && void 0 !== arguments[1] ? arguments[1] : {},
                    i = null;
                if (m(e) || l(e) ? i = Array.from(document.querySelectorAll(l(e) ? e : 'input[type="range"]')) : h(e) ? i = [e] : d(e) ? i = Array.from(e) : _(e) && (i = e.filter(h)), m(i)) return null;
                var o = n({}, r, {}, s);
                if (l(e) && o.watch) {
                    var a = new MutationObserver((function(s) {
                        Array.from(s)
                            .forEach((function(s) {
                                Array.from(s.addedNodes)
                                    .forEach((function(s) {
                                        h(s) && function(e, t) {
                                            return function() {
                                                return Array.from(document.querySelectorAll(t))
                                                    .includes(this)
                                            }.call(e, t)
                                        }(s, e) && new t(s, o)
                                    }))
                            }))
                    }));
                    a.observe(document.body, {
                        childList: !0,
                        subtree: !0
                    })
                }
                return i.map((function(e) {
                    return new t(e, s)
                }))
            }
        }, {
            key: "enabled",
            get: function() {
                return "ontouchstart" in document.documentElement
            }
        }], (i = [{
            key: "init",
            value: function() {
                t.enabled && (this.config.addCSS && (this.element.style.userSelect = "none", this.element.style.webKitUserSelect = "none", this.element.style.touchAction = "manipulation"), this.listeners(!0), this.element.rangeTouch = this)
            }
        }, {
            key: "destroy",
            value: function() {
                t.enabled && (this.config.addCSS && (this.element.style.userSelect = "", this.element.style.webKitUserSelect = "", this.element.style.touchAction = ""), this.listeners(!1), this.element.rangeTouch = null)
            }
        }, {
            key: "listeners",
            value: function(e) {
                var t = this,
                    s = e ? "addEventListener" : "removeEventListener";
                ["touchstart", "touchmove", "touchend"].forEach((function(e) {
                    t.element[s](e, (function(e) {
                        return t.set(e)
                    }), !1)
                }))
            }
        }, {
            key: "get",
            value: function(e) {
                if (!t.enabled || !c(e)) return null;
                var s, n = e.target,
                    r = e.changedTouches[0],
                    i = parseFloat(n.getAttribute("min")) || 0,
                    o = parseFloat(n.getAttribute("max")) || 100,
                    a = parseFloat(n.getAttribute("step")) || 1,
                    u = n.getBoundingClientRect(),
                    S = 100 / u.width * (this.config.thumbWidth / 2) / 100;
                return 0 > (s = 100 / u.width * (r.clientX - u.left)) ? s = 0 : 100 < s && (s = 100), 50 > s ? s -= (100 - 2 * s) * S : 50 < s && (s += 2 * (s - 50) * S), i + function(e, t) {
                    if (1 > t) {
                        var s = function(e) {
                            var t = "".concat(e)
                                .match(/(?:\.(\d+))?(?:[eE]([+-]?\d+))?$/);
                            return t ? Math.max(0, (t[1] ? t[1].length : 0) - (t[2] ? +t[2] : 0)) : 0
                        }(t);
                        return parseFloat(e.toFixed(s))
                    }
                    return Math.round(e / t) * t
                }(s / 100 * (o - i), a)
            }
        }, {
            key: "set",
            value: function(e) {
                t.enabled && c(e) && !e.target.disabled && (e.preventDefault(), e.target.value = this.get(e), function(e, t) {
                    if (e && t) {
                        var s = new Event(t, {
                            bubbles: !0
                        });
                        e.dispatchEvent(s)
                    }
                }(e.target, "touchend" === e.type ? "change" : "input"))
            }
        }]) && e(s.prototype, i), o && e(s, o), t;
        var s, i, o
    }()
})),
function(e) {
    var t = function() {
        function e(e) {
            return r.appendChild(e.dom), e
        }

        function s(e) {
            for (var t = 0; t < r.children.length; t++) r.children[t].style.display = t === e ? "block" : "none";
            n = e
        }
        var n = 0,
            r = document.createElement("div");
        r.style.cssText = "position:fixed;top:0;left:0;cursor:pointer;opacity:0.9;z-index:10000", r.addEventListener("click", (function(e) {
            e.preventDefault(), s(++n % r.children.length)
        }), !1);
        var i = (performance || Date)
            .now(),
            o = i,
            a = 0,
            u = e(new t.Panel("FPS", "#fff", "#002", "#0ff")),
            S = e(new t.Panel("MS", "#fff", "#020", "#0f0"));
        if (self.performance && self.performance.memory) var l = e(new t.Panel("MB", "#fff", "#201", "#f08"));
        return s(0), {
            REVISION: 16,
            dom: r,
            addPanel: e,
            showPanel: s,
            begin: function() {
                i = (performance || Date)
                    .now()
            },
            end: function() {
                a++;
                var e = (performance || Date)
                    .now();
                if (S.update(e - i, 200), e > o + 1e3 && (u.update(1e3 * a / (e - o), 100), o = e, a = 0, l)) {
                    var t = performance.memory;
                    l.update(t.usedJSHeapSize / 1048576, t.jsHeapSizeLimit / 1048576)
                }
                return e
            },
            update: function() {
                i = this.end()
            },
            domElement: r,
            setMode: s,
            destroy: function() {
                u && u.destroy(), u = null, S && S.destroy(), S = null, l && l.destroy(), l = null
            }
        }
    };
    t.Panel = function(t, s, n, r) {
        var i = 1 / 0,
            o = 0,
            a = Math.round,
            u = a(e.devicePixelRatio || 1),
            S = 100 * u,
            l = 50 * u,
            _ = 3 * u,
            d = 2 * u,
            h = 3 * u,
            c = 15 * u,
            m = 94 * u,
            p = 32 * u,
            R = document.createElement("canvas");
        R.width = S, R.height = l, R.style.cssText = "width:100px;height:50px";
        var f = R.getContext("2d");
        return f.font = "bold " + 12 * u + "px Helvetica,Arial,sans-serif", f.textBaseline = "top", f.fillStyle = n, f.fillRect(0, 0, S, l), f.fillStyle = s, f.fillText(t, _, d), f.fillRect(h, c, m, p), f.fillStyle = n, f.globalAlpha = .9, f.fillRect(h, c, m, p), {
            destroy: function() {
                f.clearRect(0, 0, S, l), R.remove(), f = null, R = null
            },
            dom: R,
            update: function(e, l) {
                i = Math.min(i, e), o = Math.max(o, e), f.fillStyle = n, f.globalAlpha = 1, f.fillRect(0, 0, S, c), f.fillStyle = s, f.fillText(a(e) + " " + t + " (" + a(i) + "-" + a(o) + ")", _, d), f.fillStyle = r, f.drawImage(R, h + u, c, m - u, p, h, c, m - u, p), f.fillRect(h + m - u, c, u, p), f.fillStyle = n, f.globalAlpha = .9, f.fillRect(h + m - u, c, u, a((1 - e / l) * p))
            }
        }
    }, "undefined" != typeof module && module.exports ? module.exports = t : e.Stats = t
}(window);
(function(_global) {
// console.log("-->load and run script: [externalLib]");
var ResourceManager = _global.Netbet.component.Resources.ResourceManager.getInstance();
var _sendObj = {};
_sendObj.filename = "externalLib";
_sendObj.zipname = "externalLib";
ResourceManager && ResourceManager.event.dispatch('resourceCompleteEvent', _sendObj);
})(window);